(****************************************************************************)
(* The following are UNIX system calls.  They generally return -1 if an error
   occurs.  Fuller descriptions of them are in the UNIX programmer's 
   manual. *)

function open(var name: inbuf; access: integer): integer; external;
(*  Opens a file with given nam.  If access is 0 the can read; if access is
    1 can write.  If access is 2 can read and write.  If open for writing,
    and file already exists, it destroys the current contents of the file.
    It returns an integer which is uses by other I/O functions to identify
    file. *)

function close(jobfilenumber: integer): integer; external;
(* Close a file.  jobfilenumber must be an integer that was returned by open
   or creat. *)

procedure perror(var message: inbuf); external;
(* It prints mess and then an error message describing the last error in 
   a system call.  Errors are not cleared by subsequent successful system
   calls so it should only be called when an error has just occurred. *)

procedure csignal; external;
(*  It initializes the C signal system. *)

procedure initrand(seed: integer); external;

function thisrand: real; external;

function gettime: double; external;

function system(var message: inbuf): integer; external;










