(*-----------#pc-version-----------------------------------------------------*)
(*
implementation
uses makemod,calctet,calctet1,up,mon,rsutil,util,sys;
*)
(*-----------#pc-version-----------------------------------------------------*)

(*-----------#unix-version-----------------------------------------------------*)
#include "syst.h"
#include "tt1.h"
#include "tt2.h"
#include "tt3.h"
#include "tt4.h"
#include "tt5.h"
#include "io.h"
#include "sys.h"
#include "util.h"
#include "mon.h"
#include "calctet.h"
#include "calctet1.h"
#include "eqs.h"
#include "up.h"
#include "rsutil.h"
#include "cross.h"
#include "makemod.h"
#include "gib.h"

(*-----------#unix-version-----------------------------------------------------*)
const unknownchar = '9';
type indexarray = array[1..8] of integer;
      patterninfo = record
    		     arrow1: boolean;
		     arrow2: boolean;
		     existence: integer;
                   end;
     patternarray = array[1..maxvertex,1..maxvertex] of patterninfo;
var params: text; pattern1,pattern2: patternarray;

function alphabetic(*c: char): boolean;*);
begin
   alphabetic := ((c >= 'A') and (c <= 'Z')) or ((c >= 'a') and (c <= 'z'));
end;  { function }

function alphanumeric(*c: char): boolean;*);
(* true if c is alphabetic or a digit. *)
begin
   alphanumeric := ((c >= 'A') and (c <= 'Z')) or ((c >= '0') and (c <= '9'))
		   or ((c >= 'a') and (c <= 'z'));
end;

function whitespace(*c: char): boolean;*);
(* true if c is tab or blank. *)
var tab: char;
begin
   tab := chr(9);
   whitespace := (c = ' ') or (c = tab);
end;


procedure readit(* var c: char *);
(* returns the next character to be parsed. *)
begin
   c := buf[curpos];
   curpos := curpos + 1;
end;

function myeoln (* : boolean; *);
(* true if and only if no more characters in input buffer. *)
begin
   if curpos > buflength then myeoln := true
      else myeoln := (buf[curpos] = chr(0)) or 
                     ((buf[curpos] = chr(10)) and (currentin = inp));
end;

function digit(c: char): boolean;
(* true if and only if c is a digit. *)
begin
   digit := (c >= '0') and (c <= '9');
end;

procedure checkend;
(* true if and only if the input line is over or consists only of 
   whitespace. *)

label 999;
var c: char;
begin
   while (not myeoln) and not (ignorepart in errors) do
      begin
	 readit(c);
	 if not whitespace(c) then
	       begin
		  myerror('Input line already complete.|            ',
			  ignorepart,true);
		  goto 999;
	       end;
	 999: 
      end;
end;

procedure readwhitespace;
var c: char;
begin
    c := ' ';
    while not myeoln and whitespace(c) do readit(c);
    if not whitespace(c) then if curpos <> 1 then curpos := curpos - 1;	
end;
	
function readnum(* infromtty: boolean; err: errortype): real; *);
(* parses a number from afile and returns the result.  infromtty is true if
   input is from the tty. *)

label 999;
var founddigit,isneg: boolean; numdigits: integer; c: char; 
    numdecimal,sofar: real;
begin
   founddigit := false;
   isneg := false;
   numdecimal := 0;
   numdigits := 0;
   sofar := 0;
   readwhitespace;
   c := ' ';
   if not myeoln then readit(c);
   if myeoln and (not digit(c)) then
	 begin
	    myerror('Digit required. |                        ',err,true);
	    goto 999;
	 end;
   if (c = '-') then isneg := true
   else if (c = '.') then numdecimal := 10
   else if (c = '+') then isneg := false
   else if digit(c) then
	 begin
	    sofar := (ord(c) - ord('0'));
	    founddigit := true;
	 end
      else
	 begin
	    myerror('Space, digit, or decimal point required. |',err,true);
	    goto 999;
	 end;
   while (not myeoln) and (not whitespace(c)) do 
      begin
	 readit(c);
	 if (c = '.') then
	       if (numdecimal = 0) then numdecimal := 10
	       else
		  begin
		     myerror('More than one decimal point in number. |   ',err,
		     	      true);
		     goto 999;
		  end
	 else if digit(c) then
              begin
	      	 numdigits := numdigits + 1;
		 if numdigits > 15 then 
		     begin      
		       myerror('Only 15 digits are significant. |          ',
		       		warning,true);
		       goto 999;
		     end;
	         if (numdecimal = 0) then
		   sofar := (sofar * 10) + (ord(c) - ord('0'))
	         else
	            begin
	              sofar := sofar + ((ord(c) - ord('0')) / numdecimal);
		      numdecimal := numdecimal * 10;
		    end;
		 founddigit := true;
	       end
         else if not whitespace(c) then
		  begin
		     if numdecimal = 0 then
   		        myerror('Space, digit, or decimal point required. |',
				   err,true)
   		     else
			 myerror('Whitespace or digit required.|           ',err,true);
		     goto 999;
		  end;
      end;
   if not founddigit then
	 myerror('Digit required. |                        ',err,true);
999: if isneg  then sofar := sofar * (-1);
   readnum := sofar;
end;

(* Added back in from tetnew7-6/1/89 -RS *)
procedure getnumbers(*var numset: numberset; maxnum: integer*);
var temp,i: integer; tempreal: real;
begin
   numset := [];
   readttyline(buf);
   i := 1;
   temp := 0;
   readwhitespace;
   while not myeoln do
       begin
	  i := i + 1;
	  tempreal := readnum(true,warning);
	  if (tempreal >= -32767) or (tempreal <= 32766) then
               temp := tround(tempreal)
	  else begin
		twrite(output,'Warning: the number |');
		tpwritereal(output,tempreal,8,2,false);
		twriteln(output,' out of range.|');
		end;
	  if (temp >= 1) and (temp <= maxnum) then
	  begin
	    if temp in numset then
	    begin
	     twrite(output,'Warning: the number |');
             twriteint(output,temp);
	     twriteln(output,' has been repeated.|');
	    end
	    else numset := numset + [temp]
	  end
	  else begin
		twrite(output,'Warning: the number |');
		twriteint(output,temp);
		twriteln(output,' out of range.|');
		end;
	  errors := [];
       end;  { while }
end;  { procedure }



function asknumber(mess: inbuf; default: real; isinteger: boolean): real;
begin
 if (currentin = inp) then
   begin
    putstr(mess,true);
    if isinteger then 
        if default = -1.0 then twrite(output,' [Unlimited]: |')
        else begin
		twrite(output,' [|'); 
		twriteint(output,tround(default));twrite(output,']: |')
	     end
    else if default = -1.0 then twrite(output,' [Unlimited]: |')
         else begin
		twrite(output,' [|');
		tpwritereal(output,default,8,4,false);
		twrite(output,']: |');
		end;
    repeat
        errors := [];
        readttyline(buf);
	if (not myeoln) then asknumber := readnum(true,ignoreall)
	else asknumber := default;
	if (ignoreall in errors) then 
	    if isinteger then
                if default = -1.0 then twrite(output,' [Unlimited]: |')
                else
   		begin
		twrite(output,'Re-enter number [|');
		twriteint(output,tround(default));
		twrite(output,']: |');
		end
            else 
                if default = -1.0 then twrite(output,' [Unlimited]: |')
                else
		begin
		twrite(output,'Re-enter number [|');
		tpwritereal(output,default,8,4,false);
		twrite(output,']: |');
		end;

    until not (ignoreall in errors);
    twriteeoln(output);
   end
 else 
    begin
      asknumber := readnum(false,ignoreall);
      if errors <> [] then asknumber := default;
    end;
end;  { procedure }

function uppercase(* c: char): char; *);
begin
    if c in ['a'..'z'] then uppercase := chr(ord(c) - ord('a') + ord('A'))
    else uppercase := c;
end;


procedure readedge(* var afile: text; var head,tail: vertexnametype;
		   var finished: boolean; infromtty: boolean *);
(* Parses an edge with input from afile.  Infromtty is true if an only if 
   input is from the tty.  The head of the edge is returned in head, and the
   tail in tail.  Finished is true when there is no more input in the file
   to be parsed.  Input should be arbitrary number of whitespaces followed by
   one or two alphanumerics followed by at least one whitespace followed by
   one or two alphanumerics. *)

var c: char; lastwaswhite: boolean; i: integer;

begin
   lastwaswhite := false;
   if infromtty then readttyline(buf);  
   (* if not from tty line has already been read in *)
   readwhitespace;
   if myeoln then finished := true;
   if not finished then 
       begin
	   if not myeoln and (not (ignoreall in errors)) then
	       begin
		   readname(head,ignoreall);
		   readwhitespace;
		   if not myeoln and (not (ignoreall in errors)) then
		         readname(tail,ignoreall);
		end;
	end;
end;

procedure readfileline(* var afile: text; var buf: inbuf *);
(* reads a line from afile into buf. *)
var k,i: integer; c: char;
begin
   for k:=1 to buflength do buf[k] := chr(0);
   k := 1;
   if not eof(afile) then
	 while not eoln(afile) and (k <= buflength) do
	    begin
	       read(afile,c);
	       buf[k] := c;
	       k := k + 1;
	    end;
   if not eof(afile) then readln(afile);
   curpos := 1;
   lineno := lineno + 1;
end;

function substr(first,second: commandstring): boolean;
var i: integer; match: boolean;
begin
    i := 1; match := true; 
    while (i <= commandlength) and match and not (whitespace(first[i])) do
	begin
	   if first[i] = second[i] then i := i + 1
	   else match := false;
	end;  { while }
      substr := match;
end;

procedure findindependent(* var adjacency: adjtype; var independent: vertexset *);
var i,j: integer; isindep: boolean;
begin
     independent := [];
     for i := 1 to max do
        begin
          isindep := true;
          j := 1;
          while (j <= max) and isindep do
             if adjacency^[j,i] <> notthere then isindep := false
             else j := j + 1;
          if isindep then independent := independent + [i];
       end;
end;

function istheoretical (* (vertex: vertexnametype): boolean;*);
(* Returns true if and only if vertex is theoretical, as signaled by
   beginning with a capital letter. *)
begin
     istheoretical := ((vertex[1] >= 'A') and (vertex[1] <= 'Z'));
end;

procedure calcnum(*var numob,numtheo,max: integer; localnames: namearray*);
var i: integer; stop: boolean;
begin
   numob := 0;
   numtheo := 0;
   i := 1;
   stop := false;
   while (i <= maxvertex) and (not stop) do
     if (localnames[i][1] <> ' ') then
      begin
        if istheoretical(localnames[i]) then numtheo := numtheo + 1
        else numob := numob + 1;
        i := i + 1;
      end
   else stop := true;
   max := numob + numtheo;
   origmax := max;
end;

function iscycle (*(var adjacency: adjtype): boolean; *);
label 999;
var j,k,i: integer; path: adjtype;

begin (* calcpath *)
    iscycle := false;
    tnewadj(path,fatal);
    if fatal in errors then goto 999;
    for i := 1 to numob do 
      for j := 1 to numob do
       if (i in graphvertices) and (j in graphvertices) then     
          if i <> j then path^[i,j] := adjacency^[i,j]
          else path^[i,i] := notthere;
    for k := 1 to numob do 
       for i := 1 to numob do 
           for j := 1 to numob do        
             if (i in graphvertices) and (j in graphvertices) and
                (k in graphvertices) then
               if (path^[i,k] <> notthere) and
                  (path^[k,j] <> notthere) then
                      path^[i,j] := 1;
    for i := 1 to numob do 
       if (i in graphvertices) and (path^[i,i] <> notthere) then
          begin
            iscycle := true;
            twriteln(output,'Warning: Graph is cyclic.|');
            goto 999;
          end;
999:dispose(path);
end; (* Calcdpath *)

procedure getgraph;
label 999;
var i,j: integer; changed: boolean; 
    localadj: adjtype; localnames1,localnames2: namearray;
    nodatavars,rearrange: array[vertextype] of vertextype; newvar: boolean; 
    nextob,nexttheo,index: integer; localparm: covarray; stop: boolean;
begin

(* initialize *)
     tnewadj(localadj,fatal);	(* check for enough space *)
     tnewcov(localparm,fatal);    (* check for enough space *)
     if fatal in errors then goto 999;
     for i := 1 to maxvertex do 
          begin
             nodatavars[i] := 0;
             rearrange[i] := i;
             localnames1[i] := blankname;
             for j := 1 to maxvertex do 
                 begin
                    localadj^[i,j] := notthere;
                    adjacency^[i,j] := notthere;
                 end;
           end;
     index := 1;
     readgraph(false,true,knowfile,adjacency,localnames1,true);

(* put theoreticals last *) 
     i := 1;
     nextob := 0;
     stop := false;
     while (localnames1[i] <> blankname) and (i <= maxvertex) 
            and (not stop) do
        begin
           if not istheoretical(localnames1[i]) then
              begin
                   nextob := nextob + 1;
                   rearrange[i] := nextob;
              end;
           if i < maxvertex then i := i + 1
           else stop := true;
        end;
     i := 1;
     nexttheo := nextob + 1;
     stop := false;
     while (localnames1[i] <> blankname) and (i <= maxvertex) 
           and (not stop) do
        begin
           if istheoretical(localnames1[i]) then 
              begin
                  rearrange[i] := nexttheo;
                  nexttheo := nexttheo + 1;
              end;
           if i < maxvertex then i := i + 1
           else stop := true;
        end;
     for i := 1 to maxvertex do
         begin
             localnames2[rearrange[i]] := localnames1[i];
             for j := 1 to maxvertex do
                begin
                  localadj^[rearrange[i],rearrange[j]] := adjacency^[i,j];
                  localparm^[rearrange[i],rearrange[j]] := parm^[i,j];
                end;
         end;

(* if no new variables, rearrange graph, else keep same graph *)
     for i := 1 to maxvertex do rearrange[i] := i;
     i := 1;
     newvar := false;
     stop := false;
     while (localnames2[i] <> blankname) and (i <= maxvertex) and 
           (not (istheoretical(localnames2[i]))) and (not newvar) and
           (not stop) do
       begin
         j := 1;
         while (j <= max) and (localnames2[i] <> vernames[j]) do j := j + 1;
         if localnames2[i] <> vernames[j] then 
             begin
                newvar := true;
                nodatavars[index] := i;
                index := index + 1;
             end
         else rearrange[i] := j;
         if i < maxvertex then i := i + 1
         else stop := true;
       end;

(* data file contains data matrix and then graph with different measured 
   variables, undoing data matrix just read in *)
     if newvar and justreaddata then
         begin
           i := 1;
           stop := false;
           while (nodatavars[i] <> 0) and (not stop) do
              begin
		  writevername(localnames2[nodatavars[i]],output);
		  twrite(output,' |');
                  myerror('not in covariance matrix.|', fatal,true);
                  if i < maxvertex then i := i + 1
                  else stop := true;
              end;
           goto 999;
         end

(* replace old set of variables with new set if measured variable not in
   data matrix *)
     else if newvar then
       begin
          initinput([graph],newvar);
          havereadgraph := true;
          i := 1;
          stop := false;
          while (localnames2[i] <> blankname) and (i <= maxvertex) 
                and (not stop) do
              begin
                 vernames[i] := localnames2[i];
                 if i < maxvertex then i := i + 1
                 else stop := true;
              end;
          for i := 1 to maxvertex do
             for j := 1 to maxvertex do 
                begin
                  adjacency^[i,j] := localadj^[i,j];
                  parm^[i,j] := localparm^[i,j];
                end;
        end

(* if no new measured variables, keep old measured 
   variables and covariance matrix, but get rid of extra theoreticals *)
     else
       begin
          initinput([graph,covariance,raw,independence,cellcounts],false);
          havereadgraph := true;
          j := 1;
          repeat
             if istheoretical(vernames[j]) then vernames[j] := blankname;
             if j < maxvertex then j := j + 1;
          until (j = maxvertex);
          i := nextob + 1;
          j := 1;
          while (not istheoretical(vernames[j])) and
                (vernames[j] <> blankname) do j := j + 1;
          while (localnames2[i] <> blankname) do
             begin
                vernames[j] := localnames2[i];
                rearrange[i] := j;
                i := i + 1;
                j := j + 1;
                if (i > maxvertex) or (j > maxvertex) then
                    begin
                      errormess('Too many variables: |  ',fatal,false);
                      writevername(localnames2[i],output);twriteeoln(output);
                      goto 999;
                    end;
              end;
           if not (fatal in errors) then
              begin
                 for j := i to maxvertex do rearrange[j] := 0;
                 for i := 1 to maxvertex do
                    for j := 1 to maxvertex do adjacency^[i,j] := notthere;
                 for i := 1 to maxvertex do
                    for j := 1 to maxvertex do
                        begin
                          if (rearrange[i] <> 0) and (rearrange[j] <> 0) then
                             begin
                               adjacency^[rearrange[i],rearrange[j]] := 
                                    localadj^[i,j];
                               parm^[rearrange[i],rearrange[j]] := 
                                    localparm^[i,j];
                             end;
                        end;
              end;
        end;
     graphvertices := [];
     for i:=1 to maxvertex do
       begin
         if istheoretical(vernames[i]) then theoretical[i] := true;
         if localnames1[i] <> blankname then
             begin
                j := 1;
                while (vernames[j] <> localnames1[i]) and (j <= maxvertex) do
                   j := j + 1;
                graphvertices := graphvertices + [j];
                for j := 1 to maxvertex do 
                   if adjacency^[i,j] = notthere then parm^[i,j] := 0;
             end;
         end;
     if aaabort then initinput([null],true);
     calcnum(numob,numtheo,max,vernames);
     findindependent(adjacency,independent);
     isacycle := iscycle(adjacency);
     dispose(localparm);
     dispose(localadj);
     gfilename := knowfilename;
999: end;		 


procedure getfile(* var fil: text; prompt: inbuf; filekind: filetype;
		  var filename: inbuf; var changed: boolean *);
begin
       getfilename(prompt,filename,changed);
       if filename <> nullfilename then
          if filekind = outputf then rewritefile(fil,filename)
          else resetfile(fil,filename,filekind);
end;

function matrixtype: boolean;
begin
   readfileline(knowfile,buf);
   readwhitespace;
   matrixtype := alphabetic(buf[curpos]);
end;  { function }

procedure readcomment(* var infile: text *);
var endcomment: boolean; c: char;
begin
  endcomment := false;
  while (not eof(infile)) and (not endcomment) do
      begin
        if myeoln then readfileline(infile,buf);
        readit(c);
        if c = '}' then endcomment := true;
      end;
  if not endcomment then myerror('End comment missing.|      ',ignoreall,true);
end;

procedure readheader(* var i: integer; fromindep: boolean *);
var leaveloop,wasinserted,firsttime: boolean; name: vertexnametype; k: vertextype; 
   begin
     leaveloop := false;
     firsttime := true;
     i := 0;
     while not eof(knowfile) and (not leaveloop) do 
      while (not leaveloop) do
       begin
         readwhitespace;
         if (not myeoln) then
          if alphabetic(buf[curpos]) then
           begin
             firsttime := false;
             readwhitespace;
             if (not myeoln) then

	       begin
                 readname(name,fatal);
                 if name[1] in ['A'..'Z'] then
   	           myerror('No theoreticals allowed in covariances.|  ',
                           fatal,true)
                 else i := i + 1;
                 k := listposition(name,true,vernames,wasinserted);
                 if (not wasinserted) and (not fromindep) then
                   myerror('Variable name appears twice in list.|',fatal,true)
                 else if (not wasinserted) then
                     begin
                       leaveloop := true;
                       curpos := 1;
                     end;
                 covvertices := covvertices + [k];
	       end;
           end
          else 
              begin
               leaveloop := true;
               if firsttime then errormess('List of variables required here. |',fatal,true);
              end
         else readfileline(knowfile,buf);
        end;
       calcnum(numob,numtheo,max,vernames);
       graphvertices := covvertices;
end;
   
procedure getcovariance(* var vernames: namearray; var rho,cov: covarray *);
label 999; 
var changed: boolean; var c: char; 
    i: integer;

   procedure readmatrix;
   label 999;
   var i,j : integer; covar: real; k: vertextype; numread: integer;
   begin
     numread := 0;
     readfileline(knowfile,buf);
     readheader(numob,false);
     if aaabort then goto 999;
      for i:=1 to numob do
       for j := 1 to i do
         begin
	  errors := [];
	  checkinterrupt;
          readwhitespace;
   	  if myeoln then 
             if eof(knowfile) then goto 999
             else readfileline(knowfile,buf);
   	  covar := readnum(false,fatal);
          if (fatal in errors) then goto 999;
   	  if not (ignoreall in errors) then
	      begin
                numread := numread + 1;
	      	rho^[i,j] := covar;
		rho^[j,i] := covar;
	      	cov^[i,j] := covar;
		cov^[j,i] := covar;
	      end;
   	 end;
         if not myeoln then readwhitespace;
         if not myeoln then myerror('Too many numbers in covariance matrix.|',warning,true);
999:     if numread  < ((numob * (numob - 1)) div 2) + numob then 
              myerror('Covariance matrix not complete.|',fatal,false);
         havereadcov := true;
end;

function checkunknown: boolean;   
var c: char;
begin
   checkunknown := false;
   readwhitespace;
   if myeoln then
	 myerror('Digit required. |                        ',fatal,true)
   else
        begin
            readit(c);
            if c = unknownchar then checkunknown := true
            else curpos := curpos - 1;
        end;
end;

procedure transformage(var num: integer);
begin
   if num <= 39 then num := 0
   else if num <= 54 then num := 1
   else if num <= 63 then num := 2
   else if num <= 68 then num := 3
   else if num <= 72 then num := 4
   else if num <= 75 then num := 5
   else if num <= 79 then num := 6
   else if num <= 83 then num := 7
   else if num <= 88 then num := 8
   else num := 9;
end;

(* procedure transformage(var num: integer);
begin
   if num <= 50 then num := 0
   else if num <= 70 then num := 1
   else if num <= 80 then num := 2
   else num := 3;
end;
*)

procedure readitraw;
label 999;
var i,j,catnum,num: integer; oldin: filetype;
	found,unknown:boolean;
begin
     if sampsize > maxsamp then
     begin
        oldin := currentin;
        currentin := inp;  (* so error message not display buffer *)
	myerror('Maximum sample size for raw data exceeded.|      ',fatal,true);
        currentin := oldin;
	goto 999;
     end;
     initdatamat(sampsize);
     for i := 1 to maxvertex do 
       begin
         catarray[i] := [];
         maxval[i] := 0;
       end;
     readfileline(knowfile,buf);
     readheader(numob,false);
     matnumob:=numob;  {sets the width for the big data array}
     if not aaabort then 
       for i:=1 to tround(sampsize) do
        for j := 1 to numob do
         begin
          readwhitespace;
   	  if myeoln then 
             if eof(knowfile) then
                begin
                  myerror('Not enough data.|      ',fatal,true);
                  goto 999;
                end
             else readfileline(knowfile,buf);
          unknown := checkunknown;
          if unknown then setbigdata(i,j,0)
          else
            begin
             num := tround(readnum(false,fatal));
             if (num < 0) or (num > maxvertex) then 
                   begin
                     errormess('Raw data must be between 0 and |',fatal,true);
                     twriteint(output,maxvertex);
                     twrite(output,' inclusive.|');
                     goto 999;
                   end;
             if num in catarray[j] then
                begin
		   found:=false;
 		   catnum:=1;
		   repeat
		        if varcatvalue[j,catnum]=num then found:=true
			else catnum:=catnum+1;
		   until found;
                 setbigdata(i,j,catnum);
               end
   	    else
	       if maxval[j] >= maxcategories then
		   begin
	        	errormess('Maximum number of categories in raw data is | ',fatal,true);
			twriteint(output,maxcategories);twriteeoln(output);
		   end
		else
		   begin
			varcatvalue[j,maxval[j]+1]:=num;
			setbigdata(i,j,maxval[j]+1);
			maxval[j]:=maxval[j]+1;
                        cats[j].num := maxval[j];
                        cats[j].value[maxval[j]] := num;
			catarray[j]:=catarray[j]+[num];
		   end;
               end;
	end;
      havereadraw := true;
999: end;

procedure getval(location: integer; var val: indexarray);
var indices: indexarray; i: integer;
begin
  indices[numob] := 1;
  for i := numob-1 downto 1 do indices[i] := indices[i+1] * maxval[i+1];
  for i := 1 to numob do
     begin
       val[i] := location div indices[i];
       location := location - val[i] * indices[i];
     end;
end;
     
procedure readcells;
label 999;
var i,j,k,cell,start,cellcount,num: integer; val: indexarray;
begin
     for i := 1 to max do catarray[i] := [];
     sampsize := 0;
     start := 1;
     readheader(numob,false);
     matnumob := numob;
     if aaabort then goto 999;
     for i := 1 to numob do
        begin
           num := tround(readnum(false,fatal));
           if (num > maxcategories) then
            begin
              myerror('Maximum allowable number of values is | ',fatal,true);
              twriteint(output,maxcategories);twriteeoln(output);
             end                 
           else begin
                maxval[i] := num;
                cats[i].num := num;
                catarray[i] := [0..num-1];
                for j := 1 to num do
                   begin
                      varcatvalue[i,j] := j - 1;
             	      cats[i].value[j] := varcatvalue[i,j];  
                   end;
                end;
           if aaabort then goto 999;
        end;
     readwhitespace;
     if not myeoln then
           myerror('Number of values already specified for all variables. |',ignorepart,true);
     cellcount := 1;
     for i := 1 to numob do cellcount := cellcount * maxval[i];
     i := 0;
     readfileline(knowfile,buf);
     if not aaabort then 
        while ((not eof(knowfile)) or (not myeoln)) and (i < cellcount) do
         begin
           i := i + 1;
           readwhitespace;
   	   if myeoln then 
             if eof(knowfile) then
                begin
                  myerror('Not enough data.|      ',fatal,true);
                  goto 999;
                end
             else readfileline(knowfile,buf);
            cell := tround(readnum(false,fatal));
            sampsize := sampsize + cell;
            initdatamat(sampsize);
            if sampsize > maxsamp then
               begin
                   myerror('Maximum sample size exceeded. |',fatal,false);
                   initdatamat(sampsize);
                   goto 999;
               end;
            getval(i-1,val);
            for j := start to start + cell - 1 do
              for k := 1 to numob do setbigdata(j,k,(val[k] + 1));
            start := start + cell;
         end;
   if i < cellcount then
       begin
         myerror('Not enough cells specified. |',fatal,false);
         goto 999;
       end;
   readwhitespace;
   if not myeoln then 
        myerror('Too many cells specified. |',ignorepart,true);
   havereadcells := true;
999: end;

procedure readindependence;
label 999;
var done,wasinserted,firsttime: boolean; tempindep: indepptr;
    temp: vertexnametype; position,j: vertextype;
begin
     readheader(numob,true);   
     if (fatal in errors) or eof(knowfile) then goto 999;
     done := false;
     firsttime := true;
     indep1 := nil;
     repeat
        if not firsttime then readfileline(knowfile,buf);
        firsttime := false;
        if (fatal in errors) then goto 999;
        tempindep := indep1;
        tnewindep(indep1,fatal);
        indep1^.fwd := tempindep;
        indep1^.cond := [];
        readwhitespace;
        if buf[1] = '/' then
           begin
              done := false;
              goto 999;
            end;
        j := 0;
        repeat
           readwhitespace;
           if not myeoln then         
              begin
                j := j + 1;
                readname(temp,fatal);
                if (fatal in errors) then goto 999;
                position := listposition(temp,false,vernames,wasinserted);
                if j = 1 then indep1^.tail := position
                else if j = 2 then indep1^.head := position
                else indep1^.cond := indep1^.cond + [position];
              end
           else if j = 1 then
              begin
                 myerror('Premature end of line.|',fatal,true);
                 goto 999;
              end;          
        until myeoln;
      until eof(knowfile) or done;
999:  if (fatal in errors) then disposeindeplist(indep1)
      else havereadindep := true;
end;
        
begin
  if not aaabort then
    begin
     readfileline(knowfile,buf);
     readwhitespace;
     readit(c);
     if c = '{' then 
        begin
          readcomment(knowfile);
          if myeoln then readfileline(knowfile,buf);
        end
     else curpos := curpos - 1;
     if (fatal in errors) then goto 999;
     if (not celldata) and (not indepdata) then
        begin
            sampsize := readnum(false,fatal);
            sampsize := tround(sampsize);
            if (fatal in errors) then
               begin
                  myerror('Sample size required here.|',fatal,true);
                  goto 999;
               end;
            if (sampsize <=4) and (not discrete) then
               myerror('Sample size must be greater than 4.|  ',fatal,true);
            checkend;
         end;
    end;
  if not aaabort then
          if (discrete and (not celldata)) then readitraw
          else if (discrete and celldata) then readcells
          else if indepdata then readindependence 
          else readmatrix;
  if (not discrete) and (not indepdata) and (not (fatal in errors)) then formcorrelations(rho);
  calcnum(numob,numtheo,max,vernames);
999: if aaabort then 
       begin
         knowfilename := nullfilename;
         initinput([null],true);
       end;
  trainlow := 1;
  trainhigh := round(sampsize);
(*  setupsamparray(samparray,testlow,testhigh,estlow,esthigh,trainlow,trainhigh); *)
  dfilename := knowfilename;
end;


function getnumber (* (lower,upper: real; isinteger: boolean; prompt: inbuf;
		   default: real): real; *);
var temp: real; err: errortype;
begin
     repeat
         errors := [];
         temp := asknumber(prompt,default,isinteger);
         if isinteger and ((temp <= -32767) or (temp >= 32766)) then
	    begin
              twrite(output,'warning: number |');
	      twriteint(output,tround(temp));
		twrite(output,' out of range.|'); twriteeoln(output);
	      errors := errors + [warning];
	    end
         else if temp < lower then
	    begin
	      errormess('Number less than lower bound of |       ',warning,
	      		 true);
	      if isinteger then begin twriteint(output,tround(lower)); 
				twriteeoln(output); end
	      else begin tpwritereal(output,lower,8,4,false); 
			twriteeoln(output); end;
	    end
         else if temp > upper then
	    begin
	      errormess('Number exceeds upper bound of |         ',warning,
	      		 true);
	      if isinteger then begin twriteint(output,tround(upper)); 
				twriteeoln(output); end
	      else begin tpwritereal(output,upper,8,4,false); 
			twriteeoln(output); end;
	    end
	 else getnumber := temp;
      until (errors = []) or (currentin = know);
      if errors <> [] then getnumber := default;
end;

function parsecommand(* (switch: boolean): commands; *);
var i,j: integer; c: char; found,alreadywarned: boolean;
begin
   found := false;
   command := blankcommand;
   errors := [];
   readwhitespace;
   i := 1;
   c := 'a'; 
   while (i <= commandlength) and (not myeoln) and (not whitespace(c)) do
     begin
       readit(c);
       if not whitespace(c) then command[i] := uppercase(c)
       else curpos := curpos - 1;
       i := i + 1;
     end;
   i := 1;
   if command[1] <> ' ' then
      begin
	   while (i <= numcommands) and (not found) do
	       if substr(command,commandarray[i].cstring) and
	          ((switch and (commandarray[i].cid in switchcommands)) or
		  ((not switch) and (commandarray[i].cid in commandcommands))) then
	          begin
       		     parsecommand := commandarray[i].cid;
		     found := true;
		  end
	       else i := i + 1;
	   if (i > numcommands) then
	      myerror('Unknown or inappropriate keyword.|        ',ignoreall,
	      	       true)
	   else if (i < numcommands) then
             begin
               alreadywarned := false;
               for j := i+1 to numcommands do
                  if substr(command,commandarray[j].cstring) and
                    ((switch and (commandarray[j].cid in switchcommands)) or
                    ((not switch) and (commandarray[j].cid in commandcommands))) then
                          begin
                            if not alreadywarned then
                               begin
              	                  myerror('Ambiguous command. Possible candidates:|',ignoreall,true);
                                   writecname(commandarray[i].cstring,output);
                                   twriteeoln(output);
                               end;
                            writecname(commandarray[j].cstring,output);
                            twriteeoln(output);
               		    parsecommand := null;
                            alreadywarned := true;
              	          end;
             end;
          if (not (ignoreall in errors)) then
            if (currentin = inp) and (not (commandarray[i].cid in ttycommands)) then
              begin
                  myerror('can only be called from file.|',ignoreall,true); 
                  parsecommand := null;
              end;
	  if ignoreall in errors then parsecommand := null;
      end
   else parsecommand := null; 	 			 
end;

procedure getswitches(* legal: commandset; var switchset: commandset
*); var id: commands; begin
   switchset := [];
   repeat
        readwhitespace;
	id := parsecommand(true);
	if not ((id = null) or (id in legal)) then myerror('Illegal switch.|                          ',ignorepart,true)
	else switchset := switchset + [id];
   until myeoln or (ignorepart in errors);
   if switchset = [] then switchset := [null];
end;


procedure mycov(*var rho: covarray; var tofile: text*);
var i,j,numwritten: integer;
begin
    numwritten := 1;
    for i := 1 to numob do
       begin
          if (numwritten mod 8) = 0 then twriteeoln(tofile);
          pwritename(i,tofile,9);
               numwritten := numwritten + 1;
       end;
    numwritten := 1;
    for i := 1 to numob do 
        for j := 1 to numob do
            begin
               if (numwritten mod 8 = 0) or (j = 1) then 
                    begin
                       twriteeoln(tofile);
                       numwritten := 1;
                    end;
               tpwritereal(tofile,rho^[i,j],10,decpoints,false);
               numwritten := numwritten + 1;
            end;
    twriteeoln(tofile);
    twriteeoln(tofile);
end;


procedure writecovmatrix(* var rho: covarray; var tofile: text *);
var i,j,numwritten: integer;
begin
    twrite(tofile,'  |');
    numwritten := 1;
    for i := 1 to numob do
       begin
          if (numwritten mod 8) = 0 then twriteln(tofile,'  |');
          pwritename(i,tofile,10);
               numwritten := numwritten + 1;
       end;
    numwritten := 1;
    for i := 1 to numob do 
        for j := 1 to i do
            begin
               if (numwritten mod 8 = 0) or (j = 1) then 
                    begin
                       twriteeoln(tofile);
                       numwritten := 1;
                    end;
               tpwritereal(tofile,rho^[i,j],10,decpoints,false);
               numwritten := numwritten + 1;
            end;
    twriteeoln(tofile);
    twriteeoln(tofile);
end;

procedure writetemptiers(* tofile: text *);
var i,j: vertextype; numwritten: integer;
begin
    for i := 1 to max do 
      if temptiers[i] <> [] then
       begin
         numwritten := 1;
         twrite(tofile,'Temporal Tier: |');
	twriteint(tofile,i); twriteeoln(tofile);
         for j := 1 to max do
             if (j in temptiers[i]) then
                 begin      
                    if numwritten mod 12 = 0 then twriteeoln(tofile);
			writename(j,tofile);twrite(tofile,' |');
                    numwritten := numwritten + 1;
                 end;
              twriteeoln(tofile);
        end;
     twriteeoln(tofile);
end;

procedure testcorr(var outfile: text);
var i,j: integer; z,prob: real;
    pvals: covarray;
begin
  writecovmatrix(rho,outfile);
  twriteeoln(outfile);
  tnewcov(pvals,fatal);    (* check for enough space *)
  for i := 1 to numob do pvals^[i,i]:= 0.0;
  for i := 1 to numob - 1 do
    for j := i + 1 to numob do
      begin
         z := (1/2) * (sqrt(sampsize - 3)) * ln((1 + abs(rho^[i,j])) / 
              (1 - abs(rho^[i,j])));
         getprob(pvals^[j,i],abs(z));
      end;
  twriteln(outfile,'P-value for Correlations|');
  writecovmatrix(pvals,outfile);
  twriteeoln(outfile);
end; 

procedure writesearchparams(* var tofile: text; totty: boolean; id: commands *);
var i,j,numwritten: integer; written: vertexset; someforbidden: boolean;
begin
    twrite(tofile,'Parameters: |');
    twriteeoln(tofile);     twriteeoln(tofile); 
    if (havereadcov or havereadcells or havereadraw or havereadindep) then 
      begin
        twrite(tofile, '  Sample Size: |');
        twriteint(tofile,tround(sampsize));
        twriteeoln(tofile);        
        if havereadcov then
          begin
            twriteln(tofile,'  Continuous Data|');
            twriteeoln(tofile);
            twrite(tofile,'Covariance Matrix |');
            twriteeoln(tofile);
            writecovmatrix(cov,tofile);
            twriteeoln(tofile);
            twrite(tofile,'Correlation Matrix |');
            twriteeoln(tofile);
            testcorr(tofile);
          end;
        if (havereadcells or havereadraw) then
           twriteln(tofile,'Discrete Data|'); 
        if havereadindep then twriteln(tofile,'  Independence Data|'); 
      end;
    if id in [finalsets,prttr,scales,purify,partial,status,regress] then    
	begin
	twrite(tofile,'  Significance:     |');
	tpwritereal(tofile,signif,6,4,false);
	twriteeoln(tofile);
	end;
    if id in [finalsets,prttr,scales,purify,status] then
	begin
	twrite(tofile,'  Weight:           |');
	tpwritereal(tofile,weight,6,4,false);
	twriteeoln(tofile);
	end;
    if id in [finalsets,prttr,status] then
        begin
           twrite(tofile,'  Width:            |');
	   tpwritereal(tofile,percent,6,4,false); twriteeoln(tofile);
           if depth = -1 then 
	           twriteln(tofile,'  Depth:            Unbounded|')
           else  
		begin
		twrite(tofile,'  Depth:            |');
		twriteint(tofile,depth);
		end;
	   twriteeoln(tofile);
           twrite(tofile,'  Acyclic:          |');twritetf(tofile,acyclic);
	   twriteeoln(tofile);
           twrite(tofile,'  LM:               |');twritetf(tofile,lm);
	   twriteeoln(tofile);
           twrite(tofile,'  MM:               |');twritetf(tofile,mm);
	   twriteeoln(tofile);
           twrite(tofile,'  ML:               |');twritetf(tofile,ml);
	   twriteeoln(tofile);
           twrite(tofile,'  LL:               |');twritetf(tofile,ll);
	   twriteeoln(tofile);
           twrite(tofile,'  Singleconnection: |');twritetf(tofile,singleconn);
	   twriteeoln(tofile);
           twrite(tofile,'  Common:           |');twritetf(tofile,comm);
	   twriteeoln(tofile);
        end;
    if id in [finalsets,prttr,status,partial] then
         if maxtime > 0 then begin
           twrite(tofile,'  Settime:          |');
	   tpwritereal(tofile, maxtime/60,8,4,false);
	   twrite(tofile,' minutes.|');
	   twriteeoln(tofile); end
         else begin
           twrite(tofile,'  Settime:          Unbounded |'); twriteeoln(tofile); end;
    twriteeoln(tofile);
    if id in [partial,finalsets,prttr,status] then
        begin
            someforbidden := false;
            for i := 1 to max do 
                for j := 1 to max do
                   if forbiddenadj^[i,j] <> notthere then someforbidden := true;
            if someforbidden then
                begin
                    twrite(tofile,'Forbidden edges: |');
		    twriteeoln(tofile);
                    writegraph(forbiddenadj,tofile,false,false);
		    twriteeoln(tofile);
                end;
             someforbidden := false;
             for i := 1 to max do 
                for j := 1 to max do
                   if commonfor^[i,j] <> notthere then someforbidden := true;
             if someforbidden then
                  begin
                    twrite(tofile,'Forbidden Common Causes: |');
		    twriteeoln(tofile);
                     writegraph(commonfor,tofile,true,false);
		    twriteeoln(tofile);
                  end;
              writetemptiers(tofile);
        end;
    if (not totty) and (not (id in [purify]))
      then twriteln(tofile,'}|');
end;

procedure twritefilemess(*var tofile: text; mess,filename: inbuf;
                         totty: boolean*);
begin
    if (filename <> blankfilename) then
      begin
        twrite(tofile,mess);
        putstr(filename,totty);
        twriteeoln(tofile);
      end;
end;

procedure givestatus(* var tofile: text; totty: boolean; id: commands *);
var i,j: integer;
begin
    if totty then 
      begin
        pageon := true;
        outline := 1;
      end;
    twritefilemess(tofile,'Output file: |',ofilename,totty);
    twritefilemess(tofile,'Graph file: |',gfilename,totty);
    twritefilemess(tofile,'Data file: |',dfilename,totty);
    twritefilemess(tofile,'Temporal Tier file: |',tfilename,totty);
    twritefilemess(tofile,'Forbidden Edges file: |',ffilename,totty);
    twritefilemess(tofile,'Forbidden Common Causes file: |',fcfilename,totty);
    if (id <> partial) then
        begin
            twrite(tofile,'Graph:  |');
            if max > 0 then writegraph(adjacency,tofile,false,true);
        end;
    twriteeoln(tofile);
    if havereadlinearmodel then writelinearmodel2(varorder,tofile,adjacency,parm)
    else if havereadbayes then
     begin
      if varorder = nil then 
        begin
           new(varorder);
           formeqsorder(varorder,adjacency);
        end;
      writediscretemodel(cats,varorder,adjacency,tofile,false);
     end;
    printev(tofile);
    writesearchparams(tofile,totty,id);
    pageon := false;
end;  { procedure }

procedure outputheading;
begin
   twriteeoln(ofilvar);
   twriteln(ofilvar,'{|'); 
   twriteln(ofilvar,'        TETRAD II - Version 1.2 for DOS|');
   twriteln(ofilvar,'                       by|');
   twriteln(ofilvar,'        Peter Spirtes, Richard Scheines, |');
   twriteln(ofilvar,'       Christopher Meek, and Clark Glymour|');
   twriteeoln(ofilvar);
   twriteln(ofilvar,' Copyright (C) 1994 by Lawrence Erlbaum Associates|');
   twriteeoln(ofilvar);
end;

procedure formcorrelations(* var localrho: covarray *);
var i,j,templine:  integer; convert: boolean; 
begin
  templine := lineno;
  lineno := 0; (* so error message not print out line number *)
  convert := false;
  for i := 1 to numob do
     for j := 1 to numob do 
        begin
           if i <> j then 
             begin
               if (cov^[i,j] < -1) or (cov^[i,j] > 1) then
                  convert := true;
             end
           else if cov^[i,i] <> 1 then convert := true;
           localrho^[i,j] := 0;
        end;
  if convert then
    begin
      twriteln(output,'Converting covariance matrix to correlation matrix.|');
      for i:= 1 to numob do
        if (cov^[i,i] < 0) then
           begin
              errormess('Variance less than 0       |',fatal,false);
              twrite(output,': |');
	      writename(i,output); twriteeoln(output);
           end;
      if not aaabort then
        for i:= 1 to numob do
	   for j:= i+1 to numob do
              begin
                if cov^[i,j] = 0 then localrho^[i,j] := 0 
	  	else if (cov^[i,i] = 0) or (cov^[j,j] = 0) then
                  begin
                     errormess('Variance equal to 0       |',fatal,false);
	             twrite(output,': |');
		     writename(i,output); twriteeoln(output);
                 end
                else localrho^[i,j]:= cov^[i,j]/
		   	(sqrt(cov^[i,i]) * sqrt(cov^[j,j]));
	        localrho^[j,i]:= localrho^[i,j];
	   end;
      for i:= 1 to numob do localrho^[i,i]:= 1.0;
      for i := 1 to numob do
         for j := 1 to numob do
           if abs(localrho^[i,j]) > 1 then 
             begin
                 errormess('Absolute value of correlation > 1.       |',fatal,false);
       	         twrite(output,': |'); writename(i,output); 
                 twrite(output,' |'); writename(j,output);twriteeoln(output);
             end;
   end
 else 
    for i := 1 to numob do
       for j := 1 to numob do
          localrho^[i,j] := cov^[i,j];
  lineno := templine;
end;  { formcorrs }

procedure readgraph(* infromtty: boolean; add: boolean; var fileread: text;
		      var adj: adjtype; var vertexnames: namearray; insert: boolean *);
(* Reads in the graph from the tty.  Max contains the number of vertices in
   the graph. *)

label 999;
var notfound,finished: boolean; c: char; wasinserted: boolean;
    head,tail: vertexnametype; i,j,k,headpos,tailpos: integer; 
    
begin (* readgraph *)
   numedges := 0;
   if aaabort then goto 999;
   if infromtty then lineno := 0;
   finished := false; twriteeoln(output);
   i := 1;
   while (not finished) do 
      begin 
         checkinterrupt;
         errors := errors - [ignoreall];
         head := blankname; tail := blankname;
	 if not infromtty then
 	    begin
         	readfileline(fileread,buf);
                readit(c);
                if c = '{' then 
                   begin
                     readcomment(fileread);
                     if myeoln then readfileline(fileread,buf);
                   end
                else curpos := curpos - 1;
                if (fatal in errors) then goto 999;
   	 	readedge(fileread,head,tail,finished,false);
                readwhitespace;
	    end
	 else
	    begin
		twrite(output,'Edge:  |');
		readedge(input,head,tail,finished,true);
	    end;
         if (head = tail) and (head[1] <> ' ') then
	     myerror('Head not allowed to equal tail.|          ',ignoreall,
	     	      true);
         if not finished and (not (ignoreall in errors)) then
	   if add then
	     begin
                headpos := 0;
                tailpos := 0;
                if head[1] <> ' ' then
                     headpos := listposition(head,insert,vertexnames,wasinserted);
                if tail[1] <> ' ' then
                     tailpos := listposition(tail,insert,vertexnames,wasinserted);
	        if not (ignoreall in errors) and (headpos <> 0) and 
                       (tailpos <> 0) then
		    begin
                        if not myeoln then 
                            parm^[headpos,tailpos] := readnum(false,fatal);
                        if (fatal in errors) then goto 999;
                        checkend;
			if adj^[headpos,tailpos]  <> notthere then
			   myerror('This edge is already present.|              ',
			   	    ignoreall,true)
		        else 
                          begin
                           if (adj = adjacency) then numedges := numedges + 1;
	   	           adj^[headpos,tailpos] := 1;
                          end;
			i := i + 1;
		    end;
	     end
	  else
	    begin
              headpos := 0;
              tailpos := 0;
              if head[1] <> ' ' then
                  headpos := listposition(head,false,vertexnames,wasinserted);
              if tail[1] <> ' ' then
                  tailpos := listposition(tail,false,vertexnames,wasinserted);
              if (not (ignoreall in errors)) and (headpos <> 0) and 
                 (tailpos <> 0) then
		    begin
			if adj^[headpos,tailpos] = notthere then
			   myerror('This edge cannot be removed because it does not exist. |                  ',
			   	    ignoreall,true)
			else
			  begin
		           adj^[headpos,tailpos] := notthere;
                           if (adj = adjacency) then 
                              begin
                                parm^[headpos,tailpos] := 0.0;
		                numedges := numedges - 1;
                              end;
                          end;
			i := i + 1;
		    end;
                if (not (ignoreall in errors)) and (adj = adjacency) then
                   begin
                     if headpos <> 0 then 
                         graphvertices := graphvertices - [headpos];
                     if tailpos <> 0 then 
                         graphvertices := graphvertices - [tailpos];
                     for j := 1 to maxvertex do
                        begin
                           if headpos <> 0 then 
                              if adj^[headpos,j] <> notthere then 
                                 graphvertices := graphvertices + [headpos];
                           if tailpos <> 0 then
                              if adj^[headpos,j] <> notthere then 
                                 graphvertices := graphvertices + [tailpos];
		        end;
                   end;
	    end;
     end;
    if adj = adjacency then calcnum(numob,numtheo,max,vernames);
    havereadgraph := true;
999: end;  { readgraph }

procedure setcheck(* is: integer; var c: char *);    
begin
  if (is = true) then c := '0' else c := ' ';
end;

procedure setthecheck(is: integer; var c: char);    
begin
  if (is = notthere) then c := '0' else c := ' ';
end;

procedure outputcorr(var fil: text; i,j: integer; isimplied: integer; prob: real);
var impldcheck,heldcheck: char; isheld: integer;
begin
  setthecheck(isimplied,impldcheck);
  if (prob > signif) then isheld := notthere else isheld := 0;
  setthecheck(isheld,heldcheck);
  twrite(fil,'   |'); pwritename(i,fil,7);
  twrite(fil,'   |'); pwritename(j,fil,7);
  twrite(fil,'      |'); tpwritereal(fil,rho^[i,j],7,4,false);
  twrite(fil,'    |'); twritechar(fil,impldcheck);twrite(fil,'      |'); 
	twritechar(fil,impldcheck);twrite(fil,'      |'); 
	tpwritereal(fil,prob,7,4,false);
	twriteeoln(fil);
end;

procedure showcorrelations;
var i,j: integer; 
begin
    twriteeoln(ofilvar);
    twrite(ofilvar,' Correlation   Residual|');
    twriteln(ofilvar,'   Impld.   Held   P(diff|.)');
    twriteeoln(ofilvar);
    for i := 1 to numob-1 do 
        for j := i+1 to numob do
           if (not theoretical[i]) and (not theoretical[j]) then 
                outputcorr(ofilvar,i,j,corrimpl^[i,j],corrproba^[i,j]);
    twriteeoln(ofilvar);
end;

procedure writemodelscore(score,maxscore: real);
begin
   twrite(ofilvar,'The Tetrad-score for this model is |');
   tpwritereal(ofilvar,score,7,4,false);
    twriteeoln(ofilvar);
   twrite(ofilvar,'The maximum possible Tetrad-score for this data is |');
   tpwritereal(ofilvar,bestscore,7,4,false);
    twriteeoln(ofilvar);
   twriteln(ofilvar,'}|');
end;

procedure writecandlist;
var curpos: modelptr; direction: integer; 
begin
    curpos := candidates;
    while (curpos <> nil) do
      begin
         if (direction <> 2) then begin 
		writename(curpos^.singleedge1,ofilvar);twrite(ofilvar,' -> |');
		writename(curpos^.singleedge2,ofilvar); end
         else begin
		writename(curpos^.singleedge1,ofilvar);twrite(ofilvar,' C  |');
		writename(curpos^.singleedge2,ofilvar); end;
	twrite(ofilvar,'       |');
	tpwritereal(ofilvar,(curpos^.score),7,3,false);
	twrite(ofilvar,'    |');
	tpwritereal(ofilvar,(curpos^.maxscore),7,3,false);
	twriteeoln(ofilvar);
         curpos := curpos^.fwd;
      end;
    twriteeoln(ofilvar);    twriteeoln(ofilvar);
end;

procedure writemodellist(* models: modelptr; var ofilvar: text *);
label 999;
var curpos: modelptr; parms: covarray;  gotparams: char;
    ch: char; numprinted,i,j,k: integer; topscore: real;
    comment,lisbatfilename,eqsbatfilename: inbuf;
    lisoutopts: numberset; stop: boolean; 

procedure checkfortop;
begin
   if models^.score >= 0 then 
     begin
       if (curpos^.score < (percent * models^.score)) then stop := true
     end
   else if (curpos^.score < (models^.score/percent)) then stop := true;
end;

begin
  tnewcov(parms,fatal);   (* check for space *)
  if fatal in errors then goto 999;
(*  if lisrelnumber > 0 then 
     begin
        lisbatfilename := ofilename;
        getbase(lisbatfilename);
        tconcat(lisbatfilename,'l.bat',lisbatfilename);
        askforparams(parms,gotparams);
        getlisoutputopts(lisoutopts); 
        getcomment(comment);
      end;        
  if eqsnumber > 0 then
     begin
        eqsbatfilename := ofilename;
        getbase(eqsbatfilename);
        tconcat(eqsbatfilename,'e.bat',eqsbatfilename);
        if (lisrelnumber <= 0) then askforparams(parms,gotparams);
        getcomment(comment);
     end; *)
    numprinted := 0;
    curpos := models;
    if models <> nil then topscore := models^.score;
    stop := false;
    twriteln(ofilvar,'Suggested Elaborations to Initial Model|');
    twriteeoln(ofilvar);
    while (curpos <> nil) and (not stop) do
      begin
       numprinted := numprinted + 1;
       checkfortop;
       if (not stop) then
         begin
           adjwrite(curpos^.edges,ofilvar);
	   twrite(ofilvar,'Tetrad-score : |');
	   tpwritereal(ofilvar,100 * (curpos^.score + weight * worstscore)/(bestscore + weight * worstscore),8,2,false);
	   twriteeoln(ofilvar);
	   twriteeoln(ofilvar);
           curpos := curpos^.fwd;
         end;
      end;
(*    if (eqsnumber <> 0) then makeeqsbatch(eqsbatfilename);
(*    if (lisrelnumber <> 0) then makelisbatch(lisbatfilename); *)
  dispose(parms);
999: end;

procedure outputresults(* id: commands *);
begin
  if id = finalsets then 
         writemodellist(models,ofilvar);
end;

procedure writeadj(* var graph: adjtype; var outfile: text *);
var k,l: integer;
begin
   for k := 1 to max do
      for l := 1 to max do
        if (k in graphvertices) and (l in graphvertices) and
           (graph^[k,l] <> notthere) then
		begin
		writename(k,outfile); twrite(outfile,' |');
		writename(l,outfile); twrite(outfile,' |');
		twriteint(outfile,graph^[k,l]);
		twriteeoln(outfile);
		end;
   twriteeoln(outfile);
   twriteeoln(outfile);
end;

procedure adjwrite(* var graph: adjtype; var outfile: text *);
var k,l: integer; found,stop: boolean;
begin
   for k := 1 to max do
      for l := 1 to max do
        if (k in graphvertices) and (l in graphvertices) and
           (graph^[k,l] <> notthere) then
              begin
		writename(k,outfile); twrite(outfile,' |');
		writename(l,outfile); twrite(outfile,' |');
		twriteeoln(outfile);
	      end;
    k := max + 1;
    stop := false;
    while (k <= max + lowestlevel - 1) and (not stop) do
      begin
         l := 1;
         found := false;
         stop := true;
         while (l <= max) and (not found) do
           if (graph^[k,l] <> notthere) and (l in graphvertices) then 
              begin
                 writename(l,outfile); twrite(outfile,' C |'); 
                 found := true; 
              end 
           else l := l + 1;
         l := l + 1;
         found := false;
         while (l <= max) and (not found) do
           if (graph^[k,l] <> notthere) and (l in graphvertices) then 
             begin
               writename(l,outfile); twrite(outfile,' |'); twriteeoln(outfile);
               found := true; stop := false;
             end
           else l := l + 1;
         k := k + 1;
       end;
   twriteeoln(outfile);
   twriteeoln(outfile);
end;

procedure writegraph(* var adjacency: adjtype; var tofile: text; 
                       common: boolean; allvar: boolean *);
var numprinted: integer; i,j: vertextype; written: vertexset;
begin
   written := [];
   twriteeoln(tofile);
   twrite(tofile,'    |'); 
   numprinted := 1;
   for i:= 1 to max do
      for j:= 1 to max do
       begin
	 if (adjacency^[i,j] <> notthere) then
          if (i < j) or (not common) then 
	    begin
               written := written + [i,j];
               pshort(i,tofile); twrite(tofile,' |');
               if not common then twrite(tofile,'-> |')
               else twrite(tofile,'C |');
               pshort(j,tofile);
               if not ((numprinted mod 6) = 0) then twrite(tofile,'   |');
   	       if ((numprinted mod 6) = 0) then 
                    begin twriteeoln(tofile); twrite(tofile,'    |'); end;
	       numprinted := numprinted + 1;
               written := written + [i,j];
	    end;
       end;
   twriteeoln(tofile); 
   numprinted := 1;
   if allvar then
     begin
       twrite(tofile,'    |'); 
       for i := 1 to max do 
         if (i in graphvertices) and (not (i in written)) then
            begin
               pshort(i,tofile); 
               if not ((numprinted mod 12) = 0) then twrite(tofile,'   |');
   	       if ((numprinted mod 12) = 0) then 
                    begin twriteeoln(tofile); twrite(tofile,'    |'); end;
	       numprinted := numprinted + 1;
            end;
      end;
   twriteeoln(tofile);
end;

function readnum1(* var afile: text; infromtty: boolean; err: errortype): real; *);
(* parses a number from buf and returns the result.  infromtty is true if
   input is from the tty. *)

label 999;
var founddigit,isneg: boolean; numdigits: integer; c: char; 
    numdecimal,sofar: real;
begin
   founddigit := false;
   isneg := false;
   numdecimal := 0;
   numdigits := 0;
   sofar := 0;
   readwhitespace;
   if not myeoln then readit(c);
   if myeoln and (not digit(c)) then
	 begin
	    myerror('Digit required.|                         ',err,true);
	    goto 999;
	 end;
   if (c = '-') then isneg := true
   else if (c = '.') then numdecimal := 10
   else if digit(c) then
	 begin
	    sofar := (ord(c) - ord('0'));
	    founddigit := true;
	 end
      else
	 begin
	    myerror('Space, digit, or decimal point required.|',err,true);
	    goto 999;
	 end;
   while (not myeoln) and (c in ['0'..'9','-','.']) do
      begin
	 readit(c);
	 if (c = '.') then
	       if (numdecimal = 0) then numdecimal := 10
	       else
		  begin
		     myerror('More than one decimal point in number.|  ',err,
		     	      true);
		     goto 999;
		  end
	 else if digit(c) then
              begin
	      	 numdigits := numdigits + 1;
		 if numdigits > 15 then 
		     begin      
		       myerror('Only 15 digits are significant.|          ',
		       		warning,true);
		       goto 999;
		     end;
	         if (numdecimal = 0) then
		   sofar := (sofar * 10) + (ord(c) - ord('0'))
	         else
	            begin
	              sofar := sofar + ((ord(c) - ord('0')) / numdecimal);
		      numdecimal := numdecimal * 10;
		    end;
		 founddigit := true;
	       end;
      end;
   if not founddigit then
	 myerror('Digit required.|                         ',err,true);
999: if isneg  then sofar := sofar * (-1);
   readnum1 := sofar;
end;


procedure checkcompatible(adj1,adj2: adjtype; addreq: boolean);
var i,j: vertextype; templine: integer;
begin
   for i := 1 to max do
     for j := 1 to max do
       begin
          if (adj1^[i,j] <> notthere) and (adj2^[i,j] <> notthere) then
             begin
                 templine := lineno;
                 lineno := 0; (* so doesn't print out line number in error *)
                 if addreq then errormess('Cannot require edge because it is already forbidden: |',warning,false)
                 else errormess('Cannot forbid edge because it is already required: |',warning,false);
                 lineno := templine;
                 pshort(i,output); 
                 twrite(output,' -> |');
                 pshort(j,output);
                 twriteeoln(output);
                 if addreq then adj1^[i,j] := notthere 
                 else adj2^[i,j] := notthere;
             end
       end;
end;

procedure edgeread(* add,common: boolean *);
label 999;
var i,j,numinskel: integer; switchset: commandset;
    localnames: namearray;
begin
   if fatal in errors then goto 999;
   if max < 2 then 
     begin
        myerror('At least two variables required.|',fatal,false);
        goto 999;
     end;
   if (currentin = inp) then
          begin
             twriteln(output,'Example of input: |');
             writename(1,output);
             twrite(output,' |');
             writename(2,output);
             twriteeoln(output);
          end;
   if not aaabort then
      begin
         if not common then
              readgraph(currentin = inp,add,knowfile,forbiddenadj,vernames,false)
         else readgraph(currentin = inp,add,knowfile,commonfor,vernames,false)
      end;
   if common then
       for i := 1 to max do
          for j := 1 to max do
             if add then
                  begin
                      if commonfor^[i,j] <> notthere then commonfor^[j,i] := 0
                  end
                else if commonfor^[i,j] = notthere then commonfor^[j,i] := notthere;
  if (currentin <> inp) and add then
      if common then fcfilename := knowfilename
      else ffilename := knowfilename;
  if (not common) and add then checkcompatible(adjacency,forbiddenadj,false); 
  if (not common) then calcorder;
  
999: end;
   
function getreply(* (prompt: inbuf; c: char; default: boolean): boolean; *);
var ch: char;
begin
   if (currentin = inp) then
       begin 
          putstr(prompt,true);
          twrite(output,' [|');
	  twritetf(output,default);
	  twrite(output,']: |');
          readttyline(buf);
       end;
   readwhitespace;
   if myeoln then getreply := default
   else
      begin
         readit(ch);
         getreply := uppercase(ch) = uppercase(c);
      end;
end;

procedure readtemptiers(* add: boolean *);
var emptyline: boolean; tiernum,j: integer; name: vertexnametype; 
    pos: vertextype; wasinserted,dontadd: boolean;
begin
   emptyline := false;
   if (currentin = inp) and (max > 0) then
       begin
           twriteeoln(output);
           twriteln(output,'Example of input:|');           
           twrite(output,'1 |'); 
           writename(1,output);
           if (max > 1) then
             begin
               twrite(output,' |');
               writename(2,output); 
               twrite(output,' |');
             end;
           if (max > 2) then writename(3,output); 
           twriteeoln(output);
       end;
   repeat
      if currentin = inp then
           begin
              twrite(output,'Temporal tier: |');
              readttyline(buf) 
           end
      else readfileline(knowfile,buf);
      readwhitespace;
      if myeoln then emptyline := true
      else 
       begin
          errors := [];
          if not myeoln then 
              tiernum := tround(readnum(currentin = inp,warning));
          if errors = [] then
             if (not (tiernum > 0) and (tiernum <= maxvertex)) then
               begin
                  errormess('Tier number out of range |',ignoreall,true);
                  tpwriteint(output,1,2,true);
                  twrite(output,' to |');
                  tpwriteint(output,maxvertex,4,true);
                  twriteln(output,'.|');
               end;
          if errors = [] then while not myeoln do
            begin
              errors := [];
              readwhitespace;
              readname(name,warning);
              readwhitespace;
              pos := listposition(name,false,vernames,wasinserted);
              if (not (ignoreall in errors)) then 
                if add then
                   begin
                      dontadd := false;
                      for j := 1 to max do
                       if pos in temptiers[j] then 
                         begin
                           dontadd := true;
                           errormess(' |',warning,false);
				writename(pos,output);
                           twrite(output,' already in temporal tier: |');
			   twriteint(output,j);
			   twriteeoln(output);
                         end;
                      if not dontadd then 
                         temptiers[tiernum] := temptiers[tiernum] + [pos];
                   end
                else 
                   begin
                     if pos in temptiers[tiernum] then 
                         temptiers[tiernum] := temptiers[tiernum] - [pos]
                     else
                         begin
                           errormess(' |',warning,false);
				writename(pos,output);
                           twrite(output,' not in temporal tier |');
			   twriteint(output,tiernum);
			   twriteeoln(output);
                         end;
                   end;
           end;
        end;
   until emptyline;
   if (currentin <> inp) and add then tfilename := knowfilename;
end;     

(* replaces all occurances of c with a space character *)
procedure replacecharwithspace(*c:char*);
   var
	i:integer;
   begin
	for i := 1 to buflength do
		if buf[i]=c
		then buf[i] := ' ';
   end;

procedure replacecharwithchar(*c1,c2:char*);
   var
	i:integer;
   begin
	for i := 1 to buflength do
		if buf[i]=c1
		then buf[i] := c2;
   end;

procedure writechars(*var ofile:text;character:char;numspaces:integer*);
var i :integer;
begin
   for i := 1 to numspaces do
	twritechar(ofile,character);
end;

procedure getmu0(* infromtty: boolean;var fileread: text; var mu0: vertarray; var vernames: namearray; 
                 insert: boolean *);
label 999;
var i: integer; varname: vertexnametype; varpos: vertextype; 
    finished: boolean; c: char; wasinserted: boolean;
begin
   if aaabort then goto 999;
   if infromtty then lineno := 0;
   finished := false; twriteeoln(output);
   i := 1;
   while (not finished) and not eof(knowfile) do
      begin 
         checkinterrupt;
         errors := errors - [ignoreall];
         varname := blankname; 
	 if not infromtty then
 	    begin
         	readfileline(fileread,buf);
                readit(c);
                if c = '{' then 
                   begin
                     readcomment(fileread);
                     if myeoln then readfileline(fileread,buf);
                   end
                else curpos := curpos - 1;
                if (fatal in errors) then goto 999;
                if myeoln then finished := true;
   	 	if (not finished) then
                   begin
                      readname(varname,ignoreall);
                      if not finished then readwhitespace;
                      if myeoln then finished := true;
                   end;
	    end;
         if not finished and (not (ignoreall in errors)) then
	     begin
                varpos := 0;
                if varname[1] <> ' ' then
                  varpos := listposition(varname,insert,vernames,wasinserted);
	        if not (ignoreall in errors) and (varpos <> 0) then
		    begin
                        if not myeoln then 
                            mu0[varpos] := readnum(false,fatal);
                        if (fatal in errors) then goto 999;
                        checkend;
		    end;
             end;
      end;
999: end;  { readgraph }
 
procedure writefull(var rho: covarray; var tofile: text);
var i,j,numwritten: integer;
begin
    numwritten := 1;
    for i := 1 to numob do
       begin
          if (numwritten mod 8) = 0 then twriteeoln(tofile);
          pwritename(i,tofile,9);
               numwritten := numwritten + 1;
       end;
    numwritten := 1;
    for i := 1 to numob do 
        for j := 1 to numob do
            begin
               if (numwritten mod 8 = 0) or (j = 1) then 
                    begin
                       twriteeoln(tofile);
                       numwritten := 1;
                    end;
               tpwritereal(tofile,rho^[i,j],10,decpoints,false);
               numwritten := numwritten + 1;
            end;
    twriteeoln(tofile);
    twriteeoln(tofile);
end;

             
(*-----------#pc-version-----------------------------------------------------*)
(*end.*)
(*-----------#pc-version-----------------------------------------------------*)