(****** recalc.h ******)

(* Implied Covariance matrix datastructure *)

(* there is one headptr for each non-zero, non-unity Cov(,) and H(,)
term, this headptr marks the start of a linked list of tailptr records
giving a linear combination corresponding to that H(,) or Cov(,) fact *)

type tailptr = ^tailrec;
     headptr = ^headrec;
	 tailrec = record
	 	next: tailptr;
	 	hcov: headptr;
	 	coeff: integer;  (* parameter No. *)
		val: real;
    	        params: set of vertextype; (* set of params *)
	      end;

     headrec = record
 		tail: tailptr;
		val: real;
    	        params: set of vertextype; (* set of params *)
		end;

(* Re-calculation list datastructure - 
  one such linked list is associated with each model parameter, 
  giving an ordered list of H() and Cov() expressions to be re-calculated
  when that model parameter is changed  *)
	 	
    calcptr = ^calcrec;
		calcrec = record
		next: calcptr;
		hcov: headptr;
			end;

    calclistindarrt = array[1..maxparms] of calcptr;

(* Look-up tables for re-calculation lists - one entry per model param *)

     hcovheadindexarr = array[1..maxvertex,1..maxvertex] of headptr;
     hcovheadindext = ^hcovheadindexarr;
	 	
     dblptr = ^dblrec;
	dblrec = record
			 vert: vertextype;
			 next: dblptr;
			 prev: dblptr;
			 	 	end;


(******** Procedure declaration **********)

procedure tnewhcovheadindex(var ptr: hcovheadindext; err: errortype); external;

procedure disposerecalclist(var calclist:calclistindarrt; numparms:integer); external;

procedure disposehcovind(var hind,covind:hcovheadindext); external;

procedure makeimplcov(var gcov:covarray; var graph:adjtype; 
		  var priormean:priormeansarray; 
		  var exogd:exogarray;
		  var parm:covarray;
		  numparms:integer;
		  var paramrecalcind:calclistindarrt;
		  var htermindex,covtermindex:hcovheadindext); external;

procedure recalcmatrix(var gcov:covarray; var exogd:exogarray;
				var parm:covarray;
				xparam: integer;
				var paramrecalcind: calclistindarrt;
				var covtermind:hcovheadindext;
		                var priormean:priormeansarray); external;




