//Copyright (C) 1997 Frank C. Wimberly.  All rights reserved.


class Graph{

  final int NONE   = 0;
  final int OUTOF  = 1;
  final int INTO   = 2;
  final int CIRCLE = 3;
  final int INOUT  = 4;

  protected int nvertices;
  protected int edgeMatrix[][];
  protected int paths[][];
  protected boolean havePaths;
  protected String name;
  protected String vertexNames[];

  public Graph(int nvertices, int edgeMatrix[][], String name, String vertexNames[])
  {
     this.nvertices = nvertices;
     this.edgeMatrix = edgeMatrix;
     this.name = name;
     this.vertexNames = vertexNames;
     this.havePaths = false;
     paths = new int[nvertices][nvertices];
  }

  public Graph(causalGraph G, String name, String vertexNames[])
  {
     this.nvertices = G.nvertices;
     this.edgeMatrix = G.edgeMatrix;
     this.name = name;
     this.vertexNames = vertexNames;
     this.havePaths = false;
     paths = new int[nvertices][nvertices];
  }

  public void displayGraph( )
  {  
     String row;
     System.out.println(name);
     for (int i = 0; i < nvertices; i++)
     {
        row = " ";
        for (int j = 0; j < nvertices; j++)
           row += (" " + edgeMatrix[i][j]);
        System.out.println(vertexNames[i]+" " + row);
//      System.out.println(vertexNames[i]+" " + row);
     }
  }



  public boolean adjacent(int tail, int head) 
  { 
    if(edgeMatrix[tail][head] == OUTOF && edgeMatrix[head][tail] == OUTOF)
//||(edgeMatrix[tail][head] == OUTOF && edgeMatrix[head][tail] == CIRCLE))
      return true;
    else return false;
  }

  public boolean isPath(int start, int end)
  { 
    boolean ans = false;

    if (!havePaths) {
       havePaths = true;

       for (int j = 0; j < nvertices; j++)
         for (int i = 0; i < nvertices; i++) {
           paths[i][j] = 0;
           if(adjacent(i, j)) paths[i][j] = 1;
           }

       for (int j = 0; j < nvertices; j++)
         for (int i = 0; i < nvertices; i++)
            if(paths[i][j] == 1)
                    for (int k = 0; k < nvertices; k++)
                                        paths[i][k] = paths[i][k] | paths[j][k];
       }

     if (paths[start][end] == 1) ans = true; else ans = false;
     return ans;
   }

}

