import java.awt.event.*;
import java.util.Vector;
import java.awt.*;
import java.io.*;
import java.lang.*;
import java.lang.String;
import java.lang.Math;
import java.util.*;
import java.applet.Applet;

public class bayesNetEditor extends Applet {
  static Frame F;


public void init( ) {
  F = new rectangleFrame("Bayes Net Editor");
  F.setSize(740, 500);
  F.setLayout(new FlowLayout( ));
  F.setBackground(Color.white);
  F.setVisible(true);
}

public void start( ) {

  }

public void stop( ) {

  F.setVisible(false);
  }

public void destroy ( ) {

  }
}

class Vertex {
  Rectangle rect;
  String name;

public Vertex(Rectangle r, String n) {
  this.rect = r;
  this.name = n;
  }
}

class rectangleFrame extends Frame implements ActionListener, MouseListener, MouseMotionListener {

//Check GRAPH
  final int AUTO = 15;
  final int FCIA= 16;

  final int NODES = 0;
  final int EDGES = 1;
  final int STORED = 2;
  final int SELECTED = 3;
  final int EDIT = 4;
  final int SELEDGE = 5;
  final int EVID = 6;
  final int INTER = 7;
  final int DIST = 8;
  final int SELX = 9;
  final int SELY = 10;
  final int SELCOND = 11;
  final int DELCOND = 12;
  final int DSEP = 13;
  final int SIM = 14;

  final int MAXSPOTS = 15;
  final int MAXVALUES = 15;
  final double THRESH = 40.0;

  final int NONE   = 0;
  final int OUTOF  = 1;
  final int INTO   = 2;
  final int CIRCLE = 3;
  final int INOUT  = 4;
  
  String vnames[] = new String[MAXSPOTS];  
  Color vcolors[] = new Color[MAXSPOTS];
  String valueNames[][] = new String[MAXSPOTS][MAXVALUES];
  int nvalues[] = new int[MAXSPOTS];
  boolean valNamesSet[] = new boolean[MAXSPOTS];
  int values[] = new int[MAXSPOTS];

  diGraph G;
  diGraph D;
  bayesNet B;
  bayesNet origB;
  //int adjMatrix[][] = new int[MAXSPOTS][MAXSPOTS];
  int edgeMatrix[][] = new int[MAXSPOTS][MAXSPOTS];
  String graphName;
  String fileName;

  int xnode = -1;
  int ynode = -1;
  int oldx = -1;
  int oldy = -1;
  int cnodes[] = new int[MAXSPOTS];
  nodeList condSet = new nodeList(cnodes);

  int state = NODES;
  
  int currspots = 0;
  boolean readyNewNode = true;
  boolean probsEdited = false;
  boolean modified = false;
  Vertex V[] = new Vertex[MAXSPOTS];

  final int MAXEDGES = 200;
  Point starts[] = new Point[MAXEDGES];
  Point ends[] = new Point[MAXEDGES];
  Point centers[] = new Point[MAXEDGES];
  Color ecolors[] = new Color[MAXEDGES];
  Point from, to;
  Point anchor;
  Point currentpoint = null;
  Point currlocation = null;
  int startVertex[] = new int[MAXEDGES];
  int endVertex[] = new int[MAXEDGES];
  int currline = 0;
  int selected = -1;
  int selectedEdge = -1;
  int noutlines;
  int evidence[] = new int[MAXSPOTS];
  int manipulation[] = new int[MAXSPOTS];


//Check GRAPH
  Button GRAPHbutton;
//Fci
  Button FCIbutton;
  Button Abutton;
  Button Bbutton;
  Button Cbutton;
  Button Dbutton;
  Button D1button;
  Button Ebutton;
  Button Fbutton;
  Button G1button;
  Button G2button;
  Button G3button;

  Button AV;
  Button AE;
  Button ED;
  Button CD;
  Button GS;
  Button SI;
  Button ES;
  Button UP;
  Button IV;
  Button CL;
  Button DN;
  Button IN;
  Button SX;
  Button SY;
  Button AC;
  Button DC;
  Button DS;
  Button G2;
  Button EN;

//check GRAPH
  Button goPaint;
  TextField matrixLocation;
  Dialog checkGRAPH;  
//FCI
  Button goFci;
  TextField file_name;
  TextField file2_name;
  Dialog dialogFci;  
  TextField file3_name;


  //Stores name, size and category of all variables
  //Vector vname=new Vector();
  Vector vname;
  static double signif=0.95;
  static int MAXINPUT =10000;
  static int  total_num_variable=0;
  static int sample_size;
  int inter=0;
  static Variable varArray[] = new Variable[total_num_variable];
  static int[][] data = new int[MAXINPUT][total_num_variable];
  //Total iterations done
  static int iterTot; 
  //Subset T that will be conditioned on
  //Vector T =new Vector();
  Vector T;
  static g2Result g2r;
  G2stat_test g2test;
  Vector[][] sepSet; 
  int MaxNumAdj;
  Vector[] possDSep;
  Vector[] checkDSep;
  Vector[] checkQuadr;

  Dialog editV;
  Button doneEdit;
  Button labelVals;
  Button doneNames;
  Button densityOK;
  Button storeCPTable;
  Button goSample;
  Button goEstimate;
  Button doneEvidence;
  Button selVar;
  Button valueSelected;
  Button warningOK;
  Button answerGO;
  Button answerOK;
  Button g2ansGO;
  Button g2ansOK;
  Button calcInd;
  Button simGO;
  Button killHist;
  Frame HF;
  TextField varName;
  TextField numVals;
  TextField sampSizetf;
  TextField numSampstf;
  TextField fileNametf;
  TextField vals[] = new TextField[MAXVALUES];
  TextField ptf[][] = new TextField[100][MAXVALUES];  // 100 should be replaced by max ncpv
  Dialog vlabels;
  Choice cp;
  Choice cpm;
  Choice c[] = new Choice[MAXSPOTS];
  Choice cpp[] = new Choice[MAXSPOTS];
  Dialog vl;
  Dialog density;
  Dialog generate;
  Dialog estimate;
  Dialog g2dialog;
  Dialog g2ans;
  Dialog update;
  Dialog spreadSheet;
  Dialog warning;
  Dialog simParams;
  Dialog dsepans;
  Panel panel1;
  Panel panel2;

  StringBuffer outputLine[] = new StringBuffer[9];

public rectangleFrame(String title) {
  super(title);

//Check GRAPH
  GRAPHbutton = new Button("Paint GRAPH");
  GRAPHbutton.addActionListener(this);
//Fci
  FCIbutton= new Button("Run FCI");
  FCIbutton.addActionListener(this);
  Abutton = new Button("Paint full graph");
  Abutton.addActionListener(this);
  Bbutton = new Button("Condition on Adjacencies");
  Bbutton.addActionListener(this);
  Cbutton = new Button("Orient Triples");
  Cbutton.addActionListener(this);
  Dbutton = new Button("Initialize D-loop");
  Dbutton.addActionListener(this);
  D1button = new Button("Condition on Possible-D-Sep");
  D1button.addActionListener(this);
  Ebutton = new Button("Orient as o-o");
  Ebutton.addActionListener(this);
  Fbutton = new Button("Orient collider");
  Fbutton.addActionListener(this);
  G1button = new Button("G (i)");
  G1button.addActionListener(this);
  G2button = new Button("G (ii)");
  G2button.addActionListener(this);
  G3button = new Button("G (iii)");
  G3button.addActionListener(this);
  

  AV = new Button("Add/Move Variables");
  AV.addActionListener(this);
  AE = new Button("Add/Delete Edges");
  AE.addActionListener(this);
  ED = new Button("Edit");
  ED.addActionListener(this);
  CD = new Button("Edit Distribution");
  CD.addActionListener(this);
  GS = new Button("Gen Sample");
  GS.addActionListener(this);
  SI = new Button("Simulate");
  SI.addActionListener(this);
  ES = new Button("Estimate");
  ES.addActionListener(this);
  UP = new Button("Update");
  UP.addActionListener(this);
  IV = new Button("Intervene");
  IV.addActionListener(this);
  CL = new Button("Clear");
  CL.addActionListener(this);
  DN = new Button("Done");
  DN.addActionListener(this);
  IN = new Button("Independence Tests");
  IN.addActionListener(this);

  SX = new Button("Select X");
  SX.addActionListener(this);
  SY = new Button("Select Y");
  SY.addActionListener(this);
  AC = new Button("Add to cond set");
  AC.addActionListener(this);
  DC = new Button("Del from cond set");
  DC.addActionListener(this);
  DS = new Button("X d-sep from Y?");
  DS.addActionListener(this);
  G2 = new Button("X, Y independent?");
  G2.addActionListener(this);
  EN = new Button("Edit Network.");
  EN.addActionListener(this);

//Check GRAPH
  GRAPHbutton.setBackground(Color.white);
  add(GRAPHbutton);
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Fci
  FCIbutton.setBackground(Color.white);
  add(FCIbutton);

  AV.setBackground(Color.white);
  add(AV);
  AE.setBackground(Color.gray);
  add(AE);
  ED.setBackground(Color.gray);
  add(ED);
  //DE.setBackground(Color.gray);
  //add(DE);
  CD.setBackground(Color.gray);
  add(CD);
  GS.setBackground(Color.gray);
  add(GS);
  SI.setBackground(Color.gray);
  add(SI);
  ES.setBackground(Color.gray);
  add(ES);
  UP.setBackground(Color.gray);
  add(UP);
  IV.setBackground(Color.gray);
  add(IV);
  CL.setBackground(Color.gray);
  add(CL);
  DN.setBackground(Color.white);
  add(DN);
  IN.setBackground(Color.white);
  add(IN);

  addMouseListener(this);
  addMouseMotionListener(this);

  //set default values for variables
  for(int i = 0; i < MAXSPOTS; i++) {
    valNamesSet[i] = false;
    nvalues[i] = 2;
    valueNames[i][0] = "value0";
    valueNames[i][1] = "value1";
    }
  outputLine[0] = new StringBuffer("Click on a Button to enter or modify network.");
  outputLine[1] = new StringBuffer("Instructions for the selected button will appear here.");
  noutlines = 2;
  repaint( );
  }

public void mousePressed(MouseEvent evt) {
  int x = evt.getX( );
  int y = evt.getY( );
  if(state == EDIT || state == DIST) return;
  if(state == EVID || state == INTER) return;
  if(state == SIM) return;
  if(state == SELX || state == SELY || state == SELCOND || state == DELCOND) return;
  if(state == EDGES) {
    Point pt = new Point(x, y);
    selectedEdge = closestEdge(pt);
    if(selectedEdge >= 0) {
      //adjMatrix[startVertex[selectedEdge]][endVertex[selectedEdge]] = 0;
      edgeMatrix[startVertex[selectedEdge]][endVertex[selectedEdge]] = 0;
      edgeMatrix[endVertex[selectedEdge]][startVertex[selectedEdge]] = 0;
      if(selectedEdge == currline - 1) currline -= 1;
      else {
        for(int i = selectedEdge; i < currline; i++) {
          starts[i] = starts[i+1];
          ends[i] = ends[i+1];
          centers[i] = centers[i+1];
          ecolors[i] = ecolors[i+1];
          startVertex[i] = startVertex[i+1];
          endVertex[i] = endVertex[i+1];
          }
        currline -= 1;
        }
      repaint( );
      selectedEdge = -1;
      storeGraph( );
      return;
      }
    anchor = new Point(x, y);
    return;
    }
  for(int i = 0; i < currspots; i++) {
    if(V[i].rect.contains(x, y)) {
      selected = i;
      state = SELECTED; 
      return;
      } 
    }
  if(state == NODES) {
    return;
    }
  return;
  }

public void mouseReleased(MouseEvent evt) {
  int x = evt.getX( );
  int y = evt.getY( );
  if(state == NODES) {
    if(currspots < MAXSPOTS) {
      StringBuffer l = new StringBuffer("A" + currspots);
      readyNewNode = true;
      addspot(x, y, l);
      }
    else System.out.println("Too many vertices.");
    return;
    }
  else if(state == EDGES) {
    if(currline < MAXEDGES) 
      addline(x, y);
    return;
    }
  else if(state == SELECTED) {
    currlocation = null;
    selected = -1;
    repaint( );
    state = NODES;
    return;
    }
  else if(state == SIM) {
    for(int i = 0; i < currspots; i++) {
      if(V[i].rect.contains(x, y)) selected = i;
      }
    if(selected == -1) return;
    repaint( );
    simSetup(selected);
    return;
    }
  else if(state == EDIT || state == DIST) {
    for(int i = 0; i < currspots; i++) {
      if(V[i].rect.contains(x, y)) selected = i;
      }
    if(selected == -1) return;
    repaint( );
    if(state == EDIT) editVertex(selected);
      else parentValues(selected);
    return;    
    }
  else if(state == EVID) {
    for(int i = 0; i < currspots; i++) {
      if(V[i].rect.contains(x, y)) selected = i;
      }
    if(selected == -1) return;
    getValue(selected);
    repaint( );
    return;
    }
  else if(state == INTER) {
    for(int i = 0; i < currspots; i++) {
      if(V[i].rect.contains(x, y)) selected = i;
      }
    if(selected == -1) return;
    getValue(selected);
    repaint( );
    return;
    }
  else if(state == SELX) {
    for(int i = 0; i < currspots; i++) {
      if(V[i].rect.contains(x, y)) xnode = i;
      }
    if(xnode == -1) {
      outputLine[0] = new StringBuffer("Missed all nodes--try again.");
      noutlines = 1;
      repaint( );
      return;
      }
    else {
      outputLine[0] = new StringBuffer(vnames[xnode] + " selected for X");
      noutlines = 1;
      if(oldx != ynode && oldx != -1) vcolors[oldx] = Color.blue;
      vcolors[xnode] = Color.green;
      oldx = xnode;
      //SX.setBackground(Color.gray);
      //SY.setBackground(Color.white);
      repaint( );
      return;
      }
    }
  else if(state == SELY) {
    for(int i = 0; i < currspots; i++) {
      if(V[i].rect.contains(x, y)) ynode = i;
      }
    if(ynode == -1) {
      outputLine[0] = new StringBuffer("Missed all nodes--try again.");
      noutlines = 1;
      repaint( );
      return;
      }
    else if (ynode == xnode) {
      outputLine[0] = new StringBuffer("X and Y must be different.");
      noutlines = 1;
      repaint( );
      return;
      }
    else {
      outputLine[0] = new StringBuffer(vnames[ynode] + " selected for Y");
      outputLine[1] = new StringBuffer("Now define conditioning set.");
      if(oldy != xnode && oldy != -1) vcolors[oldy] = Color.blue;
      vcolors[ynode] = Color.green;
      oldy = ynode;
      //SY.setBackground(Color.gray);
      //AC.setBackground(Color.white);      
      //DC.setBackground(Color.white);      
      //DS.setBackground(Color.white);
      repaint( );
      return;
      }
    }
  else if(state == SELCOND) {
    int cnode = -1;
    for(int i = 0; i < currspots; i++) {
      if(V[i].rect.contains(x, y)) cnode = i;
      }
    if(cnode == -1) {
      outputLine[0] = new StringBuffer("Missed all nodes--try again.");
      noutlines = 1;
      repaint( );
      return;
      }
    if(cnode == xnode || cnode == ynode) {
      outputLine[0] = new StringBuffer("Neither X nor Y may be in the conditioning set.");
      noutlines = 1;
      repaint( );
      return;
      }
    condSet.addElement(cnode);
    vcolors[cnode] = Color.red;
    outputLine[0] = new StringBuffer(vnames[cnode] + " added to conditioning set.");
    noutlines = 1;
    repaint( );
    return;
    }
  else if(state == DELCOND) {
    int cnode = -1;
    for(int i = 0; i < currspots; i++) {
      if(V[i].rect.contains(x, y)) cnode = i;
      }
    if(cnode == -1) {
      outputLine[0] = new StringBuffer("Missed all nodes--try again.");
      noutlines = 1;
      repaint( );
      return;
      }
    if(cnode == xnode || cnode == ynode) {
      outputLine[0] = new StringBuffer("Neither X nor Y may be in the conditioning set.");
      noutlines = 1;
      repaint( );
      return;
      }
    condSet.deleteElement(cnode);
    vcolors[cnode] = Color.blue;
    outputLine[0] = new StringBuffer(vnames[cnode] + " removed from conditioning set.");
    noutlines = 1;
    repaint( );
    return;
    }
  return;
  }

public void mouseEntered(MouseEvent evt) {
  }
public void mouseClicked(MouseEvent evt) {
  }
public void mouseExited(MouseEvent evt) {
  }
public void mouseMoved(MouseEvent evt) {
  }


public void mouseDragged(MouseEvent evt) {
  if( state == EDGES ) {
     currentpoint = evt.getPoint( );
     repaint( );
     return; 
     }
   else if(state == SELECTED) {
     currlocation = evt.getPoint( );
     repaint( );
     return;
     } 
   else return; 
}


public void actionPerformed(ActionEvent evt) 
{
  if(evt.getSource( ) instanceof Button) {
    //if(evt.getSource( ).getBackground( ) == Color.gray) return;
    //if(probsEdited && (evt.getSource( ) == AV || evt.getSource( ) == AE || 
    //evt.getSource( ) == ED || 
    //evt.targed == DE)) { INSERT HERE CODE FOR WARNING THE USER THAT THE
    //CONDITIONAL
    //PROBS WILL BE DISTURBED AND ASK WHETHER TO CONTINUE OR CANCEL

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//Check GRAPH
  if(evt.getSource( ) == GRAPHbutton) 
  {
    state = AUTO;
    outputLine[0] = new StringBuffer("To visualize edgeMatrix: Specify file name with proper path that contains the edgeMatrix, e.g.");
    outputLine[1] = new StringBuffer("3");
    outputLine[2] = new StringBuffer("0 1");
    outputLine[3] = new StringBuffer("2 0");
    noutlines = 4; 

    repaint( );
    checkGRAPH = new Dialog(this, "Graph painting method", true);
    checkGRAPH.setSize(180, 180);
    checkGRAPH.setLayout(new FlowLayout( ));
    goPaint = new Button("getFile");
    goPaint.addActionListener(this);
    checkGRAPH.add(new Label("File Name"));
    matrixLocation = new TextField(8);
    matrixLocation.setText("edge7.data"); 
    checkGRAPH.add(matrixLocation);
    checkGRAPH.add(goPaint);
    checkGRAPH.setVisible(true);
    return;
  }

  if(evt.getSource( ) == goPaint) 
  {
    int token, temp_int;
    Long temp;
    StreamTokenizer st;
    FileReader fr;
    vname=new Vector();

    //Get the file name from textfield
    String source_file = matrixLocation.getText( );

    //Open the data file
    try
    {
      fr = new FileReader(source_file);
    }
    catch(IOException e)
    {
      System.out.println("Cannot open file "+ source_file);
      checkGRAPH.dispose();
      return;
    }

    //Read the file in
    try
    {
      BufferedReader in = new BufferedReader(fr);
      st = new StreamTokenizer(in);
      st.eolIsSignificant(true);

      //Read in the first line, the vector of variable names
      //and find out the dimension of the data
      int wl=0;
      while(true)
      {
        token = st.nextToken();
        temp = new Long(Math.round(st.nval));
        temp_int = temp.intValue();

        if(token==st.TT_EOL)
        {
          break;
        }
        vname.insertElementAt(temp,wl);
        wl++;
      }
      st.eolIsSignificant(false);
      currspots=vname.size();

      //Initiate edgematrix and fill the first row
      edgeMatrix=  new int[currspots][currspots];
      for(int i=0;i<currspots;i++)
      {
         Integer Int=new Integer(vname.elementAt(i).toString());
         edgeMatrix[0][i]= Int.intValue();
         System.out.print(edgeMatrix[0][i]+" ");
      }
      System.out.print("\n");

      for(int i=1;i<currspots;i++)
      {
        //Read in the values into q
        for(int j=0;j<currspots;j++)
        {
          token =  st.nextToken();  
          temp = new Long(Math.round(st.nval));
          temp_int = temp.intValue();
          edgeMatrix[i][j]=temp_int;
          System.out.print(edgeMatrix[i][j]+" ");
        }
        System.out.print("\n");
      }  
      System.out.print("\n");
    }catch (Exception e){System.err.println(e);}
 
    //This calculates the vertices on a circle
    verticePositions(currspots);

    //This calculates the start and endpoints of the lines connecting V's
    drawEdgeS();

    //Set background for Add/delete Edges white, so it can be used, see check in actionPerformed
    AE.setBackground(Color.white);
    AV.setBackground(Color.gray);

    outputLine[0] = new StringBuffer("Nice!"); 
    outputLine[1] = new StringBuffer("Some stats:"); 
    outputLine[2] = new StringBuffer("Number of edges: "+currline); 

    noutlines = 3; 
    checkGRAPH.setVisible(false);
    repaint( );
    return;
    }

if(evt.getSource( ) == FCIbutton)
  {
    state=FCIA;
    outputLine[0] = new StringBuffer("Specify location of test file");
    outputLine[1] = new StringBuffer("i.e.: test.data");
    noutlines = 2;
    repaint();
    dialogFci = new Dialog(this, "Fci algorithm", true);
    dialogFci.setSize(180, 180);
    dialogFci.setLayout(new FlowLayout( ));
    goFci = new Button("Run Fci");
    goFci.addActionListener(this);
    dialogFci.add(new Label("File Name"));
    file_name = new TextField(8);
    file_name.setText("fci.data");
    dialogFci.add(file_name);
    dialogFci.add(goFci);

    dialogFci.add(new Label("Significance level"));
    file2_name = new TextField(4);
    file2_name.setText("0.05");
    dialogFci.add(file2_name);

    dialogFci.setVisible(true);
    return;
  }


if(evt.getSource( ) == goFci)
{
    dialogFci.dispose();
    //Set background for Add/delete Edges white, so it can be used, see check in actionPerformed
    remove(GRAPHbutton);
    remove(AE);
    remove(CD);
    remove(GS);
    remove(ES);
    remove(UP);
    remove(IV);
    remove(IN);
    remove(SI);

    FCIbutton.setBackground(Color.white);
    AV.setBackground(Color.white);
    CL.setBackground(Color.white);
    DN.setBackground(Color.white);
    ED.setBackground(Color.white);

    Abutton.setBackground(Color.red);
    add(Abutton);
    bayesNetEditor.F.pack();
    setSize(740,500);

    outputLine[0] = new StringBuffer("Fci: Part A"); 
    outputLine[1] = new StringBuffer("Click on: Paint full graph, to continue"); 
    noutlines =2; 

    //Reset
    iterTot=0;

    int token, temp_int;
    StreamTokenizer st;
    FileReader fr;
    Long temp;
    String name;
    int size ;
    int[] cat;
    String stop="true";
    Vector[] cate=new Vector[total_num_variable];
    vname=new Vector();

    //Get the file name from textfield
    String source_file = file_name.getText( );
    signif = Double.valueOf(file2_name.getText()).doubleValue();

    //Open the data file
    try
    {
      fr = new FileReader(source_file);
    }
    catch(IOException e)
    {
      System.out.println("Cannot open file "+ source_file);
      dialogFci.dispose();
      return;
    }

    //Read the file in
    try
    {
      BufferedReader in = new BufferedReader(fr);
      st = new StreamTokenizer(in);
      st.eolIsSignificant(true);

      //Read in the first line, the vector of variable names
      int wl=0;
      while(true)
      {
        token = st.nextToken();
        if(token==st.TT_EOL)
        {
          stop="false"; 
          break;
        }
        vname.insertElementAt(st.sval,wl);
        wl++;
      }
      System.out.println(vname);

      //Return number of variables in data set
      total_num_variable = vname.size();
      System.out.println("Number of variables: "+total_num_variable);

      data = new int[MAXINPUT][total_num_variable];
      varArray = new Variable[total_num_variable];      

      //Read in data
      //Initialize Vector array of type Vector, to store categories
      cate=new Vector[total_num_variable];
      for (int i=0; i<total_num_variable; i++)
      {
        Vector vari=new Vector();
        cate[i]=vari;
      }

      //Set end_of_file to false again!!! 
      st.eolIsSignificant(false);

      //Variables for while loop
      stop="true";
      while(true)
      { 
        for (int i=0; i<total_num_variable; i++)
        {
          token = st.nextToken();
          if(token==st.TT_EOF)
          {
            stop="false"; 
            break;
          }
          temp = new Long(Math.round(st.nval));
          temp_int = temp.intValue();

          //Checks category and insert at the right spot in rising order
          if(cate[i].contains(temp.toString())==false)
          {
            if(cate[i].size()==0)
            {
              cate[i].insertElementAt(temp.toString(),cate[i].size());
            }
            else                                        
            {
              if(Integer.parseInt(cate[i].elementAt(cate[i].size()-1).toString())<temp_int)
              {
                cate[i].insertElementAt(temp.toString(),cate[i].size());
              }
              else
              {
                for(int n=0;n<cate[i].size();n++)
                {
                  if(Integer.parseInt(cate[i].elementAt(n).toString())>temp_int)
                  {
                    cate[i].insertElementAt(temp.toString(),cate[i].size()-1);
                    break;
                  }
                }
              }//else
            }//else
          }//if false

          data[sample_size][i]=temp_int;
//System.out.print(data[sample_size][i]+" ");
        }//end of i loop
        if(stop=="false") 
        {
          break;
        }
//System.out.println(" ");
        sample_size++;
      }//end while loop
      System.out.println("Length of data: "+sample_size);
      
      //Initialize varArray, used in G2_stat
      for (int i=0; i<total_num_variable; i++)
      {
        System.out.print(cate[i]); 
        name=vname.elementAt(i).toString();
        size=cate[i].size();
        cat=new int[size];
        for(int j=0;j<size;j++)
        {
          cat[j]=Integer.parseInt(cate[i].elementAt(j).toString());
         } 
        varArray[i]=new Variable(name,size,cat);
      }
 
      //Initialize SepSet:
      sepSet=new Vector[total_num_variable][total_num_variable];
      for(int i=0; i<total_num_variable; i++)
      {
        for(int j=0; j<total_num_variable; j++)
        {
          Vector sepset=new Vector();
          sepSet[j][i]=sepset;
        }
    }

    }catch (Exception e){System.err.println(e);}
   
    repaint();

}

/***************
*A. (Paint full graph)
****************/

if(evt.getSource( ) == Abutton) 
{
  remove(Abutton);
   
  Bbutton.setBackground(Color.red);
  add(Bbutton);
  bayesNetEditor.F.pack();
  setSize(740,500);

  //Get dimension of state space (the paint methods "listens" to currspots
  currspots=total_num_variable ;

  //Initiate edgematrix to 1
  //Get the next currline line(rows) of the edgeMatrix
  edgeMatrix=  new int [currspots][currspots];
  for(int i=0;i<currspots;i++)
  {
    for(int j=0;j<currspots-1;j++)
    {
      edgeMatrix[i][j]=OUTOF;
      System.out.print(edgeMatrix[i][j]+" ");
    }
    edgeMatrix[i][currspots-1]=OUTOF;
    System.out.print(edgeMatrix[i][currspots-1]);
    System.out.print("\n");
  }  
  System.out.print("\n");
     
  //This calculates the vertices on a circle
  verticePositions(currspots);

  //Adjust variable names
  for(int i=0;i<currspots;i++)
  {
    V[i].name=vname.elementAt(i).toString();
  }  

  //This calculates the start and endpoints of the lines connecting V's
  drawEdgeS();

  outputLine[0] = new StringBuffer("Fci: Part A"); 
  outputLine[1] = new StringBuffer("Some stats:"); 
  outputLine[2] = new StringBuffer("Number of edges: "+currline); 
  outputLine[3] = new StringBuffer("Click on: \"Condition on Adjacencies\", to continue"); 
  noutlines = 4;

  sepSet=new Vector[currspots][currspots]; 
  for(int i=0;i<currspots;i++)
  {  
    for(int j=0;j<currspots;j++)
    {
      Vector sep=new Vector();
      sepSet[i][j]=sep;
    }
  }
   
  repaint( );
 
  //Values for next step
  iterTot=0; 
  MaxNumAdj=1;
}        

/***************
*B. (Eliminate edges, conditioning on Adjacencies)
****************/

if(evt.getSource() == Bbutton)
{    
    outputLine[0] = new StringBuffer("Fci: Part B"); 
    outputLine[1] = new StringBuffer("Checked for independence between variables, conditioned on subsets T of size: "+iterTot);
    outputLine[2] = new StringBuffer("Click on: \"Condition on Adjacencies\", to continue"); 
    noutlines = 3;

  //Stop criteria
  if(iterTot==MaxNumAdj)
  {
     outputLine[0] = new StringBuffer("Fci: Part B"); 
     outputLine[1] = new StringBuffer("There are no more edges to remove"); 
     outputLine[2] = new StringBuffer("Click on \"Orient Triples\", to continue");   
     noutlines = 3;
     remove(Bbutton);
     Cbutton.setBackground(Color.red);
     add(Cbutton);
     bayesNetEditor.F.pack();
     setSize(740,500);
     repaint();
     return;
  }

  g2test = new G2stat_test(currspots);

  //while... we press the "Next" button for that loop -->iter=0
    for(int i=0;i<currspots;i++)
    {//A
      for(int j=0;j<currspots;j++)
      {//B
	if(numAdj_j(i,j)>MaxNumAdj)
          MaxNumAdj=numAdj_j(i,j);

        if((i!=j)&&isEdge(i,j)&&(numAdj_j(i,j)>iterTot-1))
        {//C       
          //Vector containing the adjacencies of i except j 
          Vector Z=new Vector();

          Z=setAdj_j(i,j);
          System.out.println("\nZ "+Z);
          int q=0;
          Vector T=new Vector(); 
          updateEdgeMatrix(Z,i,j,iterTot+1,q,T);
        }//C
      }//B
    }//A
    //Total number of searches done (n in paper)
    iterTot++;
  //end while click
  repaint();
}

/***************
*C. (Orient Triples)
****************/
if(evt.getSource() == Cbutton)
{    
  outputLine[0] = new StringBuffer("Fci: Part C"); 
  outputLine[1] = new StringBuffer("Click on \"Initialize D-loop\", to continue"); 
  noutlines = 2;
  repaint();

 System.out.println("sepSet: ");
  for(int i=0;i<currspots;i++)
  {
    for(int j=0;j<currspots;j++)
    {
      System.out.print(sepSet[i][j]); 
    }  
    System.out.print("\n");
  }

  boolean add=true;
  for(int i=0;i<currspots;i++)
  {
    for(int j=0;j<currspots;j++)
    {  
      for(int k=0;k<currspots;k++)
      { 
        if((i!=j)&&(i!=k)&&(j!=k)&&(isEdge(i,j))&&(isEdge(i,k))&&(!isEdge(j,k)) )
	{
          //Work around, since sepSet[j][k].contains(varArray[i].name) does not work
          add=true;
          for(int l=0;l<sepSet[j][k].size();l++)
          {    
            Vector temp1=new Vector();
            temp1.addElement(varArray[i].name);
            if(sepSet[j][k].elementAt(l).toString().equals(temp1.toString()))
	    {
              add=false;
            }
          } 
          if(add)
	  {        
	   edgeMatrix[i][j]=2; edgeMatrix[i][k]=2;
          }
        }
      }
    }
  }

  remove(Cbutton);
  Dbutton.setBackground(Color.red);
  add(Dbutton);
  bayesNetEditor.F.pack();
  setSize(740,500);
  repaint();
}


/***************
*D. (Eliminate edges, conditioning on Possible-D-Sep)
****************/

if(evt.getSource() == Dbutton)
{ 
   outputLine[0] = new StringBuffer("Fci: Part D"); 
   outputLine[1] = new StringBuffer("Please wait");
   noutlines = 2; 
   bayesNetEditor.F.pack();
   setSize(740,500);
   repaint();

  //CHECK
  checkDSep=new Vector[currspots];
  for(int i=0;i<currspots;i++)
  {
    Vector checkD=new Vector();
    checkDSep[i]=checkD;
  }
  
  //Initialize possDSep Vector of Vector array
  possDSep=new Vector[currspots];
  for(int i=0;i<currspots;i++)
  {
    Vector possD=new Vector();
    possDSep[i]=possD;
  }

  //Initialize
  checkQuadr=new Vector[currspots];
  for(int i=0;i<currspots;i++)
  {
    Vector check=new Vector();
    checkQuadr[i]=check;
  }
  
  //Fill initQuadr
  Vector[] initQuadr=initPossQuadr(); 

  //Fill possDSep Vector array
  possDQuadr(initQuadr);

  remove(Dbutton);
  D1button.setBackground(Color.red);
  add(D1button);
  outputLine[0] = new StringBuffer("Fci: Part D"); 
  outputLine[1] = new StringBuffer("Click on \"Condition on Possible-D-Sep\", to continue ");
  noutlines = 2; 
  bayesNetEditor.F.pack();
  setSize(740,500);
  repaint();

  //Values for step D1
  iterTot=0; 
  MaxNumAdj=1;
}

if(evt.getSource() == D1button)
{
   outputLine[0] = new StringBuffer("Fci: Part D"); 
   outputLine[1] = new StringBuffer("Checked for independence between variables, conditioning on:");
   outputLine[2] = new StringBuffer("Subsets T of the Possible-D-Sep(A,B) without {A,B} of size: "+iterTot);
   noutlines = 3;
   repaint();

  //Stop criteria
  if(iterTot==MaxNumAdj)
  {
     outputLine[0] = new StringBuffer("There are no more edges to remove"); 
     outputLine[1] = new StringBuffer("Click on \"Orient o-o\", to continue");   
     noutlines = 2;
     remove(D1button);
     Ebutton.setBackground(Color.red);
     add(Ebutton);
     bayesNetEditor.F.pack();
     setSize(740,500);
     repaint();
     return;
  }

  g2test = new G2stat_test(currspots);

  //while... we press the "Next" button for that loop -->iter=0
    for(int i=0;i<currspots;i++)
    {//A
      for(int j=0;j<currspots;j++)
      {//B
	if(numAdj_j(i,j)>MaxNumAdj)
          MaxNumAdj=numAdj_j(i,j);

        if((i!=j)&&isEdge(i,j)&&(numAdj_j(i,j)>iterTot-1))
        {//C       
          //Vector containing the adjacencies of i except j 
          Vector Z=new Vector();

          Z=setPossDSepAdj_j(i,j);
          System.out.println("\nZ "+Z);
          int q=0;
          Vector T=new Vector(); 
          updateEdgeMatrix(Z,i,j,iterTot+1,q,T);
        }//C
      }//B
    }//A
    //Total number of searches done (n in paper)
    iterTot++;
  //end while click
    repaint();
}

/***************
*E. (Orient each edge as o-o
****************/

if(evt.getSource() == Ebutton)
{ 
  outputLine[0] = new StringBuffer("Fci: Part E"); 
  outputLine[1] = new StringBuffer("Orient each edge as o-o");
  outputLine[2] = new StringBuffer("Click on \"Orient as *-*\", to continue");   
  noutlines = 3; 


  //Print  out edgeMatrix  on screen
  System.out.println("edgeMatrix: ");

  for(int i=0;i<currspots;i++)
  {
    for(int j=0;j<currspots;j++)
    {
      if(edgeMatrix[i][j]!=0)
      {
        edgeMatrix[i][j]=3;
      }
      System.out.print(edgeMatrix[i][j]+" "); 
    }  
    System.out.print("\n");
  }
  
  remove(Ebutton);
  Fbutton.setBackground(Color.red);
  add(Fbutton);
  bayesNetEditor.F.pack();
  setSize(740,500);
  repaint();
}

/***************
*F. (Orient each edge as o-o
****************/

if(evt.getSource() == Fbutton)
{ 
  outputLine[0] = new StringBuffer("Fci: Part F"); 
  outputLine[1] = new StringBuffer("Orient each edge as *-*");
  outputLine[2] = new StringBuffer("Click on \"sdasdfasdfs\", to continue");   
  noutlines = 3; 

  boolean add=true;

  //Print  out edgeMatrix  on screen
  System.out.println("edgeMatrix: ");
  for(int i=0;i<currspots;i++)
  {
    for(int j=0;j<currspots;j++)
    {
      System.out.print(sepSet[i][j]+" "); 
    }  
    System.out.print("\n");
  }

  for(int i=0;i<currspots;i++)
    for(int j=0;j<currspots;j++)
      for(int k=0;k<currspots;k++)
      { 
        if((i!=j)&&(i!=k)&&(j!=k)&&(isEdge(i,j))&&(isEdge(i,k))&&(!isEdge(j,k)))
	{
          //Work around, since sepSet[j][k].contains(varArray[i].name) does not work
          add=true;
          for(int l=0;l<sepSet[j][k].size();l++)
          {    
            Vector temp1=new Vector();
            temp1.addElement(varArray[i].name);
            if(sepSet[j][k].elementAt(l).toString().equals(temp1.toString()))
	    {
System.out.print(varArray[i].name); System.out.println(" "+i+" "+j+" "+k);
              add=false;
            }         

            if(add)
	    {         
	     edgeMatrix[i][j]=2; edgeMatrix[i][k]=2;
            }
          }
        }
      }  

  //Print  out edgeMatrix  on screen
  System.out.println("edgeMatrix: ");
  for(int i=0;i<currspots;i++)
  {
    for(int j=0;j<currspots;j++)
    {
      System.out.print(edgeMatrix[i][j]+" "); 
    }  
    System.out.print("\n");
  }
  remove(Fbutton);
  G1button.setBackground(Color.red);
  add(G1button);
  bayesNetEditor.F.pack();
  setSize(740,500);
  repaint();
}

/***************
*G. (Orient each edge as o-o
****************/

if(evt.getSource() == G1button)
{ 
  outputLine[0] = new StringBuffer("Fci: Part F"); 
  outputLine[1] = new StringBuffer("Orient each edge as o-o");
  outputLine[2] = new StringBuffer("Click on \"G (i)\", to continue");   
  noutlines = 3; 


  remove(G1button);
  G2button.setBackground(Color.red);
  add(G2button);
  bayesNetEditor.F.pack();
  setSize(740,500);
  repaint();
}
if(evt.getSource() == G2button)
{ 
  outputLine[0] = new StringBuffer("Fci: Part F"); 
  outputLine[1] = new StringBuffer("Orient each edge as o-o");
  outputLine[2] = new StringBuffer("Click on \"G (ii)\", to continue");   
  noutlines = 3; 

  remove(G2button);
  G3button.setBackground(Color.red);
  add(G3button);
  bayesNetEditor.F.pack();
  setSize(740,500);
  repaint();
}

if(evt.getSource() == G3button)
{ 
  outputLine[0] = new StringBuffer("Fci: Part F"); 
  outputLine[1] = new StringBuffer("Click on \"G (iii)\", to continue");   
  noutlines = 2; 


  setSize(740,500);
  repaint();
}
    if(evt.getSource( ) == AV) {
      if(AE.getBackground( ) == Color.gray) return;

      AV.setBackground(Color.white);
      state = NODES;
      StringBuffer sb = new StringBuffer("Add Variables:  Click where you want the variable.");
      outputLine[0] = sb;
      sb = new StringBuffer("Move Variable:  Drag variable to where you want it and let go.");
      outputLine[1] = sb;
      noutlines = 2;
      repaint( );
      return;
      }
   	 if(evt.getSource( ) == AE) {
      if(AE.getBackground( ) == Color.gray) return;
      //if(state == STORED) return;
      state = EDGES;
      outputLine[0] = new StringBuffer("ADD:  Drag from cause to effect and then let go.");
      outputLine[1] = new StringBuffer("DELETE:  click on the spot near the center of the edge.");

      noutlines = 2;
      repaint( );
      return;
      }
    if(evt.getSource( ) == GS) {
      //state = SAMPLE;
      outputLine[0] = new StringBuffer("Select sample size in dialog box.");
      noutlines = 1; 
      repaint( );
      generate = new Dialog(this, "Sample", true);
      generate.setSize(140, 220);
      generate.setLayout(new FlowLayout( ));
      goSample = new Button("Go");
      goSample.addActionListener(this);
      generate.add(new Label("Samp Size"));
      sampSizetf = new TextField(8);
      generate.add(sampSizetf);
      generate.add(new Label("File Name"));
      fileNametf = new TextField(8);
      generate.add(fileNametf);
      //CheckboxGroup JorP = new CheckboxGroup( );
      //add(new Checkbox("Java", JorP, true));
      //add(new Checkbox("Pascal", JorP, false));
      //generate.add(JorP);
      generate.add(goSample);
      generate.setVisible(true);
      return;
      }
    if(evt.getSource( ) == SI) {
      state = SIM;
      outputLine[0] = new StringBuffer("Click on a vertex for which a parameter is to be");
      outputLine[1] = new StringBuffer("estimated in a simulation.");
      noutlines = 2;
      repaint( );
      return;
      }
    if(evt.getSource( ) == ES) {
      outputLine[0] = new StringBuffer("Select file name in dialog box and push Go.");
      noutlines = 1; 
      repaint( );
      estimate = new Dialog(this, "Estimate", true);
      estimate.setSize(140, 180);
      estimate.setLayout(new FlowLayout( ));
      goEstimate = new Button("Go");
      goEstimate.addActionListener(this);
      estimate.add(new Label("File Name"));
      fileNametf = new TextField(8);
      sampSizetf = new TextField(8);
      estimate.add(fileNametf);
      estimate.add(new Label("No Cases"));
      estimate.add(sampSizetf);
      estimate.add(goEstimate);
      estimate.setVisible(true);
      return;
      }
    if(evt.getSource( ) == UP) {
      outputLine[0] = new StringBuffer("Click on a variable to define a value for it.");
      outputLine[1] = new StringBuffer("Then click Next to select another variable.");
      outputLine[2] = new StringBuffer("Or click Done to update the network.");
      noutlines = 3;
      repaint( );
      state = EVID;
      for(int i = 0; i < currspots; i++)
        evidence[i] = -1;
      return;
      }
    if(evt.getSource( ) == IV) {
      outputLine[0] = new StringBuffer("Click on a variable to define a value for it.");
      outputLine[1] = new StringBuffer("Then click Next to select another variable.");
      outputLine[2] = new StringBuffer("Or click Done to apply the intervention.");
      noutlines = 3;
      repaint( );
      state = INTER;
      for(int i = 0; i < currspots; i++)
        manipulation[i] = -1;
      return;
      }      
    if(evt.getSource( ) == CL) {

//Reset when clicked on Clear
  vnames = new String[MAXSPOTS];  
  vcolors = new Color[MAXSPOTS];
  valueNames = new String[MAXSPOTS][MAXVALUES];
  nvalues = new int[MAXSPOTS];
  valNamesSet = new boolean[MAXSPOTS];
  values = new int[MAXSPOTS];
  edgeMatrix = new int[MAXSPOTS][MAXSPOTS];
  total_num_variable=0;
  iterTot=0; 
  data = new int[MAXINPUT][total_num_variable];
  varArray = new Variable[total_num_variable];      

 
  xnode = -1;
  ynode = -1;
  oldx = -1;
  oldy = -1;
  cnodes = new int[MAXSPOTS];
  condSet = new nodeList(cnodes);

  state = NODES;
  
  currspots = 0;
  readyNewNode = true;
  probsEdited = false;
  modified = false;
  V = new Vertex[MAXSPOTS];

  starts = new Point[MAXEDGES];
  ends = new Point[MAXEDGES];
  centers = new Point[MAXEDGES];
  ecolors = new Color[MAXEDGES];
  currentpoint = null;
  currlocation = null;
  startVertex = new int[MAXEDGES];
  endVertex = new int[MAXEDGES];
  currline = 0;
  selected = -1;
  selectedEdge = -1; 
  evidence = new int[MAXSPOTS];
  manipulation = new int[MAXSPOTS];

/*
      for(int i = 0; i < MAXSPOTS; i++) {
        valNamesSet[i] = false;
        nvalues[i] = 2;
        valueNames[i][0] = "value0";
        valueNames[i][1] = "value1";
        for(int j = 0; j < MAXSPOTS; j++) edgeMatrix[i][j] = 0;
        }
*/
      //storeGraph( );
      currentpoint = null;
      outputLine[0] = new StringBuffer("Click on a Button to enter or modify network.");
      outputLine[1] = new StringBuffer("Instructions for the selected button will appear here.");
      noutlines = 2;
      repaint( );
      return;
      }
    if(evt.getSource( ) == ED) {
      state = EDIT;
      outputLine[0] = new StringBuffer("By clicking on a variable, you will be able to:");
      outputLine[1] = new StringBuffer("  1) Specify/change the name of the variable");
      outputLine[2] = new StringBuffer("  2) change the number of values (default 2)");
      outputLine[3] = new StringBuffer("  3) enter/change the names of the values");
      noutlines = 4;
      repaint( );
      return;
      }
    if(evt.getSource( ) == CD) {
      state = DIST;
      outputLine[0] = new StringBuffer("By clicking on a variable, you will be able to");
      outputLine[1] = new StringBuffer("display and/or edit probability distribution of the");
      outputLine[2] = new StringBuffer("variable condition on its parents.  Be sure that");
      outputLine[3] = new StringBuffer("you have finished entering vertices, edges and numbers");
      outputLine[4] = new StringBuffer("of values before editing conditional distributions");
      noutlines = 5;
      repaint( );
      return;
      }
    if(evt.getSource( ) == DN) {
      this.setVisible(false);
      System.exit(0);
      }
    if(evt.getSource( ) == goSample) {
      int ss = Integer.valueOf(sampSizetf.getText( )).intValue( );
      bayesNetSample bns = new bayesNetSample(B, ss);
      fileName = fileNametf.getText( );
      bns.genSample(-10);
      bns.writeSample(fileName);
      generate.setVisible(false);
      return;
      }
    if(evt.getSource( ) == SX) {
      state = SELX;
      return;
      }
    if(evt.getSource( ) == SY) {
      state = SELY;
      return;
      }
    if(evt.getSource( ) == AC) {
      //if(xnode == -1 || ynode == -1) {
      //  outputLine[0] = new StringBuffer("Select X, Y first.");
      //  noutlines = 1;
      //  repaint( );
      //  return;
      //  }
      state = SELCOND;
      outputLine[0] = new StringBuffer("Select a variable to add to the conditioning set.");
      noutlines = 1;
      repaint( );
      return;
      }
    if(evt.getSource( ) == DC) {
      //if(ynode == -1) {
      //  outputLine[0] = new StringBuffer("Select X, Y first.");
      //  noutlines = 1;
      //  repaint( );
      //  return;
      //  }
      if(condSet.isEmpty( )) {
        outputLine[0] = new StringBuffer("Conditioning set is empty.");
        noutlines = 1;
        repaint( );
        return;        
        }
      state = DELCOND;
      outputLine[0] = new StringBuffer("Select variable to be deleted.");
      noutlines = 1;
      repaint( );
      return;
      }
    if(evt.getSource( ) == DS) {
      String tstring;
      String cset = "given the conditioning set:";
      state = DSEP;
      if(G.dSeparated(xnode, ynode, condSet)) 
        tstring = new String(vnames[xnode] + " and " + vnames[ynode] + " are d-separated");
      else
        tstring = new String(vnames[xnode] + " and " + vnames[ynode] + " are d-connected");
      dsepans = new Dialog(this, "Answer", true);
      dsepans.setSize(400, 90);
      dsepans.setLayout(new FlowLayout( ));
      dsepans.setBackground(Color.green);
      dsepans.add(new Label(tstring));
      if(!condSet.isEmpty( )) {
        for(int j = 0; j < currspots; j++) 
          if(condSet.isElement(j) >= 0) cset += (" " + vnames[j]);
        cset += ".";
        dsepans.add(new Label(cset));
        dsepans.setSize(350, 150);
        }
      answerOK = new Button("Reset");
      answerOK.addActionListener(this);
      answerGO = new Button("Change Problem");
      answerGO.addActionListener(this);
      dsepans.add(answerGO);
      dsepans.add(answerOK);
      dsepans.setVisible(true);
      outputLine[0] = new StringBuffer("Press Reset to define an entirely new problem.");
      outputLine[1] = new StringBuffer("Press Change Problem to modify the current problem.");
      noutlines = 2;
      repaint( );
      return;
      }
    if(evt.getSource( ) == G2) {
      outputLine[0] = new StringBuffer("Select file name in dialog box and push Go.");
      outputLine[1] = new StringBuffer("Be sure the number of variables matches the current");
      outputLine[2] = new StringBuffer("network and that the number of cases is correct.");
      noutlines = 3; 
      repaint( );
      g2dialog = new Dialog(this, "G2 Test", true);
      g2dialog.setSize(140, 180);
      g2dialog.setLayout(new FlowLayout( ));
      calcInd = new Button("Go");
      g2dialog.add(new Label("File Name"));
      fileNametf = new TextField(8);
      sampSizetf = new TextField(8);
      g2dialog.add(fileNametf);
      g2dialog.add(new Label("No Cases"));
      g2dialog.add(sampSizetf);
      g2dialog.add(calcInd);
      g2dialog.setVisible(true);
      return;
      }
    if(evt.getSource( ) == calcInd) {
      g2Result g2r;
      String t1string, t2string, t3string;
      String cset = "given the conditioning set:";
      fileName = fileNametf.getText( );
      int ncases = Integer.valueOf(sampSizetf.getText( )).intValue( );
      g2dialog.setVisible(false);
      bayesNetSample bns = new bayesNetSample(B, ncases);
      bns.readSample(fileName);
      G2stat_test g2test = new G2stat_test(bns);
      int nc = 0;
      String[] conditions = new String[condSet.nelts];
      for(int i = 0; i < currspots; i++) 
      {
        if(condSet.isElement(i) >= 0) 
          conditions[nc++] = vnames[i];
      }
      if(xnode >= 0 && ynode >= 0)
 g2r = g2test.calcIndependence(vnames[xnode], vnames[ynode], conditions, 0.95);
      else 
      {
        outputLine[0] = new StringBuffer("ERROR!  Make sure the X and Y variables and the ");
        outputLine[1] = new StringBuffer("conditioning set have been correctly defined.");
        noutlines = 2;
        repaint( );
        return;
       }
      if(g2r.probability < 0.0) {
        outputLine[0] = new StringBuffer("ERROR!  Make sure the X and Y variables and the ");
        outputLine[1] = new StringBuffer("conditioning set have been correctly defined.");
        noutlines = 2;
        repaint( );
        return;
        }
      g2ans = new Dialog(this, "G2 Test", true);
      g2ans.setSize(250, 170);
      g2ans.setLayout(new FlowLayout( ));
      g2ans.setBackground(Color.green);
      if(g2r.independent) 
        t1string = new String(vnames[xnode] + " and " + vnames[ynode] + " ARE independent.");
      else
        t1string = new String(vnames[xnode] + " and " + vnames[ynode] + " ARE NOT independent.");
      if(!condSet.isEmpty( )) {
        for(int j = 0; j < currspots; j++) 
          if(condSet.isElement(j) >= 0) cset += (" " + vnames[j]);
        cset += ",";
        g2ans.add(new Label(cset));
        g2ans.setSize(250, 200);
        }
      t2string = new String("G2 = " + g2r.g2 + " with DF = " + g2r.df);
      t3string = new String("Probability = " + g2r.probability);
      g2ansOK = new Button("Reset");
      g2ansGO = new Button("Change Problem");
      g2ans.add(new Label(t1string));
      g2ans.add(new Label(t2string));
      g2ans.add(new Label(t3string));
      g2ans.add(g2ansGO);
      g2ans.add(g2ansOK);
      g2ans.setVisible(true);
      outputLine[0] = new StringBuffer("Push Change Prob button to define new problem for same data");
      outputLine[1] = new StringBuffer("Push Reset button otherwise");
      noutlines = 2;
      repaint( );
      return;
      }
    if(evt.getSource( ) == answerGO || evt.getSource( ) == g2ansGO) {
      if(dsepans != null) dsepans.setVisible(false);
      if(g2ans != null) g2ans.setVisible(false);
      state = SELX;
      outputLine[0] = new StringBuffer("You can select new values for X and Y");
      outputLine[1] = new StringBuffer("and/or modify the conditioning set to define");
      outputLine[2] = new StringBuffer("a new d-separation or independence problem.");
      noutlines = 3;
      repaint( );
      return;
      }
    if(evt.getSource( ) == answerOK || evt.getSource( ) == g2ansOK) {
      xnode = -1;
      ynode = -1;
      oldx = -1;
      oldy = -1;
      for(int i = 0; i < MAXSPOTS; i++) vcolors[i] = Color.blue;
      int cnodes[] = new int[MAXSPOTS];
      condSet = new nodeList(cnodes);
      if(dsepans != null) dsepans.setVisible(false);
      if(g2ans != null) g2ans.setVisible(false);
      state = SELX;
      outputLine[0] = new StringBuffer("Select X.");
      noutlines = 1;
      repaint( );
      return;
      }  
    if(evt.getSource( ) == goEstimate) {
      fileName = fileNametf.getText( );
      int ncases = Integer.valueOf(sampSizetf.getText( )).intValue( );
      bayesNetSample bns = new bayesNetSample(B, ncases);
      bns.readSample(fileName);
      B.estimateDistribution(bns);
      estimate.setVisible(false);
      return;
      }
    if(evt.getSource( ) == selVar) {
      if(state == EVID) 
        evidence[selected] = cp.getSelectedIndex( );
      else if(state == INTER)
        manipulation[selected] = cp.getSelectedIndex( ); 
      vl.setVisible(false);
      outputLine[0] = new StringBuffer("Select next variable whose value is to be set.");
      noutlines = 1;
      repaint( );
      return;
      }
    if(evt.getSource( ) == doneEvidence) {
      if(state == EVID) {
        evidence[selected] = cp.getSelectedIndex( );
        outputLine[0] = new StringBuffer("Network has been updated.");
        System.out.println("Evidence = " + evidence[0] + evidence[1] + evidence[2]);
        B.update(evidence);
        }
      else if(state == INTER) {
        manipulation[selected] = cp.getSelectedIndex( );
        bayesNet B1 = B.copy( );
        manipulate(B1);
        }
      vl.setVisible(false);
      noutlines = 1;
      repaint( );
      return;
      }
    if(evt.getSource( ) == doneEdit || evt.getSource( ) == labelVals) {
      boolean graphChanged = false;
      int i = Integer.valueOf(numVals.getText( )).intValue( );
      if(nvalues[selected] != i) {
        nvalues[selected] = i;
        graphChanged = true;
        }
      vnames[selected] = varName.getText( );
      V[selected].name = vnames[selected];
      int len = vnames[selected].length( );
      if(len > 10) V[selected].rect.width = 60 + (len - 10)*8;
      //V[selected].rect.width = FontMetrics.stringWidth(vnames[selected]) + 20;
      if(!valNamesSet[selected]) 
        for(int j = 0; j < i; j++) {
          String str = new String("value"+j);
          valueNames[selected][j] = str;
          }
      if(evt.getSource( ) == doneEdit) {
//        editV.setVisible(false);
        editV.dispose();
        selected = -1;
        repaint( );
        }
      else {
        labelValues(selected);
        }
      if(graphChanged) storeGraph( );
      //else store new names only
      return;
      }
    if(evt.getSource( ) == doneNames) {
      vlabels.setVisible(false);
      for(int j = 0; j < nvalues[selected]; j++) {
        valueNames[selected][j] = vals[j].getText( );
        }
      valNamesSet[selected] = true;
      //selected = -1;
      repaint( );
      return;
      }
    if(evt.getSource( ) == storeCPTable) {
      System.out.println("StoreCPTable pushed");
      boolean updated = updateDist(selected);
      if(!updated) return;
      selected = -1;
      noutlines = 1;
      outputLine[0] = new StringBuffer("Distribution updated.");
      repaint( );
      spreadSheet.setVisible(false);
      return;
      }
    if(evt.getSource( ) == simGO) {
      if(cpm.getSelectedIndex( ) == 1 && !modified) {
        outputLine[0] = new StringBuffer("Add or delete edges.");
        outputLine[1] = new StringBuffer("Push GO when done.");
        noutlines = 2;
        repaint( );
        state = EDGES;
        modified = true;
        origB = B.copy( );
        return;
        }
      state = SIM;
      boolean sim = simulate(selected);
      modified = false;
      selected = -1;
      repaint( );
      simParams.setVisible(false);
      return;
      }
    if(evt.getSource( ) == warningOK) {
      warning.setVisible(false);
      return;
      }
    if(evt.getSource( ) == killHist) {
      state = NODES;
      outputLine[0] = new StringBuffer("Add Variables:  Click where you want the variable.");
      outputLine[1] = new StringBuffer("Move Variable:  Drag variable to where you want it and let go.");
      noutlines = 2;
      repaint( );
      HF.setVisible(false);
      return;
      }
    if(evt.getSource( ) == IN) {
      remove(GRAPHbutton);
      remove(AV);
      remove(AE);
      remove(ED);
      remove(CD);
      remove(GS);
      remove(ES);
      remove(UP);
      remove(IV);
      remove(CL);
      remove(DN);
      remove(IN);

      add(SX);
      add(SY);
      add(AC);
      add(DC);
      add(DS);
      add(G2);
      add(EN);
      //setVisible(false);
      //setVisible(true);
      noutlines = 2;
      state = SELX;
      outputLine[0] = new StringBuffer("Push the button labelled Select X");
      outputLine[1] = new StringBuffer("Then click on a variable.");
      repaint( );
      setSize(740, 505);
      return;
      }
    if(evt.getSource( ) == EN) {
      remove(SX);
      remove(SY);
      remove(AC);
      remove(DC);
      remove(DS);
      remove(G2);
      remove(EN);

      xnode = -1;
      ynode = -1;
      oldx = -1;
      oldy = -1;
      for(int i = 0; i < MAXSPOTS; i++) vcolors[i] = Color.blue;

      add(AV);
      add(AE);
      add(ED);
      add(CD);
      add(GS);
      add(ES);
      add(UP);
      add(IV);
      add(CL);
      add(DN);
      add(IN);
      StringBuffer sb = new StringBuffer("Add Variables:  Click where you want the variable.");
      outputLine[0] = sb;
      sb = new StringBuffer("Move Variable:  Drag variable to where you want it and let go.");
      outputLine[1] = sb;
      noutlines = 2;
      state = NODES;
      repaint( );
      return;
      }
    return;
  }
  return;
}

void manipulate(bayesNet B1) {
  int vertex;

  for(vertex = 0; vertex < B1.D.nvertices; vertex++) {
    if(manipulation[vertex] >= 0) {
      for(int i = 0; i < B1.D.nvertices; i++) 
        if(B1.D.edgeMatrix[vertex][i] == 2) {
          B1.D.edgeMatrix[vertex][i] = 0;
          B1.D.edgeMatrix[i][vertex] = 0;
          }
      System.out.println("Adj matrix after manipulation:");
      B1.D.findParents( );
      B1.D.displayGraph( );
      B1.tableSize[vertex] = B1.nvalues[vertex];
      B1.probs[vertex] = new float[B1.nvalues[vertex]];
      for(int i = 0; i < B1.nvalues[vertex]; i++)
        if(i == manipulation[vertex]) B1.probs[vertex][i] = (float) 1.0; 
                                      else B1.probs[vertex][i] = (float) 0.0;
      System.out.println(vnames[vertex] + " set to " + manipulation[vertex]);
      }
    }
  B = B1;
  repaint( );
  return;
  }

void labelValues(int vertex) {
  String st;
    
  vlabels = new Dialog(this, vnames[vertex], true);
  int ysize = 80 + 34*nvalues[vertex];
  vlabels.setSize(140, ysize);
  vlabels.setLayout(new FlowLayout( ));
  if(nvalues[vertex] > 0) {
    doneNames = new Button("Done");
    doneNames.addActionListener(this);
    for(int v = 0; v < nvalues[vertex]; v++) {
      TextField tf = new TextField(8);
      //tf.setText("value" + v);
      tf.setText(valueNames[vertex][v]);
      vals[v] = tf;
      vlabels.add(vals[v]);
      vlabels.add(doneNames);
    }
  vlabels.setVisible(true);
  }
}

void parentValues(int vertex) {
  int p;
  int prod[] = new int[D.nvertices];
  int np = B.D.getNumParents(vertex);
  spreadSheet = new Dialog(this, "Distributions", true);
  Label p1ablank[] = new Label[MAXSPOTS];
  Label p1bblank[] = new Label[MAXSPOTS];
  Label p2blank[] = new Label[MAXVALUES];

  probsEdited = true;
  int ncpv = 1;
  prod[0] = 1;
  if(np > 0) {
    for(p = 0; p < np; p++) {
      int par = B.D.getParent(vertex, p);
      if(p > 0) prod[p] = nvalues[par]*prod[p - 1];
      ncpv = ncpv*nvalues[par];
      }
    }
  System.out.println("ncpv = " + ncpv + " nparents = " + np + " nvalues = " + nvalues[vertex]);
  //Label blank1 = new Label("blank1");
  //Label blank2 = new Label("blank2");
  //Label blank3 = new Label("blank3");
  for(int i = 0; i < MAXSPOTS; i++) p1ablank[i] = new Label("    " + i);     
  for(int i = 0; i < MAXSPOTS; i++) p1bblank[i] = new Label("      ");     
  for(int i = 0; i < MAXVALUES; i++) p2blank[i] = new Label("      ");

  storeCPTable = new Button("Done");
  storeCPTable.addActionListener(this);
  if(np == 0) {
    spreadSheet.setLayout(new GridLayout(1, 1));
    spreadSheet.setSize(nvalues[vertex]*70, 200);
    panel2 = new Panel( );
    panel2.setLayout(new GridLayout(4, nvalues[vertex]));
    panel2.setBackground(Color.yellow);
    panel2.add(new Label("Variable"));
    panel2.add(new Label(vnames[vertex]));
    for(int i = 0; i < nvalues[vertex]; i++) {
      String tstring = new String("P(" + valueNames[vertex][i] + ")");
      panel2.add(new Label(tstring));
      //panel2.add(new Label(valueNames[vertex][i]));
      }
    for(int j = 0; j < nvalues[vertex]; j++) {
      float prob = B.conditionalProb(vertex, values, j);
      Float P = new Float(prob);
      String pst = P.toString( );
      ptf[0][j] = new TextField(8);
      ptf[0][j].setBackground(Color.white);
      ptf[0][j].setText(pst);
      panel2.add(ptf[0][j]);
      }
    panel2.add(storeCPTable);
    spreadSheet.add(panel2);
    spreadSheet.setVisible(true);
    return;
    }
  else {
    spreadSheet.setLayout(new GridLayout(1, 2));
    spreadSheet.setSize(400, 230);
    panel1 = new Panel( );
    panel1.setLayout(new GridLayout(ncpv + 3, np));
    panel2 = new Panel( );
    panel2.setLayout(new GridLayout(ncpv + 3, nvalues[vertex]));
    System.out.println("ncpv = " + ncpv + " nparents = " + np + " nvalues = " + nvalues[vertex]);
    panel1.setBackground(Color.green);
    panel2.setBackground(Color.yellow);
    //for(int i = 0; i < np; i++) panel1.add(p1ablank[i]);
    panel1.add(new Label("Parents of"));
    panel1.add(new Label(vnames[vertex]));
    for(int i = 2; i < np; i++) panel1.add(p1bblank[i]);
    panel2.add(p2blank[0]); panel2.add(new Label(vnames[vertex])); 
    for(int i = 2; i < nvalues[vertex]; i++) panel2.add(p2blank[i]);
    for(p = 0; p < np; p++) {
      int par = B.D.getParent(vertex, p);
      panel1.add(new Label(vnames[par]));
      }
    for(int i = 0; i < nvalues[vertex]; i++) {
      String tstring = new String("P(" + valueNames[vertex][i] + ")");
      panel2.add(new Label(tstring));
      //panel2.add(new Label(valueNames[vertex][i]));
      }
    for(int i = 0; i < ncpv; i++) {
      int rem = i;
      for(int j = 0; j < np; j++) {
        int par = B.D.getParent(vertex, j);
        values[j] = rem/prod[np - j - 1];
        panel1.add(new Label(valueNames[par][values[j]]));
        rem = rem % prod[np - j - 1];
        }
      for(int j = 0; j < nvalues[vertex]; j++) {
        float prob = B.conditionalProb(vertex, values, j);
        Float P = new Float(prob);
        String pst = P.toString( );
        ptf[i][j] = new TextField(8);
        ptf[i][j].setBackground(Color.white);
        ptf[i][j].setText(pst);
        panel2.add(ptf[i][j]);
        }
      }
    panel1.add(storeCPTable);
    spreadSheet.add(panel1);
    spreadSheet.add(panel2);
    spreadSheet.setVisible(true);
    //push storeCPTable implies call updateDist (new version)
    return;
  }
} 

boolean updateDist(int vertex) {
  int p;
  int prod[] = new int[D.nvertices];
  int np = B.D.getNumParents(vertex);

  int ncpv = 1;
  prod[0] = 1;
  if(np > 0) {
    for(p = 0; p < np; p++) {
      int par = B.D.getParent(vertex, p);
      if(p > 0) prod[p] = nvalues[par]*prod[p - 1];
      ncpv = ncpv*nvalues[par];
      }
    }
  for(int i = 0; i < ncpv; i++) {
    float sum = (float) 0.0;
    int rem = i;
    for(int j = 0; j < np; j++) {
      values[j] = rem/prod[np - j - 1];
      rem = rem % prod[np - j - 1];
      }
    for(int j = 0; j < nvalues[vertex]; j++) {
      float prob = Float.valueOf(ptf[i][j].getText( )).floatValue( );
      //System.out.println("For " + valueNames[vertex][j] + " p = " + prob);
      sum = sum + prob;
      B.storeConditionalProb(vertex, values, j, prob);
      }
    if(sum > 1.0 || sum < 0.98) {
      warning = new Dialog(this, "Warning", true);
      warning.setSize(350, 90);
      warning.setLayout(new FlowLayout( ));
      warning.setBackground(Color.pink);
      warning.add(new Label("In each row probabilities must sum to 1.0"));
      warningOK = new Button("OK");
      warningOK.addActionListener(this);
      warning.add(warningOK);
      warning.setVisible(true);
      outputLine[0] = new StringBuffer("In each row probabilities must sum to 1.0");
      noutlines = 1;
      repaint( );
      return false;
      }
    }
  return true;
  }

void simSetup(int vertex) {
  B.randomConditionalDistribution(-39);
  outputLine[0] = new StringBuffer("Select a parameter to estimate:");
  outputLine[1] = new StringBuffer("First select a value of the variable,");
  outputLine[2] = new StringBuffer("Then set the sample size and the number of samples.");
  outputLine[3] = new StringBuffer("Finally select values of the variables parents.");
  noutlines = 4;
  repaint( );
  simParams = new Dialog(this, "Setup", false);
  int np = B.D.getNumParents(vertex);
  simParams.setSize(100, 250 + 100*np);
  simParams.setLayout(new FlowLayout( ));
  simParams.setBackground(Color.white);
  simParams.add(new Label(vnames[vertex]));
  cp = new Choice( );
  for(int i = 0; i < nvalues[vertex]; i++)
    cp.add(valueNames[vertex][i]);
  simParams.add(cp);
  simParams.add(new Label("Samp Size"));
  sampSizetf = new TextField("100", 8);
  simParams.add(sampSizetf);
  simParams.add(new Label("# Samps"));
  numSampstf = new TextField("5", 8);
  simParams.add(numSampstf);
  simParams.add(numSampstf);
  simParams.add(new Label("Parents:"));
  for(int p = 0; p < np; p++) {
   int par = B.D.getParent(vertex, p);
   simParams.add(new Label(vnames[par]));
   cpp[p] = new Choice( );
   for(int j = 0; j < nvalues[par]; j++)
     cpp[p].add(valueNames[par][j]);
   simParams.add(cpp[p]);
   }
  simParams.add(new Label("Modify graph?"));
  cpm = new Choice( );
  cpm.add("No");
  cpm.add("Yes");
  simParams.add(cpm);
  simGO = new Button("GO");
  simGO.addActionListener(this);
  simParams.add(simGO);
  modified = false;
  simParams.setVisible(true);
  System.out.println("Did it show up?");
  return;
  }

boolean simulate(int vertex) {
  int ss, ns, val, np;
  bayesNet tempB;
  ss = Integer.valueOf(sampSizetf.getText( )).intValue( );
  ns = Integer.valueOf(numSampstf.getText( )).intValue( );
  val = cp.getSelectedIndex( );

  tempB = B;
  if(modified) {
    B = origB;
    System.out.println("Original graph(B):");
    B.D.displayGraph( );
    System.out.println("Modified graph (tempB):");
    tempB.D.displayGraph( );
    }

  np = B.D.getNumParents(vertex);
  for(int p = 0; p < np; p++)
    values[p] = cpp[p].getSelectedIndex( );
  System.out.println("Parameter to test:");
  System.out.println("  P(" + vnames[vertex] + " = " + valueNames[vertex][val] + ")");
  System.out.println("Given:  ");
  for(int p = 0; p < np; p++) {
    int par = B.D.getParent(vertex, p);
    System.out.println("   " + vnames[par] + " = " + valueNames[par][values[p]]);
    }

  double parameter = B.conditionalProb(vertex, values, val);
  double phat;
  float dataPoints[] = new float[ns];
  int numBins = 10;
  for(int i = 0; i < ns; i++) {
    bayesNet B1 = B.copy( );
    bayesNetSample bns = new bayesNetSample(B1, ss);
    bns.genSample((long) -11*(i+1));
    if(modified) {
      tempB.estimateDistribution(bns);
      for(int j = 0; j < tempB.D.nvertices; j++)
        evidence[j] = -1;
      for(int p = 0; p < np; p++) {
        int par = B.D.getParent(vertex, p);
        evidence[par] = values[p];
        }
      tempB.update(evidence);
      phat = tempB.updatedProb(vertex, val); 
      }
    else {
      B1.estimateDistribution(bns);
      phat = B1.conditionalProb(vertex, values, val);
      }
    //double se = (parameter - phat)*(parameter - phat);
    double error = parameter - phat;
    System.out.println("Iteration " + i + " Error = " + error);
    dataPoints[i] = (float) error;
    }
  HF = new Frame("Histogram");
  killHist = new Button("OK");
  killHist.addActionListener(this);
  HF.setSize(500, 600);
  HF.setLayout(new BorderLayout( ));
  Histogram H = new Histogram(ns, numBins, dataPoints);
  H.setBackground(Color.yellow);
  HF.add("Center", H);
  HF.add("South", killHist);
  H.repaint( );
  HF.setVisible(true);
  noutlines = 1;
  outputLine[0] = new StringBuffer("Click OK after examining Histogram.");
    System.out.println("Original graph(B):");
    B.D.displayGraph( );
    System.out.println("Modified graph (tempB):");
    tempB.D.displayGraph( );

  if(modified) {
    currline = 0;
    for(int i = 0; i < B.D.nvertices; i++)
      for(int j = 0; j < B.D.nvertices; j++) {
        if(B.D.edgeMatrix[i][j] == 1) {
          currline++;
          drawEdge(V[i].rect, V[j].rect);
          starts[currline] = from;
          ends[currline] = to;
          startVertex[currline] = i;
          endVertex[currline] = j;
          centers[currline] = new Point(((V[i].rect.x + V[i].rect.width/2) + (V[j].rect.x + V[j].rect.width/2))/2,
             ((V[i].rect.y + V[i].rect.height/2) + (V[j].rect.y + V[j].rect.height/2))/2);
          }
      edgeMatrix[i][j] = B.D.edgeMatrix[i][j];
      }
    }
  repaint( );
  System.out.println("currline = " + currline);
  Date dtime = new Date( );
  System.out.println("Date = " + dtime);
  return true;
  }

void getValue(int vertex) {
  vl = new Dialog(this, "Value", true);
  vl.setSize(140, 115);
  vl.setLayout(new FlowLayout( ));
  vl.setBackground(Color.white);
  vl.add(new Label(vnames[vertex]));
  cp = new Choice( );
  for(int i = 0; i < nvalues[vertex]; i++)
    cp.add(valueNames[vertex][i]);
  vl.add(cp);
  selVar = new Button("Next");
  selVar.addActionListener(this);
  doneEvidence = new Button("Done");
  doneEvidence.addActionListener(this);
  vl.add(selVar);
  vl.add(doneEvidence);
  vl.setVisible(true);
  return;
}

double dist(Point p1, Point p2) {
  double d = 0.0;
  d =  (p1.x - p2.x)*(p1.x - p2.x);
  d += (p1.y - p2.y)*(p1.y - p2.y);
  d = Math.sqrt(d);
  return d;
}

void drawEdge(Rectangle r1, Rectangle r2) {
//Draws an edge from one rectangle to another with a line which goes between their
//centers but which ends on the sides with an arrow at the child vertex.
//Assumes rectangles do not overlap.
  int xcenter1, ycenter1, xcenter2, ycenter2;
  double m, b;
  int fromx, fromy, tox, toy;
  int c1x, c1y, c2x, c2y, c3x, c3y, c4x, c4y;
  int n1, n2;
  double min;
  Point c1[] = new Point[4];
  Point c2[] = new Point[4];

  xcenter1 = (int) (r1.x + r1.width/2.0);
  ycenter1 = (int) (r1.y + r1.height/2.0);
  xcenter2 = (int) (r2.x + r2.width/2.0);
  ycenter2 = (int) (r2.y + r2.height/2.0);
  n1 = n2 = 0;
  min = 10000.0;

  if(xcenter1 == xcenter2) {
    if(ycenter1 > ycenter2) {
      fromx = xcenter1;
      fromy = (int) (ycenter1 - r1.height/2.0);
      tox = xcenter2;
      toy = (int) (ycenter2 + r2.height/2.0);
      from = new Point(fromx, fromy);
      to = new Point(tox, toy);
      return;
      }
    else {
      fromx = xcenter1;
      fromy = (int) (ycenter1 + r1.height/2.0);
      tox = xcenter2;
      toy = (int) (ycenter2 - r2.height/2.0);
      from = new Point(fromx, fromy);
      to = new Point(tox, toy);
      return;
      }
    }
  else {
    m = ((double) (ycenter2 - ycenter1))/((double) (xcenter2 - xcenter1));
    //b = ycenter1 - m*xcenter1;
    b = (double) (ycenter2 - xcenter2*m);
    
    //Rectangle 1
    c1x = r1.x; c1y = (int) (m*c1x + b);
    c2x = r1.x + r1.width; c2y = (int) (m*c2x + b);
    c3y = r1.y;  c3x = (int) ((c3y - b)/m);
    c4y = r1.y + r1.height; c4x = (int) ((c4y - b)/m);
    Rectangle box1 = new Rectangle(c1x-2, c1y-2, 4, 4);
    Rectangle box2 = new Rectangle(c2x-2, c2y-2, 4, 4);
    Rectangle box3 = new Rectangle(c3x-2, c3y-2, 4, 4);
    Rectangle box4 = new Rectangle(c4x-2, c4y-2, 4, 4);
    if(r1.intersects(box1)) { 
      c1[n1] = new Point(c1x, c1y);
      n1++;
      }
    if(r1.intersects(box2)) {
      c1[n1] = new Point(c2x, c2y);
      n1++;
      }    
    if(r1.intersects(box3)) {
      c1[n1] = new Point(c3x, c3y);
      n1++;
      }    
    if(r1.intersects(box4)) {
      c1[n1] = new Point(c4x, c4y);
      n1++;
      }
    if(n1 == 0) from = new Point(r1.x, r1.y);  

    //Rectangle 2
    c1x = r2.x; c1y = (int) (m*c1x + b);
    c2x = r2.x + r2.width; c2y = (int) (m*c2x + b);
    c3y = r2.y;  c3x = (int) ((c3y - b)/m);
    c4y = r2.y + r2.height; c4x = (int) ((c4y - b)/m);
    Rectangle box5 = new Rectangle(c1x-2, c1y-2, 4, 4);
    Rectangle box6 = new Rectangle(c2x-2, c2y-2, 4, 4);
    Rectangle box7 = new Rectangle(c3x-2, c3y-2, 4, 4);
    Rectangle box8 = new Rectangle(c4x-2, c4y-2, 4, 4);
    if(r2.intersects(box5)) { 
      c2[n2] = new Point(c1x, c1y);
      n2++;
      }
    if(r2.intersects(box6)) {
      c2[n2] = new Point(c2x, c2y);
      n2++;
      }    
    if(r2.intersects(box7)) {
      c2[n2] = new Point(c3x, c3y);
      n2++;
      }    
    if(r2.intersects(box8)) {
      c2[n2] = new Point(c4x, c4y);
      n2++;
      }
    if(n2 == 0) to = new Point(r2.x, r2.y);  
  } 
  if(n1 == 0) { System.out.println("n1=0"); to = new Point(r2.x, r2.y); return; }
  if(n2 == 0) { System.out.println("n2=0"); from = new Point(r1.x, r1.y); return; }
  for(int i = 0; i < n1; i++)
    for(int j = 0; j < n2; j++) {
      if(dist(c1[i], c2[j]) < min) {
        min = dist(c1[i], c2[j]);
        from = c1[i];
        to = c2[j];
        }
    }
  return;
}

int closestSpot(Point p) {
  //double dmin = 10000.0;
  //double dtest;
  int result = 0;
  //Point closest;

  for(int j =0; j < currspots; j++) {
    //closest = new Point(V[j].rect.x, V[j].rect.y);
    //dtest = dist(p, closest);
    //if( dtest < dmin) {
    //  dmin = dtest;
      if(V[j].rect.contains(p.x, p.y)) result = j;
    //  }
   }
  return result;
}

int closestEdge(Point p) {
  double dmin = 10000.0;
  double dtest;
  int result = -1;
  Point closest;

  for(int j =0; j < currline; j++) {
    closest = centers[j];
    dtest = dist(p, closest);
    if( dtest < dmin) {
      dmin = dtest;
      result = j;
      }
   }
  if(dmin > THRESH) result = -1;
  return result;
}

void editVertex(int vertex) {
  editV = new Dialog(this, "Edit", true);
  editV.setSize(125, 260);
  editV.setLayout(new FlowLayout( ));
  doneEdit = new Button("OK");
  doneEdit.addActionListener(this);
  labelVals = new Button("Label Vals?");
  labelVals.addActionListener(this);
  editV.add(new Label("Name"));
  varName = new TextField(8);
  varName.setText(V[vertex].name);
  editV.add(varName);
  editV.add(new Label("Num Vals"));
  numVals = new TextField(8);
  Integer nvals = new Integer(nvalues[vertex]);
  String st = nvals.toString( );
  numVals.setText(st);
  editV.add(numVals);
  editV.add(labelVals);
  editV.add(doneEdit);
  editV.setVisible(true);
  return;
}

void addspot(int x, int y, StringBuffer l) {
  if(readyNewNode) {
    readyNewNode = false;
    String st = new String(l);
    Rectangle r = new Rectangle(x, y, 60, 20);
    for(int i = 0; i < currspots; i++) {
      if(r.intersects(V[i].rect)) return;
      }
    vnames[currspots] = st;
    vcolors[currspots] = Color.blue;
    V[currspots] = new Vertex(r, st);
    currspots++;
    storeGraph( );
    if(currspots > 0) {
      ED.setBackground(Color.white);
      CD.setBackground(Color.white);
      CL.setBackground(Color.white);
      GS.setBackground(Color.white);
      SI.setBackground(Color.white);
      ES.setBackground(Color.white);
      UP.setBackground(Color.white);
      IV.setBackground(Color.white);
      IN.setBackground(Color.white);
      }
    if(currspots > 1) AE.setBackground(Color.white);
    repaint( );
    }
  }

void addline(int x, int y) {
  Point start;
  Point end;
  //Point from;
  //Point to;

  start = anchor;
  end = new Point(x, y);
  int i = closestSpot( start );
  int j = closestSpot( end );
  //from = new Point(V[i].rect.x, V[i].rect.y);
  //to = new Point(V[j].rect.x, V[j].rect.y);
  drawEdge(V[i].rect, V[j].rect);

  if(dist(start, from) > THRESH || dist(end, to) > THRESH) {
    System.out.println("Not an edge");
    return;
    } 
  int tedgeMatrix[][] = new int[MAXSPOTS][MAXSPOTS];
  for (int k = 0; k < MAXSPOTS; k++)
    for (int l = 0; l < MAXSPOTS; l++)
      tedgeMatrix[k][l] = edgeMatrix[k][l];
  tedgeMatrix[i][j] = OUTOF;
  tedgeMatrix[j][i] = INTO;
  D = new diGraph(currspots, tedgeMatrix, graphName, vnames);

  if(D.isCyclic( )) {
    outputLine[2] = new StringBuffer("Adding edge would make digraph cyclic.");
    noutlines = 3;
    currentpoint = null;
    repaint( );
    return; }  
  else {
    starts[currline] = from;
    ends[currline] = to;
    startVertex[currline] = i;
    endVertex[currline] = j;
    centers[currline] = 
       new Point(((V[i].rect.x + V[i].rect.width/2) + (V[j].rect.x + V[j].rect.width/2))/2,
                 ((V[i].rect.y + V[i].rect.height/2) + (V[j].rect.y + V[j].rect.height/2))/2);
    //centers[currline].x = 
    //            ((V[i].rect.x + V[i].rect.width/2) + (V[j].rect.x + V[j].rect.width/2))/2;
    //centers[currline].y =
    //            ((V[i].rect.y + V[i].rect.height/2) + (V[j].rect.y + V[j].rect.height/2))/2;
    ecolors[currline] = Color.blue;

    edgeMatrix[i][j] = OUTOF;
    edgeMatrix[j][i] = INTO;
    storeGraph( );
    currline++;
System.out.println(currline);

    //if(currline > 0) SG.setBackground(Color.white);
    currentpoint = null;
    noutlines = 2;
    repaint( );
    }
}

void storeGraph( ) {
  G = new diGraph(currspots, edgeMatrix, graphName, vnames);
  G.displayGraph( );
  B = new bayesNet(G, nvalues);
  B.D.setupTiers( );
  B.D.findParents( );
  B.defaultCondDist( );
  return;
  }

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//Check GRAPH                            
//Create vertice positions
void verticePositions(int n)
{
  /*
  This function calculates the vertex positions on a circle given the number of vertices
  and creates the rectangle objects
   */

  //n, of nodes
  int x_center = 300;
  int x = 0;
  int y_center = 240	;
  int y = 0;
  int rad = 130;
  //x[i], y[i] = x and y coords of i-th vertex
  V=new Vertex[n];
  for(int i=0; i<n;i++)
  {
    double d=(i+1)*360*java.lang.Math.pow(n*57.2958,-1);
    //System.out.println(d);
    double d1= rad*java.lang.Math.cos(d);
    double d2= rad*java.lang.Math.sin(d);
    Double D1= new Double(d1);
    int x1 = D1.intValue();
    Double D2= new Double(d2);
    int y1 = D2.intValue();
    x = x_center +x1;
    y = y_center +y1;
    //System.out.println(x+" "+y);
    Rectangle r = new Rectangle(x,y,50,20);
    StringBuffer l = new StringBuffer("A"+i);
    String st = new String(l);
    V[i]=new Vertex(r,st);
  }
}

void drawEdgeS()
{
  /*
  This function draws edges between all rectangles
   */

  for(int i=0;i<currspots;i++)
    for(int j=i+1;j<currspots;j++)
    {
      //give points: from and two on rectangle border
      //startVertex endVertex remembers the number of the corresponding rectangle
      drawEdge(V[i].rect,V[j].rect);
      starts[currline]=from;
      startVertex[currline]=i;
      ends[currline]=to;  
      endVertex[currline]=j;
      centers[currline] = new Point(((V[i].rect.x + V[i].rect.width/2) +
                                   (V[j].rect.x + V[j].rect.width/2))/2,
                                   ((V[i].rect.y + V[i].rect.height/2) + 
                                   (V[j].rect.y + V[j].rect.height/2))/2);
      ecolors[currline] = Color.blue;
      currline++;
    }
}

//Function that checks only if there is a direkt edge between two vertices
boolean isEdge(int i, int j)
{
  /*
  This function checks if there is an edge between i and j
  */
  if(edgeMatrix[i][j]!=0 && edgeMatrix[j][i]!=0)
    return true;
  else;
    return false;
}

Vector setAdj_j(int i, int j)
{
  /*
  This function returns a vector with the adjacencies of i\j
   */
  Vector Z=new Vector();
  for(int k=0;k<currspots;k++)
  {
    if((k!=i)&&(k!=j)&&(edgeMatrix[i][k]!=0))
    {
       Z.addElement(varArray[k].name);
     }
   }
    return Z;
}

Vector setPossDSepAdj_j(int i, int j)
{
  /*
  This function returns a vector with the adjacencies of i\j
  */
  Vector Z=new Vector();
  for(int k=0;k<currspots;k++)
  {
    Integer temp=new Integer(k);
    if((k!=i)&&(k!=j)&&possDSep[i].contains(temp.toString())&&possDSep[j].contains(temp.toString()) )
    {      
      Z.addElement(varArray[k].name);
     }
   }
    return Z;
}

Vector setAdj(int i)
{
  /*
  This function returns a vector with the adjacencies of i
   */
  Vector Z=new Vector();
  for(int k=0;k<currspots;k++)
  {
    if((k!=i)&&(edgeMatrix[i][k]!=0))
    {
       Z.addElement(varArray[k].name);
     }
   }
    return Z;
}


int numAdj_j(int i,int j)
{
  /*
  This function counts the number of Adjacencies of i\j
  */
 int m=0;
  for(int k=0;k<currspots;k++)
  {
    if((k!=i)&&(k!=j)&&isEdge(i,k))
    m++; 
  }
  return m;
}


Vector[] initPossQuadr()
{
  //Creating a Vector array of Vector that will contain the initial quadruples
  //Vector initQuadr contains Vectors that will contain the quadruples
  Vector[] initQuadr=new Vector[currspots];
  for(int i=0;i<currspots;i++)
  {
    Vector init =new Vector();
    initQuadr[i]=init;
  }

  //For any node i find all possible triples by selecting node i and test any two adjacent
  // node j and k, then store it as initial quadruples <i,j,j,k> and <k,j,j,i> (symmetry)
  Vector Z=new Vector(); 
  for(int i=0;i<currspots;i++)
  {
    Z=setAdj(i);
    //Instead of looping over all we could permute the corresponding vector - maybe later
    //We run the iteration not over the symmetry

    for(int j=0;j<currspots;j++)
    {
      for(int k=0;k<currspots;k++)
      {
        //Test if Triangle or Collider&& Z.contains(varArray[k].name) && Z.contains(varArray[j].name)
/*
System.out.print("varArray[i]"+varArray[i].name);
System.out.print(" varArray[j]"+varArray[j].name);
System.out.print(" varArray[k]"+varArray[k].name);
System.out.print(" Z contains [j]"+Z.contains(varArray[j].name));
System.out.print(" Z contains [k]"+Z.contains(varArray[k].name));
System.out.print(" ");
System.out.print(edgeMatrix[j][i]==2);
System.out.print(" ");
System.out.print(edgeMatrix[i][j]==2);
System.out.print(" ");
System.out.println(isEdge(i,k));
*/
        if((i!=j)&&(i!=k)&&(j!=k)&& Z.contains(varArray[j].name)
                        && ((edgeMatrix[j][i]==2) && (edgeMatrix[j][k]==2)||isEdge(i,k)))
	{
	  //CHECK create quadruple
           Vector quadr1 = new Vector(4);
           quadr1.addElement(varArray[i].name); quadr1.addElement(varArray[j].name);
           quadr1.addElement(varArray[j].name); quadr1.addElement(varArray[k].name);	   

           Vector quadr = new Vector(4);
           Integer quadr11=new Integer(i);
           Integer quadr23=new Integer(j);
           Integer quadr44=new Integer(k);

           //Add as new quadruple
           quadr.addElement(quadr11.toString());  quadr.addElement(quadr23.toString());
           quadr.addElement(quadr23.toString());  quadr.addElement(quadr44.toString());	   

           //Insert quadruple at the end of the Vector initQuadr[i]
           initQuadr[i].addElement(quadr);

           //CHECK
           //Insert quadruple at the end of the Vector initQuadr[i]
           checkQuadr[i].addElement(quadr1);
           //if(!initQuadr1[i].contains(varArray[k].name))
	   //checkQuadr[i].addElement(varArray[k].name);

           //Add also just the endpoints
           if(!possDSep[i].contains(quadr44.toString()))
             possDSep[i].addElement(quadr44.toString());
        }
      }//k
    }//j
    //   
  }//i

/*  for(int i=0;i<currspots;i++)
  { 
   System.out.println("Initial quadruples: "+initQuadr[i]);
   //CHECK
   System.out.println(" or: "+checkQuadr[i]);
   System.out.println("Nodes in the set of possible D-Sep: "+possDSep[i]);
  }
  */
  return initQuadr;
}

void possDQuadr(Vector[] possQuadr)
{
  String quadr11,quadr12,quadr13,quadr14,quadr22,quadr23,quadr24;
  Integer quadr13I; int quadr13i;
  boolean change,add;

  Integer check11;  int check11i;
  Integer check12;  int check12i;
  Integer check23;  int check23i;
  Integer check24;  int check24i;

  while(true)
  {
    change=false;
    for(int i=0;i<currspots;i++)
    { 
      for(int j=0;j<possQuadr[i].size();j++)
      {
        //The entrees of the first quadruple as Strings
        quadr11=possQuadr[i].elementAt(j).toString().substring(1,2);
        quadr12=possQuadr[i].elementAt(j).toString().substring(4,5);
        quadr13=possQuadr[i].elementAt(j).toString().substring(7,8); 
        quadr14=possQuadr[i].elementAt(j).toString().substring(10,11);

        //For this entree we also need the integer value
        quadr13I=new Integer(possQuadr[i].elementAt(j).toString().substring(7,8));
        quadr13i=quadr13I.intValue();

        //CHECK: The entrees of the quadruple we would like to connect as Strings
        check11=new Integer(quadr11); check11i=check11.intValue();
        check12=new Integer(quadr12); check12i=check12.intValue();

        for(int k=0;k<possQuadr[quadr13i].size();k++)
        {
	  //The entrees of the quadruple we would like to connect a Strings

          quadr22=possQuadr[quadr13i].elementAt(k).toString().substring(4,5);
          quadr23=possQuadr[quadr13i].elementAt(k).toString().substring(7,8);
          quadr24=possQuadr[quadr13i].elementAt(k).toString().substring(10,11);

	  //CHECK: The entrees of the quadruple we would like to connect a Strings
          check23=new Integer(quadr23); check23i=check23.intValue();
          check24=new Integer(quadr24); check24i=check24.intValue();  

          if((!quadr11.equals(quadr23))&&(!quadr11.equals(quadr24))&&quadr22.equals(quadr14))
          {
            //Compare the two quadruples...
            Vector quadr = new Vector(4);
            quadr.addElement(quadr11);  quadr.addElement(quadr12);
            quadr.addElement(quadr23);  quadr.addElement(quadr24);

            //CHECK
            Vector quadr1 = new Vector(4);
            quadr1.addElement(varArray[check11i].name);  quadr1.addElement(varArray[check12i].name);
            quadr1.addElement(varArray[check23i].name);  quadr1.addElement(varArray[check24i].name);	
  
            add=true;
            for(int l=0;l<possQuadr[i].size();l++)
            { 
              if(possQuadr[i].elementAt(l).toString().equals(quadr.toString()) )
	      {
      	        add=false;
              }
	    }            
            if(add)
	    {
/*              System.out.print("---> "+possQuadr[i].elementAt(j));
              System.out.print(" and "+possQuadr[quadr13i].elementAt(k));
              System.out.println(" to "+quadr);
*/
              change=true;
              possQuadr[i].addElement(quadr);
              //CHECK
              checkQuadr[i].addElement(quadr1);

              //Add also just the endpoints to the actual Vector of interest
              if(!possDSep[i].contains(quadr24))
                possDSep[i].addElement(quadr24);
	    }
          }
        }//k
      }//j
    }//i
 
    if(change==false)
      break;
   }//while 

/*
  //CHECK
  for(int i=0;i<currspots;i++)
  { 
    System.out.println("\nSet of poss Quadruples as Strings: "+varArray[i].name+": "+checkQuadr[i]);
  }
  for(int i=0;i<currspots;i++)
  { 
    System.out.println("\nSet of poss Quadruples for "+varArray[i].name+": "+possQuadr[i]);
  }
  */
  for(int i=0;i<currspots;i++)
  { 
    System.out.println("\nSet of possDSep for "+varArray[i].name+": "+possDSep[i]);
  }
  return;
}

void updateEdgeMatrix(Vector Z,int i,int j,int iterTot,int q,Vector T)
{ 
  /*
  This is a recursive function that calls itself with the arguments:
  Z is a Vector of setAdj_j(int i, int j) and T c Z. Z is fixed but T permutes through
  Z and has size iterTot.
  */

  int k=iterTot;
  k=k-1;
  boolean exit=false;
  if(k>0)
  { 
    for(int p=q;p<Z.size()-k+1;p++)
    {  
      if(exit==true)
      {
        break;
      }
 
      T.addElement(Z.elementAt(p));
      p++;
      updateEdgeMatrix(Z,i,j,k,p,T);

      //We don't want to permute the empty set
      if(T.size()==0)
      {
        break;
      }

      //Remove the just added element   
      T.removeElement(T.lastElement());
      p--;
    }
  }
  if(k==0)
  {    
    String[] T1=new String[T.size()];
    for(int l=0;l<T.size();l++)
    {
      T1[l]= T.elementAt(l).toString();
      System.out.println("T: "+T1[l]);
    }
//    System.out.println("Test in: Variables: "+varArray[i].name+", "+varArray[j].name+" sign: "+signif);

    g2r=g2test.calcIndependence(varArray[i].name,varArray[j].name,T1,signif);
    System.out.println("Test out: "+g2r.independent);

    if(g2r.independent==true)
    {     
      //Remove edge
      edgeMatrix[i][j]=0;edgeMatrix[j][i]=0;
      //Record sepSet
        sepSet[i][j].addElement(T.toString()); sepSet[j][i].addElement(T.toString());
        System.out.print("\n----------->>>>> Independence = True");
        System.out.println(", sepSet "+sepSet[i][j]+"\n"); 
        System.out.println(", sepSet "+sepSet[0][3]+"\n"); 
        exit=true;  
    }
  }
  k++;
} 

public void paint(Graphics g) {
  int x, y, h, w;
  double theta, a, b;
  int itheta;
  String l;
  Font f = new Font("TimesRoman", Font.BOLD, 13);

  g.clearRect(0, 0, 740, 500);
  g.setColor(Color.black);
  g.setFont(f);

  g.drawLine(10, 400, 450, 400);
  g.drawString("Instructions:", 10, 410);

  for(int i = 0; i < noutlines; i++) {
    String output = new String(outputLine[i]);
    g.drawString(output, 10, 425 + i*15);
    }

//Check GRAPH
if(state == FCIA||state == AUTO || state ==  NODES || state ==  EDIT || state ==  EDGES)
{
  //Paint method for given edgeMatrix
  for (int i=0; i < currspots; i++) 
  {
    x = V[i].rect.x;
    y = V[i].rect.y;
    l = V[i].name;
    h = V[i].rect.height;
    w = V[i].rect.width;
    g.setColor(vcolors[i]);
    g.drawRect(x, y, w, h);
    if(i == selected) g.drawRect(x - 2, y - 2, w + 4, h + 4);
    g.setColor(Color.black);
    g.drawString(l, x+(w/2 - 3*l.length( )), y+15);
    g.setColor(Color.blue);
  }

  for (int i = 0; i < currline; i++) 
  {
     //start
    int j=edgeMatrix[endVertex[i]][startVertex[i]];
    //end  
    int k=edgeMatrix[startVertex[i]][endVertex[i]];

    //System.out.println(k +" "+ j);

    if((j!=0)&&(k!=0))
    {
    g.setColor(ecolors[i]);
    g.drawLine(starts[i].x, starts[i].y, ends[i].x, ends[i].y);
    g.fillOval(centers[i].x, centers[i].y, 5, 5);
    a = (double) (ends[i].x - starts[i].x);
    b = (double) (starts[i].y - ends[i].y);
    theta = Math.atan2(b, a);
    itheta = (int) ((theta*360.0)/(2.0*3.14159265));
    itheta += 180;

    if(k==1);
    if(j==2)
    {
      g.setColor(Color.blue);
      g.fillArc(ends[i].x - 18, ends[i].y - 18, 36, 36, itheta - 15, 20);
    }
    if(k==2)
    {
      g.setColor(Color.blue);
      g.fillArc(starts[i].x - 18, starts[i].y - 18, 36, 36, itheta + 165, 20);
    }
    if(j==3)
    {
       g.setColor(Color.red);
       g.fillOval(ends[i].x-4, ends[i].y-4,8,8);
    }
    if(k==3)
    {
      g.setColor(Color.red);
      g.fillOval(starts[i].x-4, starts[i].y-4 ,8,8);
    }
    }

    g.setColor(Color.red);
    if(currentpoint != null) g.drawLine(anchor.x, anchor.y, currentpoint.x,
                                        currentpoint.y);
  }
}
else
{
  g.setColor(Color.blue);
  if(currlocation != null) 
  {
    for(int i = 0; i < currline; i++) 
    {
      if(startVertex[i] == selected || endVertex[i] == selected) 
      {
        int ii = startVertex[i];
        int jj = endVertex[i];
        drawEdge(V[ii].rect, V[jj].rect);
        starts[i] = from;
        ends[i] = to;
        centers[i] = 
          new Point(((V[ii].rect.x + V[ii].rect.width/2)+(V[jj].rect.x + 
                    V[jj].rect.width/2))/2,((V[ii].rect.y+V[ii].rect.height/2)+
                   (V[jj].rect.y + V[jj].rect.height/2))/2);
      }
    }
    V[selected].rect.x = currlocation.x;
    V[selected].rect.y = currlocation.y;
  }

  for (int i=0; i < currspots; i++) {
    x = V[i].rect.x;
    y = V[i].rect.y;
    l = V[i].name;
    h = V[i].rect.height;
    w = V[i].rect.width;
    g.setColor(vcolors[i]);
    g.drawRect(x, y, w, h);
    if(i == selected) g.drawRect(x - 2, y - 2, w + 4, h + 4);
    g.setColor(Color.black);
    g.drawString(l, x+(w/2 - 3*l.length( )), y+15);
    g.setColor(Color.blue);
    }

  for (int i = 0; i < currline; i++) 
   if(B.D.adjacent(startVertex[i], endVertex[i])) 
    {
      g.setColor(ecolors[i]);
      g.drawLine(starts[i].x, starts[i].y, ends[i].x, ends[i].y);
      g.fillOval(centers[i].x, centers[i].y, 5, 5);
      a = (double) (ends[i].x - starts[i].x);
      b = (double) (starts[i].y - ends[i].y);
      theta = Math.atan2(b, a);
      itheta = (int) ((theta*360.0)/(2.0*3.14159265));
      itheta += 180;
      g.fillArc(ends[i].x - 18, ends[i].y - 18, 36, 36, itheta - 15, 30);
      }

      g.setColor(Color.red);
      if(currentpoint != null) 
        g.drawLine(anchor.x, anchor.y, currentpoint.x, currentpoint.y);
    }
  }
}
