(*-----------#pc-version-----------------------------------------------------*)

{$N+,E+,F+,O+}
(*
unit tt2;
interface
uses tt1;
*)
(*-----------#pc-version-----------------------------------------------------*)

type
     insigcorrarr = array[1..maxvertex,1..maxvertex] of boolean;
     insigcorrptr = ^insigcorrarr;

     bigarr = array[1..maxsamp] of vertarrptr;
     dataarr = ^bigarr;

     edge = 0..max2s;
     { range of integers representing one internal representation of edges }

     edgroup = set of edge;
     vertexset = set of vertextype;

     pathpair = record
                   vertices: vertexset;
                   plength: integer;
		end;  { pathpair }
     { represents edges and vertices respectively in a path or trek }

     pathsptr = ^pathslist;
     pathslist = record
		    next: pathsptr;
		    vertices: vertexset;
		    level: integer;
                    strength: real;
		 end;
     { represents list of paths or treks }

     upathpair = record
                   into: array[1..2] of integer;
		   edges: edgroup;
		   heads: vertexset;
		   tails: vertexset;
                   plength: integer;
                end;

     treksptr = ^trekslist;
     trekslist = record
		    next: treksptr;
		    trek1: pathsptr;
		    trek2: pathsptr;
		    level: integer;
		    source: vertextype;
		 end;
     { represents list of paths or treks }

     trekstypearr = array[1..maxvertex,1..maxvertex] of treksptr;
     trekstype = ^trekstypearr;
     { represents the list of treks between any two vertices }

     bytetype = 0..63;
     adjtypearr = array[1..maxvertex,1..maxvertex] of bytetype;
     adjtype = ^adjtypearr;
     { represents the adjacency matrix }

     covarr = array[1..maxvertex,1..maxvertex] of real;
     covarray = ^covarr;

     indepptr = ^indepcell;
     indepcell = record
                   tail,head: vertextype;
                   cond: vertexset;
                   fwd: indepptr;
                 end;

     pathstypearr = array[1..maxvertex,1..maxvertex] of pathsptr;
     pathstype = ^pathstypearr;
     { represents the list of paths between any two vertices }

  parray = array[1..maxvertex] of vertextype;
  udpathsptr = ^udpathslist;
  udpathslist = record
	    next: udpathsptr;
	    vertices: vertexset;
	    level: integer;
            length: integer;
            patharray: parray;
            strength: real;
		 end;
  { represents list of paths or treks }

  udpathsarr = array[1..maxvertex,1..maxvertex] of udpathsptr;
  udpathstype = ^udpathsarr;
  { represents the list of paths between any two vertices }

     intpair = record
		  head: vertextype;
		  tail: vertextype;
	       end;

     val = record                       { Vttr field stores the Rttr,  }
	      vttr : real;              { v1 the RD+, and v2 the ID-  }
	      v1,v2 : integer;
	   end;
     valarray = array[1..max2s,1..3] of val;

     edgenamearr = array[vertextype,vertextype] of integer;
     edgenametype = ^edgenamearr;
     pairtointarr = array[vertextype,vertextype] of integer;
     pairtointtype = ^pairtointarr;
     inttopairarr = array[1..10000] of intpair;
     inttopairtype = ^inttopairarr;
     edgetovertarr = array[1..edgemax] of intpair;
     edgetoverttype = ^edgetovertarr;
     patterntype = 1..3;
     eqnumbers = 1..3;
     eqset = set of eqnumbers;

     impcorr =  adjtype;
     probcorr =  covarray;
 
    filetype = (covarf,graphf,printf,outputf,modparams,inp,know,montef);
    filenamepntr=^filenameblock;
    filenameblock=record
                    filename:inbuf;
                    next:filenamepntr;
                  end;
    varname=array[1..3] of char;
    namepntr=^labelname;
    labelname=record
               eqsname:inbuf;
               tetname:inbuf;
               next:namepntr;
             end;

      edgerec = array[0..2] of edgroup;

      modelptr = ^modellist;
      modellist = record
		    fwd,back: modelptr;
                    numedges: integer;
		    singleedge1: vertextype;
                    singleedge2: vertextype;
	            edges: adjtype;
                    direction: -1..2;
	            score,maxscore: real;
                  end;

     implist = ^imprec;
     imprec = record
		i,j,k,l,pattern: vertextype;
                prob: real;
                fwd,back: implist;
              end;

     modasclusters = array[1..maxtheos] of vertexset;
     clusterptr = ^clusterlist;
     clusterlist = record
               	next: clusterptr;
               	cluster: modasclusters;
		numpar: integer;
        end;     
     eqs = set of eqnumbers;
     ovlaparray = array[1..3] of 0..maxvertex;
     parentarray = array[1..maxvertex] of vertextype;
     otype = (all,implied,held,none);

     tempset = array[1..maxvertex] of vertexset;

     tempptr = ^temprec;
     temprec = record
               vertices: vertexset;
               next: tempptr;
             end;             

     probscores = array[patterntype] of real;
     imparray = array[patterntype] of boolean;
     needtype = (agraph,data,lineardata,fileforout,
                 bayesnet,discretedata,model);
   vertarray = array[1..maxvertex] of real;
   
   probarray = array[0..maxcategories] of real;

   probptr = ^prob;
   prob = record
            nextvalue: array[1..maxcategories] of probptr;
            cutoff,count,multiplier: probarray;
            varnum: vertextype;
          end;

   (* to hold the number of categories for each discrete variable. *)
   categorynum = 1..maxcategories;
   categoryrecord = record 
                        num: categorynum;
                        value: array[1..maxcategories] of real;
                        inversevalue: array[0..maxcategories] of integer;
                        numpi: integer;   (* temporary *)
                        condprob: probptr;
                    end;
   categoryarray = array[1..maxvertex] of categoryrecord;
   

   (* To hold the order for the equations *)
   eqorder = ^varlist;
   varlist = record
                     next: eqorder;
                     varbl: vertextype;
                end;
   (* To hold the partial order of the graph *)
   tiersptr = ^tierslist;
   tierslist = record
                  next: tiersptr;
                  varset: vertexset;
               end;
    relationsets = array[1..maxvertex] of vertexset;
    probrange = 1..5;
    uncertaintype = array[1..maxtheos,1..maxtheos] of boolean;

    distparms = record
		   probtype: probrange; (* 1..5, 1 for uniform, 2 for normal, etc. *)
		   parm1: real;  (* e.g. mean, lower bound, etc. *)
		   parm2: real;  (* e.g. variance, stand. dev *)
		end;

    exogarray = array[1..maxvertex] of distparms;
  corroccurs = record 
              varbl: vertextype;
              num: integer
             end;

  subsetptr = ^subsetlist;
  subsetlist = record
              next: subsetptr;
              vset: vertexset;
              avg: real;
              latprop: real;
              minprob: real;
            end;

  trekseptype = array[1..maxtheos,1..maxtheos] of vertexset;
  latype = array[1 .. maxtheos] of boolean;
  esttype = (MLinternal,MLexternal,uniform,noisyormeth);
  estset = set of esttype;
  modelt = array[1..maxvertex] of vertexset;
  modeltype = record
               amodel: modelt;
               signif,acc,sens,spec,pospred,negpred,
               acccut, senscut,speccut,pospredcut,negpredcut,
               mostposcut,mostnegcut,mostpos,mostneg: real;
               precision: integer;
               estimate: esttype;
               next: ^modeltype;
               fwd,back: ^modeltype;  (* temporary *)
               score: real;           (* temporary *)
               v1,v2: vertextype;     (* temporary *)               
              end;

  modeltypeptr = ^modeltype;
  infotype = (accuracy,positivepredvalue,negativepredvalue,specificity,
              sensitivity,mostpos,mostneg);
  realpair = record
                pos,total: real;
             end;
  noisyortype = array[1..maxvertex,catrange] of realpair;

    endtype = (in2,out2,knownin2,knownout2,notknown);
    endset = set of endtype;
    endarraytype = array[0..maxvertex,0..maxvertex] of endset;
    endarray = ^endarraytype;
    dseparraytype = array[1..maxvertex,1..maxvertex] of vertexset;
    dseparray = ^dseparraytype;


  magtype = record
              amag: endarray;
              parents: adjtype;
              children: adjtype;
              doublehead: adjtype;
              inducing: adjtype;
              numparents: parray;
              numchildren: parray;
              numdouble: parray;
              ancestor: adjtype;
              ancestors: tempset;
              cov1: covarray;
              cov2: covarray;
              cov3: covarray;
              vv: vertarray;
              order: parray;
              nparams: integer;
              score: real;
              parm: covarray;
           end;

var 
    commandneed: array[commands] of set of needtype;
    numcats: array[1..maxvertex] of integer;
    pageon,discrete,celldata,indepdata: boolean;
    maxval: array[1..maxvertex] of integer;
    acommand: commands;
    fileexists: array[filetype] of boolean;
    causalsuff,ranpart,rantet,wantexit: boolean;
    acyclic,dacyclic,newcycle: boolean;
    ll, ml, mm, lm, comm, singleconn: boolean;
    havereadcov,havereadgraph,justreaddata,havereadbayes,havereadindep,
    havereadraw,havereadcells,havereadlinearmodel,havereadcon: boolean;
    fromtty: boolean;             { true if input from tty }
    theoretical: array[1..maxvertex] of boolean; { TRUE if corresponding
						 variable is theoretical }

    lineno,outline: integer;
    lastvarassigned,lastedgeassigned: integer;
    numob,numtheo: integer;
    curpos: integer;              { location of current input character }
    pexnum,exnum,origpdplus,origpdminus: integer;
    max,origmax: integer;        		{ number of vertices in graph }
    numedges,numcorrs: integer;
    depth,nochangedepth,eqsnumber,lisrelnumber: integer;
 
    sampsize, pttr, signif,weight,percent,printpart,maxtime: real;
    impheld,impnheld,score,maxscore, currentmax,bestscore,worstscore: real;

    vernames: namearray;       
    buf: inbuf;
    ifilename,ofilename: inbuf;
    graphfilename,nullfilename,blankfilename: inbuf;
    gfilename,ffilename,tfilename,dfilename,fcfilename: inbuf;
    curfilename,knowfilename: inbuf;    
    ofilvar:  text; 
    knowfile: text;
    eqsfile, lisfile: text;
    eqsinp, lisinp:text;
    paramfile: text;
    eqsfilelist, filenamelist, lisfilelist:filenamepntr;
    numfilenames:integer;
    namelist:namepntr;

    graphvertices,covvertices,notfixed: vertexset;
    ttycommands,runcommands,switchcommands,commandcommands,knowcommands,
    datacommands: set of commands;
    command: commandstring;
    commandarray: array[1..numcommands] of commandid;

(*-----------#pc-version-----------------------------------------------------*)
(*
implementation
end.
*)
(*-----------#pc-version-----------------------------------------------------*)
