(*-----------#pc-version-----------------------------------------------------*)
(*
implementation
uses sys;
*)
(*-----------#pc-version-----------------------------------------------------*)

(*-----------#unix-version-----------------------------------------------------*)
#include "syst.h"
#include "tt1.h"
#include "tt2.h"
#include "tt3.h"
#include "tt4.h"
#include "tt5.h"
#include "cross.h"
#include "part.h"
#include "calctet.h"
#include "mon.h"
#include "util.h"
#include "sys.h"
#include "indep1.h"
(*-----------#unix-version-----------------------------------------------------*)

var indices: array[1..maxvertex] of integer;

function chisquare2(g2,df,signif: real; var prob: real): boolean;
   function interpolate(highprob, lowprob, highval, lowval: real): real;
   begin
        interpolate := lowprob + 
                ((g2 - lowval)/(highval - lowval)) * (highprob - lowprob);
   end;

var cutoff: real;
begin
   if df = 19 then
      begin
         if g2 <   3.9683 then prob := 0.9999
         else if g2 <   4.9123 then
            prob := interpolate(0.9999,0.9995,  3.9683,  4.9123)
         else if g2 <   5.4068 then
            prob := interpolate(0.9995,0.9990,  4.9123,  5.4068)
         else if g2 <   6.8440 then
            prob := interpolate(0.9990,0.9950,  5.4068,  6.8440)
         else if g2 <   7.6327 then
            prob := interpolate(0.9950,0.9900,  6.8440,  7.6327)
         else if g2 <   8.9065 then
            prob := interpolate(0.9900,0.9750,  7.6327,  8.9065)
         else if g2 <  10.1170 then
            prob := interpolate(0.9750,0.9500,  8.9065, 10.1170)
         else if g2 <  11.6509 then
            prob := interpolate(0.9500,0.9000, 10.1170, 11.6509)
         else if g2 < 13.716 then
            prob := interpolate(0.90, 0.80, 11.651, 13.716) 
         else if g2 < 15.352 then
            prob := interpolate(0.80, 0.70, 13.716, 15.352) 
         else if g2 < 18.338 then
            prob := interpolate(0.70, 0.50, 15.352, 18.338) 
         else if g2 < 21.689 then
            prob := interpolate(0.50, 0.30, 18.338, 21.689) 
         else if g2 < 23.900 then
            prob := interpolate(0.30, 0.20 , 21.689, 23.900) 
         else if g2 < 27.2036 then
            prob := interpolate(0.20, 0.1, 23.900, 27.2036) 
         else if g2 <  30.1435 then
            prob := interpolate(0.1000,0.0500, 27.2036, 30.1435)
         else if g2 <  32.8523 then
            prob := interpolate(0.0500,0.0250, 30.1435, 32.8523)
         else if g2 <  36.1909 then
            prob := interpolate(0.0250,0.0100, 32.8523, 36.1909)
         else if g2 <  38.5823 then
            prob := interpolate(0.0100,0.0050, 36.1909, 38.5823)
         else if g2 <  43.8202 then
            prob := interpolate(0.0050,0.0010, 38.5823, 43.8202)
         else if g2 <  45.9731 then
            prob := interpolate(0.0010,0.0005, 43.8202, 45.9731)
         else if g2 <  50.7955 then
            prob := interpolate(0.0005,0.0001, 45.9731, 50.7955)
         else prob := 0.0;
      end
   else if df = 20 then
      begin
         if g2 <   4.3952 then prob := 0.9999
         else if g2 <   5.3981 then
            prob := interpolate(0.9999,0.9995,  4.3952,  5.3981)
         else if g2 <   5.9210 then
            prob := interpolate(0.9995,0.9990,  5.3981,  5.9210)
         else if g2 <   7.4338 then
            prob := interpolate(0.9990,0.9950,  5.9210,  7.4338)
         else if g2 <   8.2604 then
            prob := interpolate(0.9950,0.9900,  7.4338,  8.2604)
         else if g2 <   9.5908 then
            prob := interpolate(0.9900,0.9750,  8.2604,  9.5908)
         else if g2 <  10.8508 then
            prob := interpolate(0.9750,0.9500,  9.5908, 10.8508)
         else if g2 <  12.4426 then
            prob := interpolate(0.9500,0.9000, 10.8508, 12.4426)
         else if g2 < 14.578 then
            prob := interpolate(0.90, 0.80, 12.443, 14.578) 
         else if g2 < 16.266 then
            prob := interpolate(0.80, 0.70, 14.578, 16.266) 
         else if g2 < 19.337 then
            prob := interpolate(0.70, 0.50, 16.266, 19.337) 
         else if g2 < 22.775 then
            prob := interpolate(0.50, 0.30, 19.337, 22.775) 
         else if g2 < 25.038 then
            prob := interpolate(0.30, 0.20, 22.775, 25.038) 
         else if g2 < 28.412 then
            prob := interpolate(0.20, 0.10, 25.038, 28.412) 
         else if g2 <  31.4104 then
            prob := interpolate(0.1000,0.0500, 28.4120, 31.4104)
         else if g2 <  34.1696 then
            prob := interpolate(0.0500,0.0250, 31.4104, 34.1696)
         else if g2 <  37.5662 then
            prob := interpolate(0.0250,0.0100, 34.1696, 37.5662)
         else if g2 <  39.9968 then
            prob := interpolate(0.0100,0.0050, 37.5662, 39.9968)
         else if g2 <  45.3147 then
            prob := interpolate(0.0050,0.0010, 39.9968, 45.3147)
         else if g2 <  47.4985 then
            prob := interpolate(0.0010,0.0005, 45.3147, 47.4985)
         else if g2 <  52.3860 then
            prob := interpolate(0.0005,0.0001, 47.4985, 52.3860)
         else prob := 0.0;
      end
   else if df = 21 then
      begin
         if g2 <   4.8348 then prob := 0.9999
         else if g2 <   5.8957 then
            prob := interpolate(0.9999,0.9995,  4.8348,  5.8957)
         else if g2 <   6.4467 then
            prob := interpolate(0.9995,0.9990,  5.8957,  6.4467)
         else if g2 <   8.0337 then
            prob := interpolate(0.9990,0.9950,  6.4467,  8.0337)
         else if g2 <   8.8972 then
            prob := interpolate(0.9950,0.9900,  8.0337,  8.8972)
         else if g2 <  10.2829 then
            prob := interpolate(0.9900,0.9750,  8.8972, 10.2829)
         else if g2 <  11.5913 then
            prob := interpolate(0.9750,0.9500, 10.2829, 11.5913)
         else if g2 <  13.2396 then
            prob := interpolate(0.9500,0.9000, 11.5913, 13.2396)
         else if g2 < 15.445 then
            prob := interpolate(0.90, 0.80, 13.240, 15.445) 
         else if g2 < 17.182 then
            prob := interpolate(0.80, 0.70, 15.445, 17.182) 
         else if g2 < 20.337 then
            prob := interpolate(0.70, 0.50, 17.182, 20.337) 
         else if g2 < 23.858 then
            prob := interpolate(0.50, 0.30, 20.337, 23.858) 
         else if g2 < 26.171 then
            prob := interpolate(0.30, 0.20 , 23.858, 26.171) 
         else if g2 < 29.6151 then
            prob := interpolate(0.20, 0.1, 26.171, 29.6151) 
         else if g2 <  32.6706 then
            prob := interpolate(0.1000,0.0500, 29.6151, 32.6706)
         else if g2 <  35.4789 then
            prob := interpolate(0.0500,0.0250, 32.6706, 35.4789)
         else if g2 <  38.9322 then
            prob := interpolate(0.0250,0.0100, 35.4789, 38.9322)
         else if g2 <  41.4011 then
            prob := interpolate(0.0100,0.0050, 38.9322, 41.4011)
         else if g2 <  46.7970 then
            prob := interpolate(0.0050,0.0010, 41.4011, 46.7970)
         else if g2 <  49.0108 then
            prob := interpolate(0.0010,0.0005, 46.7970, 49.0108)
         else if g2 <  53.9620 then
            prob := interpolate(0.0005,0.0001, 49.0108, 53.9620)
         else prob := 0.0;
      end
   else if df = 22 then
      begin
         if g2 <   5.2865 then prob := 0.9999
         else if g2 <   6.4045 then
            prob := interpolate(0.9999,0.9995,  5.2865,  6.4045)
         else if g2 <   6.9830 then
            prob := interpolate(0.9995,0.9990,  6.4045,  6.9830)
         else if g2 <   8.6427 then
            prob := interpolate(0.9990,0.9950,  6.9830,  8.6427)
         else if g2 <   9.5425 then
            prob := interpolate(0.9950,0.9900,  8.6427,  9.5425)
         else if g2 <  10.9823 then
            prob := interpolate(0.9900,0.9750,  9.5425, 10.9823)
         else if g2 <  12.3380 then
            prob := interpolate(0.9750,0.9500, 10.9823, 12.3380)
         else if g2 <  14.0415 then
            prob := interpolate(0.9500,0.9000, 12.3380, 14.0415)
         else if g2 < 16.314 then
            prob := interpolate(0.90, 0.80, 14.041, 16.314) 
         else if g2 < 18.101 then
            prob := interpolate(0.80, 0.70, 16.314, 18.101) 
         else if g2 < 21.337 then
            prob := interpolate(0.70, 0.50, 18.101, 21.337) 
         else if g2 < 24.939 then
            prob := interpolate(0.50, 0.30, 21.337, 24.939) 
         else if g2 < 27.301 then
            prob := interpolate(0.30, 0.20 , 24.939, 27.301) 
         else if g2 < 30.8133 then
            prob := interpolate(0.20, 0.1, 27.301, 30.8133) 
         else if g2 <  33.9244 then
            prob := interpolate(0.1000,0.0500, 30.8133, 33.9244)
         else if g2 <  36.7807 then
            prob := interpolate(0.0500,0.0250, 33.9244, 36.7807)
         else if g2 <  40.2894 then
            prob := interpolate(0.0250,0.0100, 36.7807, 40.2894)
         else if g2 <  42.7957 then
            prob := interpolate(0.0100,0.0050, 40.2894, 42.7957)
         else if g2 <  48.2679 then
            prob := interpolate(0.0050,0.0010, 42.7957, 48.2679)
         else if g2 <  50.5111 then
            prob := interpolate(0.0010,0.0005, 48.2679, 50.5111)
         else if g2 <  55.5246 then
            prob := interpolate(0.0005,0.0001, 50.5111, 55.5246)
         else prob := 0.0;
      end
   else if df = 23 then
      begin
         if g2 <   5.7494 then prob := 0.9999
         else if g2 <   6.9237 then
            prob := interpolate(0.9999,0.9995,  5.7494,  6.9237)
         else if g2 <   7.5292 then
            prob := interpolate(0.9995,0.9990,  6.9237,  7.5292)
         else if g2 <   9.2604 then
            prob := interpolate(0.9990,0.9950,  7.5292,  9.2604)
         else if g2 <  10.1957 then
            prob := interpolate(0.9950,0.9900,  9.2604, 10.1957)
         else if g2 <  11.6886 then
            prob := interpolate(0.9900,0.9750, 10.1957, 11.6886)
         else if g2 <  13.0905 then
            prob := interpolate(0.9750,0.9500, 11.6886, 13.0905)
         else if g2 <  14.8480 then
            prob := interpolate(0.9500,0.9000, 13.0905, 14.8480)
         else if g2 < 17.187 then
            prob := interpolate(0.90, 0.80, 14.848, 17.187) 
         else if g2 < 19.021 then
            prob := interpolate(0.80, 0.70, 17.187, 19.021) 
         else if g2 < 22.337 then
            prob := interpolate(0.70, 0.50, 19.021, 22.337) 
         else if g2 < 26.018 then
            prob := interpolate(0.50, 0.30, 22.337, 26.018) 
         else if g2 < 28.429 then
            prob := interpolate(0.30, 0.20 , 26.018, 28.429) 
         else if g2 < 32.0069 then
            prob := interpolate(0.20, 0.1, 28.429, 32.0069) 
         else if g2 <  35.1725 then
            prob := interpolate(0.1000,0.0500, 32.0069, 35.1725)
         else if g2 <  38.0756 then
            prob := interpolate(0.0500,0.0250, 35.1725, 38.0756)
         else if g2 <  41.6384 then
            prob := interpolate(0.0250,0.0100, 38.0756, 41.6384)
         else if g2 <  44.1813 then
            prob := interpolate(0.0100,0.0050, 41.6384, 44.1813)
         else if g2 <  49.7282 then
            prob := interpolate(0.0050,0.0010, 44.1813, 49.7282)
         else if g2 <  52.0002 then
            prob := interpolate(0.0010,0.0005, 49.7282, 52.0002)
         else if g2 <  57.0746 then
            prob := interpolate(0.0005,0.0001, 52.0002, 57.0746)
         else prob := 0.0;
      end
   else if df = 24 then
      begin
         if g2 <   6.2230 then prob := 0.9999
         else if g2 <   7.4527 then
            prob := interpolate(0.9999,0.9995,  6.2230,  7.4527)
         else if g2 <   8.0849 then
            prob := interpolate(0.9995,0.9990,  7.4527,  8.0849)
         else if g2 <   9.8862 then
            prob := interpolate(0.9990,0.9950,  8.0849,  9.8862)
         else if g2 <  10.8564 then
            prob := interpolate(0.9950,0.9900,  9.8862, 10.8564)
         else if g2 <  12.4012 then
            prob := interpolate(0.9900,0.9750, 10.8564, 12.4012)
         else if g2 <  13.8484 then
            prob := interpolate(0.9750,0.9500, 12.4012, 13.8484)
         else if g2 <  15.6587 then
            prob := interpolate(0.9500,0.9000, 13.8484, 15.6587)
         else if g2 < 18.062 then
            prob := interpolate(0.90, 0.80, 15.659, 18.062) 
         else if g2 < 19.943 then
            prob := interpolate(0.80, 0.70, 18.062, 19.943) 
         else if g2 < 23.337 then
            prob := interpolate(0.70, 0.50, 19.943, 23.337) 
         else if g2 < 27.096 then
            prob := interpolate(0.50, 0.30, 23.337, 27.096) 
         else if g2 < 29.553 then
            prob := interpolate(0.30, 0.20 , 27.096, 29.553) 
         else if g2 < 33.1962 then
            prob := interpolate(0.20, 0.1, 29.553, 33.1962) 
         else if g2 <  36.4150 then
            prob := interpolate(0.1000,0.0500, 33.1962, 36.4150)
         else if g2 <  39.3641 then
            prob := interpolate(0.0500,0.0250, 36.4150, 39.3641)
         else if g2 <  42.9798 then
            prob := interpolate(0.0250,0.0100, 39.3641, 42.9798)
         else if g2 <  45.5585 then
            prob := interpolate(0.0100,0.0050, 42.9798, 45.5585)
         else if g2 <  51.1786 then
            prob := interpolate(0.0050,0.0010, 45.5585, 51.1786)
         else if g2 <  53.4788 then
            prob := interpolate(0.0010,0.0005, 51.1786, 53.4788)
         else if g2 <  58.6130 then
            prob := interpolate(0.0005,0.0001, 53.4788, 58.6130)
         else prob := 0.0;
      end
   else if df = 25 then
      begin
         if g2 <   6.7066 then prob := 0.9999
         else if g2 <   7.9910 then
            prob := interpolate(0.9999,0.9995,  6.7066,  7.9910)
         else if g2 <   8.6493 then
            prob := interpolate(0.9995,0.9990,  7.9910,  8.6493)
         else if g2 <  10.5197 then
            prob := interpolate(0.9990,0.9950,  8.6493, 10.5197)
         else if g2 <  11.5240 then
            prob := interpolate(0.9950,0.9900, 10.5197, 11.5240)
         else if g2 <  13.1197 then
            prob := interpolate(0.9900,0.9750, 11.5240, 13.1197)
         else if g2 <  14.6114 then
            prob := interpolate(0.9750,0.9500, 13.1197, 14.6114)
         else if g2 <  16.4734 then
            prob := interpolate(0.9500,0.9000, 14.6114, 16.4734)
         else if g2 < 18.940 then
            prob := interpolate(0.90, 0.80, 16.473, 18.940) 
         else if g2 < 20.867 then
            prob := interpolate(0.80, 0.70, 18.940, 20.867) 
         else if g2 < 24.337 then
            prob := interpolate(0.70, 0.50, 20.867, 24.337) 
         else if g2 < 28.172 then
            prob := interpolate(0.50, 0.30, 24.337, 28.172) 
         else if g2 < 30.675 then
            prob := interpolate(0.30, 0.20 , 28.172, 30.675) 
         else if g2 < 34.3816  then
            prob := interpolate(0.20, 0.1, 30.675, 34.3816) 
         else if g2 <  37.6525 then
            prob := interpolate(0.1000,0.0500, 34.3816, 37.6525)
         else if g2 <  40.6465 then
            prob := interpolate(0.0500,0.0250, 37.6525, 40.6465)
         else if g2 <  44.3141 then
            prob := interpolate(0.0250,0.0100, 40.6465, 44.3141)
         else if g2 <  46.9279 then
            prob := interpolate(0.0100,0.0050, 44.3141, 46.9279)
         else if g2 <  52.6197 then
            prob := interpolate(0.0050,0.0010, 46.9279, 52.6197)
         else if g2 <  54.9475 then
            prob := interpolate(0.0010,0.0005, 52.6197, 54.9475)
         else if g2 <  60.1403 then
            prob := interpolate(0.0005,0.0001, 54.9475, 60.1403)
         else prob := 0.0;
      end
   else if df = 26 then
      begin
         if g2 <   7.1998 then prob := 0.9999
         else if g2 <   8.5379 then
            prob := interpolate(0.9999,0.9995,  7.1998,  8.5379)
         else if g2 <   9.2221 then
            prob := interpolate(0.9995,0.9990,  8.5379,  9.2221)
         else if g2 <  11.1602 then
            prob := interpolate(0.9990,0.9950,  9.2221, 11.1602)
         else if g2 <  12.1981 then
            prob := interpolate(0.9950,0.9900, 11.1602, 12.1981)
         else if g2 <  13.8439 then
            prob := interpolate(0.9900,0.9750, 12.1981, 13.8439)
         else if g2 <  15.3792 then
            prob := interpolate(0.9750,0.9500, 13.8439, 15.3792)
         else if g2 <  17.2919 then
            prob := interpolate(0.9500,0.9000, 15.3792, 17.2919)
         else if g2 < 19.820 then
            prob := interpolate(0.90, 0.80, 17.292, 19.820) 
         else if g2 < 21.792 then
            prob := interpolate(0.80, 0.70, 19.820, 21.792) 
         else if g2 < 25.336 then
            prob := interpolate(0.70, 0.50, 21.792, 25.336) 
         else if g2 < 29.246 then
            prob := interpolate(0.50, 0.30, 25.336, 29.246) 
         else if g2 < 31.795 then
            prob := interpolate(0.30, 0.20 , 29.246, 31.795) 
         else if g2 < 35.5632 then
            prob := interpolate(0.20, 0.1, 31.795, 35.5632) 
         else if g2 <  38.8851 then
            prob := interpolate(0.1000,0.0500, 35.5632, 38.8851)
         else if g2 <  41.9232 then
            prob := interpolate(0.0500,0.0250, 38.8851, 41.9232)
         else if g2 <  45.6417 then
            prob := interpolate(0.0250,0.0100, 41.9232, 45.6417)
         else if g2 <  48.2899 then
            prob := interpolate(0.0100,0.0050, 45.6417, 48.2899)
         else if g2 <  54.0520 then
            prob := interpolate(0.0050,0.0010, 48.2899, 54.0520)
         else if g2 <  56.4069 then
            prob := interpolate(0.0010,0.0005, 54.0520, 56.4069)
         else if g2 <  61.6573 then
            prob := interpolate(0.0005,0.0001, 56.4069, 61.6573)
         else prob := 0.0;
      end
   else if df = 27 then
      begin
         if g2 <   7.7019 then prob := 0.9999
         else if g2 <   9.0932 then
            prob := interpolate(0.9999,0.9995,  7.7019,  9.0932)
         else if g2 <   9.8028 then
            prob := interpolate(0.9995,0.9990,  9.0932,  9.8028)
         else if g2 <  11.8076 then
            prob := interpolate(0.9990,0.9950,  9.8028, 11.8076)
         else if g2 <  12.8785 then
            prob := interpolate(0.9950,0.9900, 11.8076, 12.8785)
         else if g2 <  14.5734 then
            prob := interpolate(0.9900,0.9750, 12.8785, 14.5734)
         else if g2 <  16.1514 then
            prob := interpolate(0.9750,0.9500, 14.5734, 16.1514)
         else if g2 <  18.1139 then
            prob := interpolate(0.9500,0.9000, 16.1514, 18.1139)
         else if g2 < 20.703 then
            prob := interpolate(0.90, 0.80, 18.114, 20.703) 
         else if g2 < 22.719 then
            prob := interpolate(0.80, 0.70, 20.703, 22.719) 
         else if g2 < 26.336 then
            prob := interpolate(0.70, 0.50, 22.719, 26.336) 
         else if g2 < 30.319 then
            prob := interpolate(0.50, 0.30, 26.336, 30.319) 
         else if g2 < 32.912 then
            prob := interpolate(0.30, 0.20 , 30.319, 32.912) 
         else if g2 < 36.7412 then
            prob := interpolate(0.20, 0.1, 32.912, 36.7412) 
         else if g2 <  40.1133 then
            prob := interpolate(0.1000,0.0500, 36.7412, 40.1133)
         else if g2 <  43.1945 then
            prob := interpolate(0.0500,0.0250, 40.1133, 43.1945)
         else if g2 <  46.9629 then
            prob := interpolate(0.0250,0.0100, 43.1945, 46.9629)
         else if g2 <  49.6449 then
            prob := interpolate(0.0100,0.0050, 46.9629, 49.6449)
         else if g2 <  55.4760 then
            prob := interpolate(0.0050,0.0010, 49.6449, 55.4760)
         else if g2 <  57.8576 then
            prob := interpolate(0.0010,0.0005, 55.4760, 57.8576)
         else if g2 <  63.1645 then
            prob := interpolate(0.0005,0.0001, 57.8576, 63.1645)
         else prob := 0.0;
      end
   else if df = 28 then
      begin
         if g2 <   8.2126 then prob := 0.9999
         else if g2 <   9.6563 then
            prob := interpolate(0.9999,0.9995,  8.2126,  9.6563)
         else if g2 <  10.3909 then
            prob := interpolate(0.9995,0.9990,  9.6563, 10.3909)
         else if g2 <  12.4613 then
            prob := interpolate(0.9990,0.9950, 10.3909, 12.4613)
         else if g2 <  13.5647 then
            prob := interpolate(0.9950,0.9900, 12.4613, 13.5647)
         else if g2 <  15.3079 then
            prob := interpolate(0.9900,0.9750, 13.5647, 15.3079)
         else if g2 <  16.9279 then
            prob := interpolate(0.9750,0.9500, 15.3079, 16.9279)
         else if g2 <  18.9392 then
            prob := interpolate(0.9500,0.9000, 16.9279, 18.9392)
         else if g2 < 21.588 then
            prob := interpolate(0.90, 0.80, 18.939, 21.588) 
         else if g2 < 23.647 then
            prob := interpolate(0.80, 0.70, 21.588, 23.647) 
         else if g2 < 27.336 then
            prob := interpolate(0.70, 0.50, 23.647, 27.336) 
         else if g2 < 31.391 then
            prob := interpolate(0.50, 0.30, 27.336, 31.391) 
         else if g2 < 34.027 then
            prob := interpolate(0.30, 0.20 , 31.391, 34.027) 
         else if g2 < 37.9159        then
            prob := interpolate(0.20, 0.1, 34.027, 37.9159) 
         else if g2 <  41.3371 then
            prob := interpolate(0.1000,0.0500, 37.9159, 41.3371)
         else if g2 <  44.4608 then
            prob := interpolate(0.0500,0.0250, 41.3371, 44.4608)
         else if g2 <  48.2782 then
            prob := interpolate(0.0250,0.0100, 44.4608, 48.2782)
         else if g2 <  50.9934 then
            prob := interpolate(0.0100,0.0050, 48.2782, 50.9934)
         else if g2 <  56.8923 then
            prob := interpolate(0.0050,0.0010, 50.9934, 56.8923)
         else if g2 <  59.3000 then
            prob := interpolate(0.0010,0.0005, 56.8923, 59.3000)
         else if g2 <  64.6624 then
            prob := interpolate(0.0005,0.0001, 59.3000, 64.6624)
         else prob := 0.0;
      end
   else if df = 29 then
      begin
         if g2 <   8.7315 then prob := 0.9999
         else if g2 <  10.2268 then
            prob := interpolate(0.9999,0.9995,  8.7315, 10.2268)
         else if g2 <  10.9861 then
            prob := interpolate(0.9995,0.9990, 10.2268, 10.9861)
         else if g2 <  13.1211 then
            prob := interpolate(0.9990,0.9950, 10.9861, 13.1211)
         else if g2 <  14.2565 then
            prob := interpolate(0.9950,0.9900, 13.1211, 14.2565)
         else if g2 <  16.0471 then
            prob := interpolate(0.9900,0.9750, 14.2565, 16.0471)
         else if g2 <  17.7084 then
            prob := interpolate(0.9750,0.9500, 16.0471, 17.7084)
         else if g2 <  19.7677 then
            prob := interpolate(0.9500,0.9000, 17.7084, 19.7677)
         else if g2 < 22.475 then
            prob := interpolate(0.90, 0.80, 19.768, 22.475) 
         else if g2 < 24.577 then
            prob := interpolate(0.80, 0.70, 22.475, 24.577) 
         else if g2 < 28.336 then
            prob := interpolate(0.70, 0.50, 24.577, 28.336) 
         else if g2 < 32.461 then
            prob := interpolate(0.50, 0.30, 28.336, 32.461) 
         else if g2 < 35.139 then
            prob := interpolate(0.30, 0.20 , 32.461, 35.139) 
         else if g2 < 39.0875        then
            prob := interpolate(0.20, 0.1, 35.139, 39.0875) 
         else if g2 <  42.5570 then
            prob := interpolate(0.1000,0.0500, 39.0875, 42.5570)
         else if g2 <  45.7223 then
            prob := interpolate(0.0500,0.0250, 42.5570, 45.7223)
         else if g2 <  49.5879 then
            prob := interpolate(0.0250,0.0100, 45.7223, 49.5879)
         else if g2 <  52.3356 then
            prob := interpolate(0.0100,0.0050, 49.5879, 52.3356)
         else if g2 <  58.3012 then
            prob := interpolate(0.0050,0.0010, 52.3356, 58.3012)
         else if g2 <  60.7346 then
            prob := interpolate(0.0010,0.0005, 58.3012, 60.7346)
         else if g2 <  66.1517 then
            prob := interpolate(0.0005,0.0001, 60.7346, 66.1517)
         else prob := 0.0;
      end
   else if df = 30 then
      begin
         if g2 <   9.2581 then prob := 0.9999
         else if g2 <  10.8044 then
            prob := interpolate(0.9999,0.9995,  9.2581, 10.8044)
         else if g2 <  11.5880 then
            prob := interpolate(0.9995,0.9990, 10.8044, 11.5880)
         else if g2 <  13.7867 then
            prob := interpolate(0.9990,0.9950, 11.5880, 13.7867)
         else if g2 <  14.9535 then
            prob := interpolate(0.9950,0.9900, 13.7867, 14.9535)
         else if g2 <  16.7908 then
            prob := interpolate(0.9900,0.9750, 14.9535, 16.7908)
         else if g2 <  18.4927 then
            prob := interpolate(0.9750,0.9500, 16.7908, 18.4927)
         else if g2 <  20.5992 then
            prob := interpolate(0.9500,0.9000, 18.4927, 20.5992)
         else if g2 < 23.364 then
            prob := interpolate(0.90, 0.80, 20.599, 23.364) 
         else if g2 < 25.508 then
            prob := interpolate(0.80, 0.70, 23.364, 25.508) 
         else if g2 < 29.336 then
            prob := interpolate(0.70, 0.50, 25.508, 29.336) 
         else if g2 < 33.530 then
            prob := interpolate(0.50, 0.30, 29.336, 33.530) 
         else if g2 < 36.250 then
            prob := interpolate(0.30, 0.20 , 33.530, 36.250) 
         else if g2 < 40.256  then
            prob := interpolate(0.20, 0.1, 36.250, 40.256) 
         else if g2 <  43.7730 then
            prob := interpolate(0.1000,0.0500, 40.2560, 43.7730)
         else if g2 <  46.9792 then
            prob := interpolate(0.0500,0.0250, 43.7730, 46.9792)
         else if g2 <  50.8922 then
            prob := interpolate(0.0250,0.0100, 46.9792, 50.8922)
         else if g2 <  53.6720 then
            prob := interpolate(0.0100,0.0050, 50.8922, 53.6720)
         else if g2 <  59.7031 then
            prob := interpolate(0.0050,0.0010, 53.6720, 59.7031)
         else if g2 <  62.1619 then
            prob := interpolate(0.0010,0.0005, 59.7031, 62.1619)
         else if g2 <  67.6326 then
            prob := interpolate(0.0005,0.0001, 62.1619, 67.6326)
         else prob := 0.0;
      end
   else if df = 31 then
      begin
         if g2 <   9.7921 then prob := 0.9999
         else if g2 <  11.3887 then
            prob := interpolate(0.9999,0.9995,  9.7921, 11.3887)
         else if g2 <  12.1963 then
            prob := interpolate(0.9995,0.9990, 11.3887, 12.1963)
         else if g2 <  14.4578 then
            prob := interpolate(0.9990,0.9950, 12.1963, 14.4578)
         else if g2 <  15.6555 then
            prob := interpolate(0.9950,0.9900, 14.4578, 15.6555)
         else if g2 <  17.5387 then
            prob := interpolate(0.9900,0.9750, 15.6555, 17.5387)
         else if g2 <  19.2806 then
            prob := interpolate(0.9750,0.9500, 17.5387, 19.2806)
         else if g2 <  21.4336 then
            prob := interpolate(0.9500,0.9000, 19.2806, 21.4336)
         else if g2 <  41.4217 then
            prob := interpolate(0.9000,0.1000, 21.4336, 41.4217)
         else if g2 <  44.9853 then
            prob := interpolate(0.1000,0.0500, 41.4217, 44.9853)
         else if g2 <  48.2319 then
            prob := interpolate(0.0500,0.0250, 44.9853, 48.2319)
         else if g2 <  52.1914 then
            prob := interpolate(0.0250,0.0100, 48.2319, 52.1914)
         else if g2 <  55.0027 then
            prob := interpolate(0.0100,0.0050, 52.1914, 55.0027)
         else if g2 <  61.0983 then
            prob := interpolate(0.0050,0.0010, 55.0027, 61.0983)
         else if g2 <  63.5820 then
            prob := interpolate(0.0010,0.0005, 61.0983, 63.5820)
         else if g2 <  69.1057 then
            prob := interpolate(0.0005,0.0001, 63.5820, 69.1057)
         else prob := 0.0;
      end
   else if df = 32 then
      begin
         if g2 <  10.3331 then prob := 0.9999
         else if g2 <  11.9794 then
            prob := interpolate(0.9999,0.9995, 10.3331, 11.9794)
         else if g2 <  12.8107 then
            prob := interpolate(0.9995,0.9990, 11.9794, 12.8107)
         else if g2 <  15.1340 then
            prob := interpolate(0.9990,0.9950, 12.8107, 15.1340)
         else if g2 <  16.3622 then
            prob := interpolate(0.9950,0.9900, 15.1340, 16.3622)
         else if g2 <  18.2908 then
            prob := interpolate(0.9900,0.9750, 16.3622, 18.2908)
         else if g2 <  20.0719 then
            prob := interpolate(0.9750,0.9500, 18.2908, 20.0719)
         else if g2 <  22.2706 then
            prob := interpolate(0.9500,0.9000, 20.0719, 22.2706)
         else if g2 <  42.5847 then
            prob := interpolate(0.9000,0.1000, 22.2706, 42.5847)
         else if g2 <  46.1943 then
            prob := interpolate(0.1000,0.0500, 42.5847, 46.1943)
         else if g2 <  49.4804 then
            prob := interpolate(0.0500,0.0250, 46.1943, 49.4804)
         else if g2 <  53.4858 then
            prob := interpolate(0.0250,0.0100, 49.4804, 53.4858)
         else if g2 <  56.3281 then
            prob := interpolate(0.0100,0.0050, 53.4858, 56.3281)
         else if g2 <  62.4872 then
            prob := interpolate(0.0050,0.0010, 56.3281, 62.4872)
         else if g2 <  64.9955 then
            prob := interpolate(0.0010,0.0005, 62.4872, 64.9955)
         else if g2 <  70.5712 then
            prob := interpolate(0.0005,0.0001, 64.9955, 70.5712)
         else prob := 0.0;
      end
   else if df = 33 then
      begin
         if g2 <  10.8810 then prob := 0.9999
         else if g2 <  12.5763 then
            prob := interpolate(0.9999,0.9995, 10.8810, 12.5763)
         else if g2 <  13.4309 then
            prob := interpolate(0.9995,0.9990, 12.5763, 13.4309)
         else if g2 <  15.8153 then
            prob := interpolate(0.9990,0.9950, 13.4309, 15.8153)
         else if g2 <  17.0735 then
            prob := interpolate(0.9950,0.9900, 15.8153, 17.0735)
         else if g2 <  19.0467 then
            prob := interpolate(0.9900,0.9750, 17.0735, 19.0467)
         else if g2 <  20.8665 then
            prob := interpolate(0.9750,0.9500, 19.0467, 20.8665)
         else if g2 <  23.1102 then
            prob := interpolate(0.9500,0.9000, 20.8665, 23.1102)
         else if g2 <  43.7452 then
            prob := interpolate(0.9000,0.1000, 23.1102, 43.7452)
         else if g2 <  47.3999 then
            prob := interpolate(0.1000,0.0500, 43.7452, 47.3999)
         else if g2 <  50.7251 then
            prob := interpolate(0.0500,0.0250, 47.3999, 50.7251)
         else if g2 <  54.7755 then
            prob := interpolate(0.0250,0.0100, 50.7251, 54.7755)
         else if g2 <  57.6484 then
            prob := interpolate(0.0100,0.0050, 54.7755, 57.6484)
         else if g2 <  63.8701 then
            prob := interpolate(0.0050,0.0010, 57.6484, 63.8701)
         else if g2 <  66.4025 then
            prob := interpolate(0.0010,0.0005, 63.8701, 66.4025)
         else if g2 <  72.0296 then
            prob := interpolate(0.0005,0.0001, 66.4025, 72.0296)
         else prob := 0.0;
      end
   else if df = 34 then
      begin
         if g2 <  11.4352 then prob := 0.9999
         else if g2 <  13.1791 then
            prob := interpolate(0.9999,0.9995, 11.4352, 13.1791)
         else if g2 <  14.0567 then
            prob := interpolate(0.9995,0.9990, 13.1791, 14.0567)
         else if g2 <  16.5013 then
            prob := interpolate(0.9990,0.9950, 14.0567, 16.5013)
         else if g2 <  17.7891 then
            prob := interpolate(0.9950,0.9900, 16.5013, 17.7891)
         else if g2 <  19.8063 then
            prob := interpolate(0.9900,0.9750, 17.7891, 19.8063)
         else if g2 <  21.6643 then
            prob := interpolate(0.9750,0.9500, 19.8063, 21.6643)
         else if g2 <  23.9523 then
            prob := interpolate(0.9500,0.9000, 21.6643, 23.9523)
         else if g2 <  44.9032 then
            prob := interpolate(0.9000,0.1000, 23.9523, 44.9032)
         else if g2 <  48.6024 then
            prob := interpolate(0.1000,0.0500, 44.9032, 48.6024)
         else if g2 <  51.9660 then
            prob := interpolate(0.0500,0.0250, 48.6024, 51.9660)
         else if g2 <  56.0609 then
            prob := interpolate(0.0250,0.0100, 51.9660, 56.0609)
         else if g2 <  58.9639 then
            prob := interpolate(0.0100,0.0050, 56.0609, 58.9639)
         else if g2 <  65.2472 then
            prob := interpolate(0.0050,0.0010, 58.9639, 65.2472)
         else if g2 <  67.8035 then
            prob := interpolate(0.0010,0.0005, 65.2472, 67.8035)
         else if g2 <  73.4812 then
            prob := interpolate(0.0005,0.0001, 67.8035, 73.4812)
         else prob := 0.0;
      end
   else if df = 35 then
      begin
         if g2 <  11.9957 then prob := 0.9999
         else if g2 <  13.7875 then
            prob := interpolate(0.9999,0.9995, 11.9957, 13.7875)
         else if g2 <  14.6878 then
            prob := interpolate(0.9995,0.9990, 13.7875, 14.6878)
         else if g2 <  17.1918 then
            prob := interpolate(0.9990,0.9950, 14.6878, 17.1918)
         else if g2 <  18.5089 then
            prob := interpolate(0.9950,0.9900, 17.1918, 18.5089)
         else if g2 <  20.5694 then
            prob := interpolate(0.9900,0.9750, 18.5089, 20.5694)
         else if g2 <  22.4650 then
            prob := interpolate(0.9750,0.9500, 20.5694, 22.4650)
         else if g2 <  24.7967 then
            prob := interpolate(0.9500,0.9000, 22.4650, 24.7967)
         else if g2 <  46.0588 then
            prob := interpolate(0.9000,0.1000, 24.7967, 46.0588)
         else if g2 <  49.8018 then
            prob := interpolate(0.1000,0.0500, 46.0588, 49.8018)
         else if g2 <  53.2033 then
            prob := interpolate(0.0500,0.0250, 49.8018, 53.2033)
         else if g2 <  57.3421 then
            prob := interpolate(0.0250,0.0100, 53.2033, 57.3421)
         else if g2 <  60.2748 then
            prob := interpolate(0.0100,0.0050, 57.3421, 60.2748)
         else if g2 <  66.6188 then
            prob := interpolate(0.0050,0.0010, 60.2748, 66.6188)
         else if g2 <  69.1986 then
            prob := interpolate(0.0010,0.0005, 66.6188, 69.1986)
         else if g2 <  74.9262 then
            prob := interpolate(0.0005,0.0001, 69.1986, 74.9262)
         else prob := 0.0;
      end
   else if df = 36 then
      begin
         if g2 <  12.5622 then prob := 0.9999
         else if g2 <  14.4012 then
            prob := interpolate(0.9999,0.9995, 12.5622, 14.4012)
         else if g2 <  15.3241 then
            prob := interpolate(0.9995,0.9990, 14.4012, 15.3241)
         else if g2 <  17.8867 then
            prob := interpolate(0.9990,0.9950, 15.3241, 17.8867)
         else if g2 <  19.2327 then
            prob := interpolate(0.9950,0.9900, 17.8867, 19.2327)
         else if g2 <  21.3359 then
            prob := interpolate(0.9900,0.9750, 19.2327, 21.3359)
         else if g2 <  23.2686 then
            prob := interpolate(0.9750,0.9500, 21.3359, 23.2686)
         else if g2 <  25.6433 then
            prob := interpolate(0.9500,0.9000, 23.2686, 25.6433)
         else if g2 <  47.2122 then
            prob := interpolate(0.9000,0.1000, 25.6433, 47.2122)
         else if g2 <  50.9985 then
            prob := interpolate(0.1000,0.0500, 47.2122, 50.9985)
         else if g2 <  54.4373 then
            prob := interpolate(0.0500,0.0250, 50.9985, 54.4373)
         else if g2 <  58.6192 then
            prob := interpolate(0.0250,0.0100, 54.4373, 58.6192)
         else if g2 <  61.5812 then
            prob := interpolate(0.0100,0.0050, 58.6192, 61.5812)
         else if g2 <  67.9852 then
            prob := interpolate(0.0050,0.0010, 61.5812, 67.9852)
         else if g2 <  70.5881 then
            prob := interpolate(0.0010,0.0005, 67.9852, 70.5881)
         else if g2 <  76.3650 then
            prob := interpolate(0.0005,0.0001, 70.5881, 76.3650)
         else prob := 0.0;
      end
   else if df = 37 then
      begin
         if g2 <  13.1343 then prob := 0.9999
         else if g2 <  15.0202 then
            prob := interpolate(0.9999,0.9995, 13.1343, 15.0202)
         else if g2 <  15.9653 then
            prob := interpolate(0.9995,0.9990, 15.0202, 15.9653)
         else if g2 <  18.5858 then
            prob := interpolate(0.9990,0.9950, 15.9653, 18.5858)
         else if g2 <  19.9602 then
            prob := interpolate(0.9950,0.9900, 18.5858, 19.9602)
         else if g2 <  22.1056 then
            prob := interpolate(0.9900,0.9750, 19.9602, 22.1056)
         else if g2 <  24.0749 then
            prob := interpolate(0.9750,0.9500, 22.1056, 24.0749)
         else if g2 <  26.4921 then
            prob := interpolate(0.9500,0.9000, 24.0749, 26.4921)
         else if g2 <  48.3634 then
            prob := interpolate(0.9000,0.1000, 26.4921, 48.3634)
         else if g2 <  52.1923 then
            prob := interpolate(0.1000,0.0500, 48.3634, 52.1923)
         else if g2 <  55.6680 then
            prob := interpolate(0.0500,0.0250, 52.1923, 55.6680)
         else if g2 <  59.8925 then
            prob := interpolate(0.0250,0.0100, 55.6680, 59.8925)
         else if g2 <  62.8833 then
            prob := interpolate(0.0100,0.0050, 59.8925, 62.8833)
         else if g2 <  69.3465 then
            prob := interpolate(0.0050,0.0010, 62.8833, 69.3465)
         else if g2 <  71.9722 then
            prob := interpolate(0.0010,0.0005, 69.3465, 71.9722)
         else if g2 <  77.7977 then
            prob := interpolate(0.0005,0.0001, 71.9722, 77.7977)
         else prob := 0.0;
      end
   else if df = 38 then
      begin
         if g2 <  13.7120 then prob := 0.9999
         else if g2 <  15.6441 then
            prob := interpolate(0.9999,0.9995, 13.7120, 15.6441)
         else if g2 <  16.6112 then
            prob := interpolate(0.9995,0.9990, 15.6441, 16.6112)
         else if g2 <  19.2889 then
            prob := interpolate(0.9990,0.9950, 16.6112, 19.2889)
         else if g2 <  20.6914 then
            prob := interpolate(0.9950,0.9900, 19.2889, 20.6914)
         else if g2 <  22.8785 then
            prob := interpolate(0.9900,0.9750, 20.6914, 22.8785)
         else if g2 <  24.8839 then
            prob := interpolate(0.9750,0.9500, 22.8785, 24.8839)
         else if g2 <  27.3430 then
            prob := interpolate(0.9500,0.9000, 24.8839, 27.3430)
         else if g2 <  49.5126 then
            prob := interpolate(0.9000,0.1000, 27.3430, 49.5126)
         else if g2 <  53.3835 then
            prob := interpolate(0.1000,0.0500, 49.5126, 53.3835)
         else if g2 <  56.8955 then
            prob := interpolate(0.0500,0.0250, 53.3835, 56.8955)
         else if g2 <  61.1621 then
            prob := interpolate(0.0250,0.0100, 56.8955, 61.1621)
         else if g2 <  64.1814 then
            prob := interpolate(0.0100,0.0050, 61.1621, 64.1814)
         else if g2 <  70.7029 then
            prob := interpolate(0.0050,0.0010, 64.1814, 70.7029)
         else if g2 <  73.3512 then
            prob := interpolate(0.0010,0.0005, 70.7029, 73.3512)
         else if g2 <  79.2247 then
            prob := interpolate(0.0005,0.0001, 73.3512, 79.2247)
         else prob := 0.0;
      end
   else if df = 39 then
      begin
         if g2 <  14.2950 then prob := 0.9999
         else if g2 <  16.2729 then
            prob := interpolate(0.9999,0.9995, 14.2950, 16.2729)
         else if g2 <  17.2616 then
            prob := interpolate(0.9995,0.9990, 16.2729, 17.2616)
         else if g2 <  19.9959 then
            prob := interpolate(0.9990,0.9950, 17.2616, 19.9959)
         else if g2 <  21.4262 then
            prob := interpolate(0.9950,0.9900, 19.9959, 21.4262)
         else if g2 <  23.6543 then
            prob := interpolate(0.9900,0.9750, 21.4262, 23.6543)
         else if g2 <  25.6954 then
            prob := interpolate(0.9750,0.9500, 23.6543, 25.6954)
         else if g2 <  28.1958 then
            prob := interpolate(0.9500,0.9000, 25.6954, 28.1958)
         else if g2 <  50.6598 then
            prob := interpolate(0.9000,0.1000, 28.1958, 50.6598)
         else if g2 <  54.5722 then
            prob := interpolate(0.1000,0.0500, 50.6598, 54.5722)
         else if g2 <  58.1201 then
            prob := interpolate(0.0500,0.0250, 54.5722, 58.1201)
         else if g2 <  62.4281 then
            prob := interpolate(0.0250,0.0100, 58.1201, 62.4281)
         else if g2 <  65.4756 then
            prob := interpolate(0.0100,0.0050, 62.4281, 65.4756)
         else if g2 <  72.0547 then
            prob := interpolate(0.0050,0.0010, 65.4756, 72.0547)
         else if g2 <  74.7253 then
            prob := interpolate(0.0010,0.0005, 72.0547, 74.7253)
         else if g2 <  80.6462 then
            prob := interpolate(0.0005,0.0001, 74.7253, 80.6462)
         else prob := 0.0;
      end
   else if df = 40 then
      begin
         if g2 <  14.8831 then prob := 0.9999
         else if g2 <  16.9062 then
            prob := interpolate(0.9999,0.9995, 14.8831, 16.9062)
         else if g2 <  17.9164 then
            prob := interpolate(0.9995,0.9990, 16.9062, 17.9164)
         else if g2 <  20.7065 then
            prob := interpolate(0.9990,0.9950, 17.9164, 20.7065)
         else if g2 <  22.1643 then
            prob := interpolate(0.9950,0.9900, 20.7065, 22.1643)
         else if g2 <  24.4330 then
            prob := interpolate(0.9900,0.9750, 22.1643, 24.4330)
         else if g2 <  26.5093 then
            prob := interpolate(0.9750,0.9500, 24.4330, 26.5093)
         else if g2 <  29.0505 then
            prob := interpolate(0.9500,0.9000, 26.5093, 29.0505)
         else if g2 <  51.8051 then
            prob := interpolate(0.9000,0.1000, 29.0505, 51.8051)
         else if g2 <  55.7585 then
            prob := interpolate(0.1000,0.0500, 51.8051, 55.7585)
         else if g2 <  59.3417 then
            prob := interpolate(0.0500,0.0250, 55.7585, 59.3417)
         else if g2 <  63.6907 then
            prob := interpolate(0.0250,0.0100, 59.3417, 63.6907)
         else if g2 <  66.7660 then
            prob := interpolate(0.0100,0.0050, 63.6907, 66.7660)
         else if g2 <  73.4020 then
            prob := interpolate(0.0050,0.0010, 66.7660, 73.4020)
         else if g2 <  76.0946 then
            prob := interpolate(0.0010,0.0005, 73.4020, 76.0946)
         else if g2 <  82.0623 then
            prob := interpolate(0.0005,0.0001, 76.0946, 82.0623)
         else prob := 0.0;
      end
   else if df <= 50 then
      begin
         if g2 <  21.0093 then prob := 0.9999
         else if g2 <  23.4610 then
            prob := interpolate(0.9999,0.9995, 21.0093, 23.4610)
         else if g2 <  24.6739 then
            prob := interpolate(0.9995,0.9990, 23.4610, 24.6739)
         else if g2 <  27.9907 then
            prob := interpolate(0.9990,0.9950, 24.6739, 27.9907)
         else if g2 <  29.7067 then
            prob := interpolate(0.9950,0.9900, 27.9907, 29.7067)
         else if g2 <  32.3574 then
            prob := interpolate(0.9900,0.9750, 29.7067, 32.3574)
         else if g2 <  34.7643 then
            prob := interpolate(0.9750,0.9500, 32.3574, 34.7643)
         else if g2 <  37.6886 then
            prob := interpolate(0.9500,0.9000, 34.7643, 37.6886)
         else if g2 <  63.1671 then
            prob := interpolate(0.9000,0.1000, 37.6886, 63.1671)
         else if g2 <  67.5048 then
            prob := interpolate(0.1000,0.0500, 63.1671, 67.5048)
         else if g2 <  71.4202 then
            prob := interpolate(0.0500,0.0250, 67.5048, 71.4202)
         else if g2 <  76.1539 then
            prob := interpolate(0.0250,0.0100, 71.4202, 76.1539)
         else if g2 <  79.4900 then
            prob := interpolate(0.0100,0.0050, 76.1539, 79.4900)
         else if g2 <  86.6608 then
            prob := interpolate(0.0050,0.0010, 79.4900, 86.6608)
         else if g2 <  89.5605 then
            prob := interpolate(0.0010,0.0005, 86.6608, 89.5605)
         else if g2 <  95.9687 then
            prob := interpolate(0.0005,0.0001, 89.5605, 95.9687)
         else prob := 0.0;
      end
   else if df <= 60 then
      begin
         if g2 <  27.4969 then prob := 0.9999
         else if g2 <  30.3405 then
            prob := interpolate(0.9999,0.9995, 27.4969, 30.3405)
         else if g2 <  31.7383 then
            prob := interpolate(0.9995,0.9990, 30.3405, 31.7383)
         else if g2 <  35.5345 then
            prob := interpolate(0.9990,0.9950, 31.7383, 35.5345)
         else if g2 <  37.4849 then
            prob := interpolate(0.9950,0.9900, 35.5345, 37.4849)
         else if g2 <  40.4817 then
            prob := interpolate(0.9900,0.9750, 37.4849, 40.4817)
         else if g2 <  43.1880 then
            prob := interpolate(0.9750,0.9500, 40.4817, 43.1880)
         else if g2 <  46.4589 then
            prob := interpolate(0.9500,0.9000, 43.1880, 46.4589)
         else if g2 <  74.3970 then
            prob := interpolate(0.9000,0.1000, 46.4589, 74.3970)
         else if g2 <  79.0819 then
            prob := interpolate(0.1000,0.0500, 74.3970, 79.0819)
         else if g2 <  83.2977 then
            prob := interpolate(0.0500,0.0250, 79.0819, 83.2977)
         else if g2 <  88.3794 then
            prob := interpolate(0.0250,0.0100, 83.2977, 88.3794)
         else if g2 <  91.9517 then
            prob := interpolate(0.0100,0.0050, 88.3794, 91.9517)
         else if g2 <  99.6072 then
            prob := interpolate(0.0050,0.0010, 91.9517, 99.6072)
         else if g2 < 102.6948 then
            prob := interpolate(0.0010,0.0005, 99.6072,102.6948)
         else if g2 < 109.5029 then
            prob := interpolate(0.0005,0.0001,102.6948,109.5029)
         else prob := 0.0;
      end
   else if df <= 70 then
      begin
         if g2 <  34.2607 then prob := 0.9999
         else if g2 <  37.4674 then
            prob := interpolate(0.9999,0.9995, 34.2607, 37.4674)
         else if g2 <  39.0364 then
            prob := interpolate(0.9995,0.9990, 37.4674, 39.0364)
         else if g2 <  43.2752 then
            prob := interpolate(0.9990,0.9950, 39.0364, 43.2752)
         else if g2 <  45.4417 then
            prob := interpolate(0.9950,0.9900, 43.2752, 45.4417)
         else if g2 <  48.7576 then
            prob := interpolate(0.9900,0.9750, 45.4417, 48.7576)
         else if g2 <  51.7393 then
            prob := interpolate(0.9750,0.9500, 48.7576, 51.7393)
         else if g2 <  55.3289 then
            prob := interpolate(0.9500,0.9000, 51.7393, 55.3289)
         else if g2 <  85.5270 then
            prob := interpolate(0.9000,0.1000, 55.3289, 85.5270)
         else if g2 <  90.5312 then
            prob := interpolate(0.1000,0.0500, 85.5270, 90.5312)
         else if g2 <  95.0232 then
            prob := interpolate(0.0500,0.0250, 90.5312, 95.0232)
         else if g2 < 100.4252 then
            prob := interpolate(0.0250,0.0100, 95.0232,100.4252)
         else if g2 < 104.2149 then
            prob := interpolate(0.0100,0.0050,100.4252,104.2149)
         else if g2 < 112.3169 then
            prob := interpolate(0.0050,0.0010,104.2149,112.3169)
         else if g2 < 115.5776 then
            prob := interpolate(0.0010,0.0005,112.3169,115.5776)
         else if g2 < 122.7547 then
            prob := interpolate(0.0005,0.0001,115.5776,122.7547)
         else prob := 0.0;
      end
   else if df <= 80 then
      begin
         if g2 <  41.2445 then prob := 0.9999
         else if g2 <  44.7910 then
            prob := interpolate(0.9999,0.9995, 41.2445, 44.7910)
         else if g2 <  46.5199 then
            prob := interpolate(0.9995,0.9990, 44.7910, 46.5199)
         else if g2 <  51.1719 then
            prob := interpolate(0.9990,0.9950, 46.5199, 51.1719)
         else if g2 <  53.5401 then
            prob := interpolate(0.9950,0.9900, 51.1719, 53.5401)
         else if g2 <  57.1532 then
            prob := interpolate(0.9900,0.9750, 53.5401, 57.1532)
         else if g2 <  60.3915 then
            prob := interpolate(0.9750,0.9500, 57.1532, 60.3915)
         else if g2 <  64.2778 then
            prob := interpolate(0.9500,0.9000, 60.3915, 64.2778)
         else if g2 <  96.5782 then
            prob := interpolate(0.9000,0.1000, 64.2778, 96.5782)
         else if g2 < 101.8795 then
            prob := interpolate(0.1000,0.0500, 96.5782,101.8795)
         else if g2 < 106.6286 then
            prob := interpolate(0.0500,0.0250,101.8795,106.6286)
         else if g2 < 112.3288 then
            prob := interpolate(0.0250,0.0100,106.6286,112.3288)
         else if g2 < 116.3211 then
            prob := interpolate(0.0100,0.0050,112.3288,116.3211)
         else if g2 < 124.8392 then
            prob := interpolate(0.0050,0.0010,116.3211,124.8392)
         else if g2 < 128.2613 then
            prob := interpolate(0.0010,0.0005,124.8392,128.2613)
         else if g2 < 135.7825 then
            prob := interpolate(0.0005,0.0001,128.2613,135.7825)
         else prob := 0.0;
      end
   else if df <= 90 then
      begin
         if g2 <  48.4087 then prob := 0.9999
         else if g2 <  52.2758 then
            prob := interpolate(0.9999,0.9995, 48.4087, 52.2758)
         else if g2 <  54.1552 then
            prob := interpolate(0.9995,0.9990, 52.2758, 54.1552)
         else if g2 <  59.1963 then
            prob := interpolate(0.9990,0.9950, 54.1552, 59.1963)
         else if g2 <  61.7541 then
            prob := interpolate(0.9950,0.9900, 59.1963, 61.7541)
         else if g2 <  65.6466 then
            prob := interpolate(0.9900,0.9750, 61.7541, 65.6466)
         else if g2 <  69.1260 then
            prob := interpolate(0.9750,0.9500, 65.6466, 69.1260)
         else if g2 <  73.2911 then
            prob := interpolate(0.9500,0.9000, 69.1260, 73.2911)
         else if g2 < 107.5650 then
            prob := interpolate(0.9000,0.1000, 73.2911,107.5650)
         else if g2 < 113.1453 then
            prob := interpolate(0.1000,0.0500,107.5650,113.1453)
         else if g2 < 118.1359 then
            prob := interpolate(0.0500,0.0250,113.1453,118.1359)
         else if g2 < 124.1163 then
            prob := interpolate(0.0250,0.0100,118.1359,124.1163)
         else if g2 < 128.2989 then
            prob := interpolate(0.0100,0.0050,124.1163,128.2989)
         else if g2 < 137.2084 then
            prob := interpolate(0.0050,0.0010,128.2989,137.2084)
         else if g2 < 140.7823 then
            prob := interpolate(0.0010,0.0005,137.2084,140.7823)
         else if g2 < 148.6273 then
            prob := interpolate(0.0005,0.0001,140.7823,148.6273)
         else prob := 0.0;
      end
   else 
      begin
         if g2 <  55.7246 then prob := 0.9999
         else if g2 <  59.8957 then
            prob := interpolate(0.9999,0.9995, 55.7246, 59.8957)
         else if g2 <  61.9179 then
            prob := interpolate(0.9995,0.9990, 59.8957, 61.9179)
         else if g2 <  67.3276 then
            prob := interpolate(0.9990,0.9950, 61.9179, 67.3276)
         else if g2 <  70.0649 then
            prob := interpolate(0.9950,0.9900, 67.3276, 70.0649)
         else if g2 <  74.2219 then
            prob := interpolate(0.9900,0.9750, 70.0649, 74.2219)
         else if g2 <  77.9295 then
            prob := interpolate(0.9750,0.9500, 74.2219, 77.9295)
         else if g2 <  82.3581 then
            prob := interpolate(0.9500,0.9000, 77.9295, 82.3581)
         else if g2 < 118.4980 then
            prob := interpolate(0.9000,0.1000, 82.3581,118.4980)
         else if g2 < 124.3421 then
            prob := interpolate(0.1000,0.0500,118.4980,124.3421)
         else if g2 < 129.5612 then
            prob := interpolate(0.0500,0.0250,124.3421,129.5612)
         else if g2 < 135.8067 then
            prob := interpolate(0.0250,0.0100,129.5612,135.8067)
         else if g2 < 140.1695 then
            prob := interpolate(0.0100,0.0050,135.8067,140.1695)
         else if g2 < 149.4493 then
            prob := interpolate(0.0050,0.0010,140.1695,149.4493)
         else if g2 < 153.1670 then
            prob := interpolate(0.0010,0.0005,149.4493,153.1670)
         else if g2 < 161.3187 then
            prob := interpolate(0.0005,0.0001,153.1670,161.3187)
         else prob := 0.0;
      end;
  chisquare2 := prob > signif;
end;



function chisquare(g2,df,signif: real; var prob: real): boolean;
   function interpolate(highprob, lowprob, highval, lowval: real): real;
   begin
        interpolate := lowprob + 
                ((g2 - lowval)/(highval - lowval)) * (highprob - lowprob);
   end;

var cutoff: real;
begin
   if df >= 20 then chisquare := chisquare2(g2,df,signif,prob)
   else
    begin
     if df = 1 then
      begin
         if g2 <   0.0000000157 then prob := 0.9999
         else if g2 <  0.000000393 then
            prob := interpolate(0.9999,0.9995,  0.0000000157,  0.000000393)
         else if g2 <  0.00000157  then
            prob := interpolate(0.9995,0.9990,  0.000000393,  0.00000157)
         else if g2 <  0.0000393 then
            prob := interpolate(0.9990,0.9950,  0.00000157,  0.0000393)
         else if g2 <   0.0002 then
            prob := interpolate(0.9950,0.9900,  0.0000393,  0.0002)
         else if g2 <   0.0010 then
            prob := interpolate(0.9900,0.9750,  0.0002,  0.0010)
         else if g2 <   0.0039 then
            prob := interpolate(0.9750,0.9500,  0.0010,  0.0039)
         else if g2 <   0.0158 then
            prob := interpolate(0.9500,0.9000,  0.0039,  0.0158)
         else if g2 < 0.0642 then
            prob := interpolate(0.90, 0.80, 0.0158, 0.0642) 
         else if g2 < 0.148 then
            prob := interpolate(0.80, 0.70, 0.0642, 0.148) 
         else if g2 < 0.455 then
            prob := interpolate(0.70, 0.50, 0.148, 0.455) 
         else if g2 < 1.074 then
            prob := interpolate(0.50, 0.30, 0.455, 1.074) 
         else if g2 < 1.642 then
            prob := interpolate(0.30, 0.20 , 1.074, 1.642) 
         else if g2 <   2.7055 then
            prob := interpolate(0.2000,0.1000,  1.642,  2.7055)
         else if g2 <   3.8415 then
            prob := interpolate(0.1000,0.0500,  2.7055,  3.8415)
         else if g2 <   5.0239 then
            prob := interpolate(0.0500,0.0250,  3.8415,  5.0239)
         else if g2 <   6.6349 then
            prob := interpolate(0.0250,0.0100,  5.0239,  6.6349)
         else if g2 <   7.8794 then
            prob := interpolate(0.0100,0.0050,  6.6349,  7.8794)
         else if g2 <  10.8276 then
            prob := interpolate(0.0050,0.0010,  7.8794, 10.8276)
         else if g2 <  12.1157 then
            prob := interpolate(0.0010,0.0005, 10.8276, 12.1157)
         else if g2 <  15.1367 then
            prob := interpolate(0.0005,0.0001, 12.1157, 15.1367)
         else prob := 0.0;
      end
   else if df = 2 then
      begin
         if g2 <   0.0002 then prob := 0.9999
         else if g2 <   0.0010 then
            prob := interpolate(0.9999,0.9995,  0.0002,  0.0010)
         else if g2 <   0.0020 then
            prob := interpolate(0.9995,0.9990,  0.0010,  0.0020)
         else if g2 <   0.0100 then
            prob := interpolate(0.9990,0.9950,  0.0020,  0.0100)
         else if g2 <   0.0201 then
            prob := interpolate(0.9950,0.9900,  0.0100,  0.0201)
         else if g2 <   0.0506 then
            prob := interpolate(0.9900,0.9750,  0.0201,  0.0506)
         else if g2 <   0.1026 then
            prob := interpolate(0.9750,0.9500,  0.0506,  0.1026)
         else if g2 <   0.2107 then
            prob := interpolate(0.9500,0.9000,  0.1026,  0.2107)
         else if g2 < 0.446 then
            prob := interpolate(0.90, 0.80, 0.211, 0.446) 
         else if g2 < 0.713 then
            prob := interpolate(0.80, 0.70, 0.446, 0.713) 
         else if g2 < 1.386 then
            prob := interpolate(0.70, 0.50, 0.713, 1.386) 
         else if g2 < 2.408 then
            prob := interpolate(0.50, 0.30, 1.386, 2.408) 
         else if g2 < 3.219 then
            prob := interpolate(0.30, 0.20 , 2.408, 3.219) 
         else if g2 < 4.6052 then
            prob := interpolate(0.20, 0.10, 3.219, 4.6052) 
         else if g2 <   5.9915 then
            prob := interpolate(0.1000,0.0500,  4.6052,  5.9915)
         else if g2 <   7.3778 then
            prob := interpolate(0.0500,0.0250,  5.9915,  7.3778)
         else if g2 <   9.2103 then
            prob := interpolate(0.0250,0.0100,  7.3778,  9.2103)
         else if g2 <  10.5966 then
            prob := interpolate(0.0100,0.0050,  9.2103, 10.5966)
         else if g2 <  13.8155 then
            prob := interpolate(0.0050,0.0010, 10.5966, 13.8155)
         else if g2 <  15.2018 then
            prob := interpolate(0.0010,0.0005, 13.8155, 15.2018)
         else if g2 <  18.4207 then
            prob := interpolate(0.0005,0.0001, 15.2018, 18.4207)
         else prob := 0.0;
      end
   else if df = 3 then
      begin
         if g2 <   0.0052 then prob := 0.9999
         else if g2 <   0.0153 then
            prob := interpolate(0.9999,0.9995,  0.0052,  0.0153)
         else if g2 <   0.0243 then
            prob := interpolate(0.9995,0.9990,  0.0153,  0.0243)
         else if g2 <   0.0717 then
            prob := interpolate(0.9990,0.9950,  0.0243,  0.0717)
         else if g2 <   0.1148 then
            prob := interpolate(0.9950,0.9900,  0.0717,  0.1148)
         else if g2 <   0.2158 then
            prob := interpolate(0.9900,0.9750,  0.1148,  0.2158)
         else if g2 <   0.3518 then
            prob := interpolate(0.9750,0.9500,  0.2158,  0.3518)
         else if g2 <   0.5844 then
            prob := interpolate(0.9500,0.9000,  0.3518,  0.5844)
         else if g2 < 1.005 then
            prob := interpolate(0.90, 0.80, 0.584, 1.005) 
         else if g2 < 1.424 then
            prob := interpolate(0.80, 0.70, 1.005, 1.424) 
         else if g2 < 2.366 then
            prob := interpolate(0.70, 0.50, 1.424, 2.366) 
         else if g2 < 3.665 then
            prob := interpolate(0.50, 0.30, 2.366, 3.665) 
         else if g2 < 4.642 then
            prob := interpolate(0.30, 0.20 , 3.665, 4.642) 
         else if g2 <   6.2514 then
            prob := interpolate(0.2000,0.1000,  4.642,  6.2514)
         else if g2 <   7.8147 then
            prob := interpolate(0.1000,0.0500,  6.2514,  7.8147)
         else if g2 <   9.3484 then
            prob := interpolate(0.0500,0.0250,  7.8147,  9.3484)
         else if g2 <  11.3449 then
            prob := interpolate(0.0250,0.0100,  9.3484, 11.3449)
         else if g2 <  12.8382 then
            prob := interpolate(0.0100,0.0050, 11.3449, 12.8382)
         else if g2 <  16.2662 then
            prob := interpolate(0.0050,0.0010, 12.8382, 16.2662)
         else if g2 <  17.7300 then
            prob := interpolate(0.0010,0.0005, 16.2662, 17.7300)
         else if g2 <  21.1075 then
            prob := interpolate(0.0005,0.0001, 17.7300, 21.1075)
         else prob := 0.0;
      end
   else if df = 4 then
      begin
         if g2 <   0.0284 then prob := 0.9999
         else if g2 <   0.0639 then
            prob := interpolate(0.9999,0.9995,  0.0284,  0.0639)
         else if g2 <   0.0908 then
            prob := interpolate(0.9995,0.9990,  0.0639,  0.0908)
         else if g2 <   0.2070 then
            prob := interpolate(0.9990,0.9950,  0.0908,  0.2070)
         else if g2 <   0.2971 then
            prob := interpolate(0.9950,0.9900,  0.2070,  0.2971)
         else if g2 <   0.4844 then
            prob := interpolate(0.9900,0.9750,  0.2971,  0.4844)
         else if g2 <   0.7107 then
            prob := interpolate(0.9750,0.9500,  0.4844,  0.7107)
         else if g2 <   1.0636 then
            prob := interpolate(0.9500,0.9000,  0.7107,  1.0636)
         else if g2 < 1.649 then
            prob := interpolate(0.90, 0.80, 1.064, 1.649) 
         else if g2 < 2.195 then
            prob := interpolate(0.80, 0.70, 1.649, 2.195) 
         else if g2 < 3.357 then
            prob := interpolate(0.70, 0.50, 2.195, 3.357) 
         else if g2 < 4.878 then
            prob := interpolate(0.50, 0.30, 3.357, 4.878) 
         else if g2 < 5.989 then
            prob := interpolate(0.30, 0.20 , 4.878, 5.989) 
         else if g2 <   7.7794 then
            prob := interpolate(0.2000,0.1000,  5.989, 7.7794)
         else if g2 <   9.4877 then
            prob := interpolate(0.1000,0.0500,  7.7794,  9.4877)
         else if g2 <  11.1433 then
            prob := interpolate(0.0500,0.0250,  9.4877, 11.1433)
         else if g2 <  13.2767 then
            prob := interpolate(0.0250,0.0100, 11.1433, 13.2767)
         else if g2 <  14.8603 then
            prob := interpolate(0.0100,0.0050, 13.2767, 14.8603)
         else if g2 <  18.4668 then
            prob := interpolate(0.0050,0.0010, 14.8603, 18.4668)
         else if g2 <  19.9974 then
            prob := interpolate(0.0010,0.0005, 18.4668, 19.9974)
         else if g2 <  23.5127 then
            prob := interpolate(0.0005,0.0001, 19.9974, 23.5127)
         else prob := 0.0;
      end
   else if df = 5 then
      begin
         if g2 <   0.0822 then prob := 0.9999
         else if g2 <   0.1581 then
            prob := interpolate(0.9999,0.9995,  0.0822,  0.1581)
         else if g2 <   0.2102 then
            prob := interpolate(0.9995,0.9990,  0.1581,  0.2102)
         else if g2 <   0.4117 then
            prob := interpolate(0.9990,0.9950,  0.2102,  0.4117)
         else if g2 <   0.5543 then
            prob := interpolate(0.9950,0.9900,  0.4117,  0.5543)
         else if g2 <   0.8312 then
            prob := interpolate(0.9900,0.9750,  0.5543,  0.8312)
         else if g2 <   1.1455 then
            prob := interpolate(0.9750,0.9500,  0.8312,  1.1455)
         else if g2 <   1.6103 then
            prob := interpolate(0.9500,0.9000,  1.1455,  1.6103)
         else if g2 < 2.343 then
            prob := interpolate(0.90, 0.80, 1.610, 2.343) 
         else if g2 < 3.000 then
            prob := interpolate(0.80, 0.70, 2.343, 3.000) 
         else if g2 < 4.351 then
            prob := interpolate(0.70, 0.50, 3.000, 4.351) 
         else if g2 < 6.064 then
            prob := interpolate(0.50, 0.30, 4.351, 6.064) 
         else if g2 < 7.289 then
            prob := interpolate(0.30, 0.20 , 6.064, 7.289) 
         else if g2 < 9.2364 then
            prob := interpolate(0.20, 0.1, 7.289, 9.2364) 
         else if g2 <  11.0705 then
            prob := interpolate(0.1000,0.0500,  9.2364, 11.0705)
         else if g2 <  12.8325 then
            prob := interpolate(0.0500,0.0250, 11.0705, 12.8325)
         else if g2 <  15.0863 then
            prob := interpolate(0.0250,0.0100, 12.8325, 15.0863)
         else if g2 <  16.7496 then
            prob := interpolate(0.0100,0.0050, 15.0863, 16.7496)
         else if g2 <  20.5150 then
            prob := interpolate(0.0050,0.0010, 16.7496, 20.5150)
         else if g2 <  22.1053 then
            prob := interpolate(0.0010,0.0005, 20.5150, 22.1053)
         else if g2 <  25.7448 then
            prob := interpolate(0.0005,0.0001, 22.1053, 25.7448)
         else prob := 0.0;
      end
   else if df = 6 then
      begin
         if g2 <   0.1724 then prob := 0.9999
         else if g2 <   0.2994 then
            prob := interpolate(0.9999,0.9995,  0.1724,  0.2994)
         else if g2 <   0.3811 then
            prob := interpolate(0.9995,0.9990,  0.2994,  0.3811)
         else if g2 <   0.6757 then
            prob := interpolate(0.9990,0.9950,  0.3811,  0.6757)
         else if g2 <   0.8721 then
            prob := interpolate(0.9950,0.9900,  0.6757,  0.8721)
         else if g2 <   1.2373 then
            prob := interpolate(0.9900,0.9750,  0.8721,  1.2373)
         else if g2 <   1.6354 then
            prob := interpolate(0.9750,0.9500,  1.2373,  1.6354)
         else if g2 <   2.2041 then
            prob := interpolate(0.9500,0.9000,  1.6354,  2.2041)
         else if g2 < 3.070 then
            prob := interpolate(0.90, 0.80, 2.204, 3.070) 
         else if g2 < 3.828 then
            prob := interpolate(0.80, 0.70, 3.070, 3.828) 
         else if g2 < 5.348 then
            prob := interpolate(0.70, 0.50, 3.828, 5.348) 
         else if g2 < 7.231 then
            prob := interpolate(0.50, 0.30, 5.348, 7.231) 
         else if g2 < 8.558 then
            prob := interpolate(0.30, 0.20 , 7.231, 8.558) 
         else if g2 < 10.6446 then
            prob := interpolate(0.20, 0.1, 8.558, 10.6446) 
         else if g2 <  12.5916 then
            prob := interpolate(0.1000,0.0500, 10.6446, 12.5916)
         else if g2 <  14.4494 then
            prob := interpolate(0.0500,0.0250, 12.5916, 14.4494)
         else if g2 <  16.8119 then
            prob := interpolate(0.0250,0.0100, 14.4494, 16.8119)
         else if g2 <  18.5476 then
            prob := interpolate(0.0100,0.0050, 16.8119, 18.5476)
         else if g2 <  22.4577 then
            prob := interpolate(0.0050,0.0010, 18.5476, 22.4577)
         else if g2 <  24.1028 then
            prob := interpolate(0.0010,0.0005, 22.4577, 24.1028)
         else if g2 <  27.8563 then
            prob := interpolate(0.0005,0.0001, 24.1028, 27.8563)
         else prob := 0.0;
      end
   else if df = 7 then
      begin
         if g2 <   0.3000 then prob := 0.9999
         else if g2 <   0.4849 then
            prob := interpolate(0.9999,0.9995,  0.3000,  0.4849)
         else if g2 <   0.5985 then
            prob := interpolate(0.9995,0.9990,  0.4849,  0.5985)
         else if g2 <   0.9893 then
            prob := interpolate(0.9990,0.9950,  0.5985,  0.9893)
         else if g2 <   1.2390 then
            prob := interpolate(0.9950,0.9900,  0.9893,  1.2390)
         else if g2 <   1.6899 then
            prob := interpolate(0.9900,0.9750,  1.2390,  1.6899)
         else if g2 <   2.1673 then
            prob := interpolate(0.9750,0.9500,  1.6899,  2.1673)
         else if g2 <   2.8331 then
            prob := interpolate(0.9500,0.9000,  2.1673,  2.8331)
         else if g2 < 3.882 then
            prob := interpolate(0.90, 0.80, 2.833, 3.882) 
         else if g2 < 4.671 then
            prob := interpolate(0.80, 0.70, 3.882, 4.671) 
         else if g2 < 6.346 then
            prob := interpolate(0.70, 0.50, 4.671, 6.346) 
         else if g2 < 8.383 then
            prob := interpolate(0.50, 0.30, 6.346, 8.383) 
         else if g2 < 9.803 then
            prob := interpolate(0.30, 0.20 , 8.383, 9.803) 
         else if g2 < 12.017 then
            prob := interpolate(0.20, 0.1, 9.803, 12.017) 
         else if g2 <  14.0671 then
            prob := interpolate(0.1000,0.0500, 12.0170, 14.0671)
         else if g2 <  16.0128 then
            prob := interpolate(0.0500,0.0250, 14.0671, 16.0128)
         else if g2 <  18.4753 then
            prob := interpolate(0.0250,0.0100, 16.0128, 18.4753)
         else if g2 <  20.2777 then
            prob := interpolate(0.0100,0.0050, 18.4753, 20.2777)
         else if g2 <  24.3219 then
            prob := interpolate(0.0050,0.0010, 20.2777, 24.3219)
         else if g2 <  26.0178 then
            prob := interpolate(0.0010,0.0005, 24.3219, 26.0178)
         else if g2 <  29.8775 then
            prob := interpolate(0.0005,0.0001, 26.0178, 29.8775)
         else prob := 0.0;
      end
   else if df = 8 then
      begin
         if g2 <   0.4636 then prob := 0.9999
         else if g2 <   0.7104 then
            prob := interpolate(0.9999,0.9995,  0.4636,  0.7104)
         else if g2 <   0.8571 then
            prob := interpolate(0.9995,0.9990,  0.7104,  0.8571)
         else if g2 <   1.3444 then
            prob := interpolate(0.9990,0.9950,  0.8571,  1.3444)
         else if g2 <   1.6465 then
            prob := interpolate(0.9950,0.9900,  1.3444,  1.6465)
         else if g2 <   2.1797 then
            prob := interpolate(0.9900,0.9750,  1.6465,  2.1797)
         else if g2 <   2.7326 then
            prob := interpolate(0.9750,0.9500,  2.1797,  2.7326)
         else if g2 <   3.4895 then
            prob := interpolate(0.9500,0.9000,  2.7326,  3.4895)
         else if g2 < 4.594 then
            prob := interpolate(0.90, 0.80, 3.490, 4.594) 
         else if g2 < 5.527 then
            prob := interpolate(0.80, 0.70, 4.594, 5.527) 
         else if g2 < 7.344 then
            prob := interpolate(0.70, 0.50, 5.527, 7.344) 
         else if g2 < 9.524 then
            prob := interpolate(0.50, 0.30, 7.344, 9.524) 
         else if g2 < 11.030 then
            prob := interpolate(0.30, 0.20 , 9.524, 11.030) 
         else if g2 < 13.3616 then
            prob := interpolate(0.20, 0.1, 11.030, 13.3616) 
         else if g2 <  15.5073 then
            prob := interpolate(0.1000,0.0500, 13.3616, 15.5073)
         else if g2 <  17.5345 then
            prob := interpolate(0.0500,0.0250, 15.5073, 17.5345)
         else if g2 <  20.0902 then
            prob := interpolate(0.0250,0.0100, 17.5345, 20.0902)
         else if g2 <  21.9550 then
            prob := interpolate(0.0100,0.0050, 20.0902, 21.9550)
         else if g2 <  26.1245 then
            prob := interpolate(0.0050,0.0010, 21.9550, 26.1245)
         else if g2 <  27.8680 then
            prob := interpolate(0.0010,0.0005, 26.1245, 27.8680)
         else if g2 <  31.8276 then
            prob := interpolate(0.0005,0.0001, 27.8680, 31.8276)
         else prob := 0.0;
      end
   else if df = 9 then
      begin
         if g2 <   0.6608 then prob := 0.9999
         else if g2 <   0.9717 then
            prob := interpolate(0.9999,0.9995,  0.6608,  0.9717)
         else if g2 <   1.1519 then
            prob := interpolate(0.9995,0.9990,  0.9717,  1.1519)
         else if g2 <   1.7349 then
            prob := interpolate(0.9990,0.9950,  1.1519,  1.7349)
         else if g2 <   2.0879 then
            prob := interpolate(0.9950,0.9900,  1.7349,  2.0879)
         else if g2 <   2.7004 then
            prob := interpolate(0.9900,0.9750,  2.0879,  2.7004)
         else if g2 <   3.3251 then
            prob := interpolate(0.9750,0.9500,  2.7004,  3.3251)
         else if g2 <   4.1682 then
            prob := interpolate(0.9500,0.9000,  3.3251,  4.1682)
         else if g2 < 5.380 then
            prob := interpolate(0.90, 0.80, 4.168, 5.380) 
         else if g2 < 6.393 then
            prob := interpolate(0.80, 0.70, 5.380, 6.393) 
         else if g2 < 8.343 then
            prob := interpolate(0.70, 0.50, 6.393, 8.343) 
         else if g2 < 10.656 then
            prob := interpolate(0.50, 0.30, 8.343, 10.656) 
         else if g2 < 12.242 then
            prob := interpolate(0.30, 0.20 , 10.656, 12.242) 
         else if g2 < 14.6837 then
            prob := interpolate(0.20, 0.1, 12.242, 14.6837) 
         else if g2 <  16.9190 then
            prob := interpolate(0.1000,0.0500, 14.6837, 16.9190)
         else if g2 <  19.0228 then
            prob := interpolate(0.0500,0.0250, 16.9190, 19.0228)
         else if g2 <  21.6660 then
            prob := interpolate(0.0250,0.0100, 19.0228, 21.6660)
         else if g2 <  23.5894 then
            prob := interpolate(0.0100,0.0050, 21.6660, 23.5894)
         else if g2 <  27.8772 then
            prob := interpolate(0.0050,0.0010, 23.5894, 27.8772)
         else if g2 <  29.6658 then
            prob := interpolate(0.0010,0.0005, 27.8772, 29.6658)
         else if g2 <  33.7199 then
            prob := interpolate(0.0005,0.0001, 29.6658, 33.7199)
         else prob := 0.0;
      end
   else if df = 10 then
      begin
         if g2 <   0.8889 then prob := 0.9999
         else if g2 <   1.2650 then
            prob := interpolate(0.9999,0.9995,  0.8889,  1.2650)
         else if g2 <   1.4787 then
            prob := interpolate(0.9995,0.9990,  1.2650,  1.4787)
         else if g2 <   2.1559 then
            prob := interpolate(0.9990,0.9950,  1.4787,  2.1559)
         else if g2 <   2.5582 then
            prob := interpolate(0.9950,0.9900,  2.1559,  2.5582)
         else if g2 <   3.2470 then
            prob := interpolate(0.9900,0.9750,  2.5582,  3.2470)
         else if g2 <   3.9403 then
            prob := interpolate(0.9750,0.9500,  3.2470,  3.9403)
         else if g2 <   4.8652 then
            prob := interpolate(0.9500,0.9000,  3.9403,  4.8652)
         else if g2 < 6.179 then
            prob := interpolate(0.90, 0.80, 4.865, 6.179) 
         else if g2 < 7.267 then
            prob := interpolate(0.80, 0.70, 6.179, 7.267) 
         else if g2 < 9.342 then
            prob := interpolate(0.70, 0.50, 7.267, 9.342) 
         else if g2 < 11.781 then
            prob := interpolate(0.50, 0.30, 9.342, 11.781) 
         else if g2 < 13.442 then
            prob := interpolate(0.30, 0.20, 11.781, 13.442) 
         else if g2 < 15.9872 then
            prob := interpolate(0.20, 0.10, 13.442, 15.9872) 
         else if g2 <  18.3070 then
            prob := interpolate(0.1000,0.0500, 15.9872, 18.3070)
         else if g2 <  20.4832 then
            prob := interpolate(0.0500,0.0250, 18.3070, 20.4832)
         else if g2 <  23.2093 then
            prob := interpolate(0.0250,0.0100, 20.4832, 23.2093)
         else if g2 <  25.1882 then
            prob := interpolate(0.0100,0.0050, 23.2093, 25.1882)
         else if g2 <  29.5883 then
            prob := interpolate(0.0050,0.0010, 25.1882, 29.5883)
         else if g2 <  31.4198 then
            prob := interpolate(0.0010,0.0005, 29.5883, 31.4198)
         else if g2 <  35.5640 then
            prob := interpolate(0.0005,0.0001, 31.4198, 35.5640)
         else prob := 0.0;
      end
   else if df = 11 then
      begin
         if g2 <   1.1453 then prob := 0.9999
         else if g2 <   1.5868 then
            prob := interpolate(0.9999,0.9995,  1.1453,  1.5868)
         else if g2 <   1.8339 then
            prob := interpolate(0.9995,0.9990,  1.5868,  1.8339)
         else if g2 <   2.6032 then
            prob := interpolate(0.9990,0.9950,  1.8339,  2.6032)
         else if g2 <   3.0535 then
            prob := interpolate(0.9950,0.9900,  2.6032,  3.0535)
         else if g2 <   3.8157 then
            prob := interpolate(0.9900,0.9750,  3.0535,  3.8157)
         else if g2 <   4.5748 then
            prob := interpolate(0.9750,0.9500,  3.8157,  4.5748)
         else if g2 <   5.5778 then
            prob := interpolate(0.9500,0.9000,  4.5748,  5.5778)
         else if g2 < 6.989 then
            prob := interpolate(0.90, 0.80, 5.578, 6.989) 
         else if g2 < 8.148 then
            prob := interpolate(0.80, 0.70, 6.989, 8.148) 
         else if g2 < 10.341 then
            prob := interpolate(0.70, 0.50, 8.148, 10.341) 
         else if g2 < 12.899 then
            prob := interpolate(0.50, 0.30, 10.341, 12.899) 
         else if g2 < 14.631 then
            prob := interpolate(0.30, 0.20 , 12.899, 14.631) 
         else if g2 < 17.275 then
            prob := interpolate(0.20, 0.1, 14.631, 17.275) 
         else if g2 <  19.6751 then
            prob := interpolate(0.1000,0.0500, 17.2750, 19.6751)
         else if g2 <  21.9200 then
            prob := interpolate(0.0500,0.0250, 19.6751, 21.9200)
         else if g2 <  24.7250 then
            prob := interpolate(0.0250,0.0100, 21.9200, 24.7250)
         else if g2 <  26.7568 then
            prob := interpolate(0.0100,0.0050, 24.7250, 26.7568)
         else if g2 <  31.2641 then
            prob := interpolate(0.0050,0.0010, 26.7568, 31.2641)
         else if g2 <  33.1366 then
            prob := interpolate(0.0010,0.0005, 31.2641, 33.1366)
         else if g2 <  37.3670 then
            prob := interpolate(0.0005,0.0001, 33.1366, 37.3670)
         else prob := 0.0;
      end
   else if df = 12 then
      begin
         if g2 <   1.4275 then prob := 0.9999
         else if g2 <   1.9344 then
            prob := interpolate(0.9999,0.9995,  1.4275,  1.9344)
         else if g2 <   2.2142 then
            prob := interpolate(0.9995,0.9990,  1.9344,  2.2142)
         else if g2 <   3.0738 then
            prob := interpolate(0.9990,0.9950,  2.2142,  3.0738)
         else if g2 <   3.5706 then
            prob := interpolate(0.9950,0.9900,  3.0738,  3.5706)
         else if g2 <   4.4038 then
            prob := interpolate(0.9900,0.9750,  3.5706,  4.4038)
         else if g2 <   5.2260 then
            prob := interpolate(0.9750,0.9500,  4.4038,  5.2260)
         else if g2 <   6.3038 then
            prob := interpolate(0.9500,0.9000,  5.2260,  6.3038)
         else if g2 < 7.807 then
            prob := interpolate(0.90, 0.80, 6.304, 7.807) 
         else if g2 < 9.034 then
            prob := interpolate(0.80, 0.70, 7.807, 9.034) 
         else if g2 < 11.340 then
            prob := interpolate(0.70, 0.50, 9.034, 11.340) 
         else if g2 < 14.011 then
            prob := interpolate(0.50, 0.30, 11.340, 14.011) 
         else if g2 < 15.812 then
            prob := interpolate(0.30, 0.20 , 14.011, 15.812) 
         else if g2 < 18.5493 then
            prob := interpolate(0.20, 0.1, 15.812, 18.5493) 
         else if g2 <  21.0261 then
            prob := interpolate(0.1000,0.0500, 18.5493, 21.0261)
         else if g2 <  23.3367 then
            prob := interpolate(0.0500,0.0250, 21.0261, 23.3367)
         else if g2 <  26.2170 then
            prob := interpolate(0.0250,0.0100, 23.3367, 26.2170)
         else if g2 <  28.2995 then
            prob := interpolate(0.0100,0.0050, 26.2170, 28.2995)
         else if g2 <  32.9095 then
            prob := interpolate(0.0050,0.0010, 28.2995, 32.9095)
         else if g2 <  34.8213 then
            prob := interpolate(0.0010,0.0005, 32.9095, 34.8213)
         else if g2 <  39.1344 then
            prob := interpolate(0.0005,0.0001, 34.8213, 39.1344)
         else prob := 0.0;
      end
   else if df = 13 then
      begin
         if g2 <   1.7333 then prob := 0.9999
         else if g2 <   2.3051 then
            prob := interpolate(0.9999,0.9995,  1.7333,  2.3051)
         else if g2 <   2.6172 then
            prob := interpolate(0.9995,0.9990,  2.3051,  2.6172)
         else if g2 <   3.5650 then
            prob := interpolate(0.9990,0.9950,  2.6172,  3.5650)
         else if g2 <   4.1069 then
            prob := interpolate(0.9950,0.9900,  3.5650,  4.1069)
         else if g2 <   5.0088 then
            prob := interpolate(0.9900,0.9750,  4.1069,  5.0088)
         else if g2 <   5.8919 then
            prob := interpolate(0.9750,0.9500,  5.0088,  5.8919)
         else if g2 <   7.0415 then
            prob := interpolate(0.9500,0.9000,  5.8919,  7.0415)
         else if g2 < 8.634 then
            prob := interpolate(0.90, 0.80, 7.042, 8.634) 
         else if g2 < 9.926 then
            prob := interpolate(0.80, 0.70, 8.634, 9.926) 
         else if g2 < 12.340 then
            prob := interpolate(0.70, 0.50, 9.926, 12.340) 
         else if g2 < 15.119 then
            prob := interpolate(0.50, 0.30, 12.340, 15.119) 
         else if g2 < 16.985 then
            prob := interpolate(0.30, 0.20 , 15.119, 16.985) 
         else if g2 < 19.8119 then
            prob := interpolate(0.20, 0.1, 16.985, 19.8119) 
         else if g2 <  22.3620 then
            prob := interpolate(0.1000,0.0500, 19.8119, 22.3620)
         else if g2 <  24.7356 then
            prob := interpolate(0.0500,0.0250, 22.3620, 24.7356)
         else if g2 <  27.6882 then
            prob := interpolate(0.0250,0.0100, 24.7356, 27.6882)
         else if g2 <  29.8195 then
            prob := interpolate(0.0100,0.0050, 27.6882, 29.8195)
         else if g2 <  34.5282 then
            prob := interpolate(0.0050,0.0010, 29.8195, 34.5282)
         else if g2 <  36.4778 then
            prob := interpolate(0.0010,0.0005, 34.5282, 36.4778)
         else if g2 <  40.8707 then
            prob := interpolate(0.0005,0.0001, 36.4778, 40.8707)
         else prob := 0.0;
      end
   else if df = 14 then
      begin
         if g2 <   2.0608 then prob := 0.9999
         else if g2 <   2.6967 then
            prob := interpolate(0.9999,0.9995,  2.0608,  2.6967)
         else if g2 <   3.0407 then
            prob := interpolate(0.9995,0.9990,  2.6967,  3.0407)
         else if g2 <   4.0747 then
            prob := interpolate(0.9990,0.9950,  3.0407,  4.0747)
         else if g2 <   4.6604 then
            prob := interpolate(0.9950,0.9900,  4.0747,  4.6604)
         else if g2 <   5.6287 then
            prob := interpolate(0.9900,0.9750,  4.6604,  5.6287)
         else if g2 <   6.5706 then
            prob := interpolate(0.9750,0.9500,  5.6287,  6.5706)
         else if g2 <   7.7895 then
            prob := interpolate(0.9500,0.9000,  6.5706,  7.7895)
         else if g2 < 9.467 then
            prob := interpolate(0.90, 0.80, 7.790, 9.467) 
         else if g2 < 10.821 then
            prob := interpolate(0.80, 0.70, 9.467, 10.821) 
         else if g2 < 13.339 then
            prob := interpolate(0.70, 0.50, 10.821, 13.339) 
         else if g2 < 16.222 then
            prob := interpolate(0.50, 0.30, 13.339, 16.222) 
         else if g2 < 18.151 then
            prob := interpolate(0.30, 0.20 , 16.222, 18.151) 
         else if g2 < 21.0641 then
            prob := interpolate(0.20, 0.1, 18.151, 21.0641) 
         else if g2 <  23.6848 then
            prob := interpolate(0.1000,0.0500, 21.0641, 23.6848)
         else if g2 <  26.1189 then
            prob := interpolate(0.0500,0.0250, 23.6848, 26.1189)
         else if g2 <  29.1412 then
            prob := interpolate(0.0250,0.0100, 26.1189, 29.1412)
         else if g2 <  31.3193 then
            prob := interpolate(0.0100,0.0050, 29.1412, 31.3193)
         else if g2 <  36.1233 then
            prob := interpolate(0.0050,0.0010, 31.3193, 36.1233)
         else if g2 <  38.1094 then
            prob := interpolate(0.0010,0.0005, 36.1233, 38.1094)
         else if g2 <  42.5793 then
            prob := interpolate(0.0005,0.0001, 38.1094, 42.5793)
         else prob := 0.0;
      end
   else if df = 15 then
      begin
         if g2 <   2.4082 then prob := 0.9999
         else if g2 <   3.1075 then
            prob := interpolate(0.9999,0.9995,  2.4082,  3.1075)
         else if g2 <   3.4827 then
            prob := interpolate(0.9995,0.9990,  3.1075,  3.4827)
         else if g2 <   4.6009 then
            prob := interpolate(0.9990,0.9950,  3.4827,  4.6009)
         else if g2 <   5.2293 then
            prob := interpolate(0.9950,0.9900,  4.6009,  5.2293)
         else if g2 <   6.2621 then
            prob := interpolate(0.9900,0.9750,  5.2293,  6.2621)
         else if g2 <   7.2609 then
            prob := interpolate(0.9750,0.9500,  6.2621,  7.2609)
         else if g2 <   8.5468 then
            prob := interpolate(0.9500,0.9000,  7.2609,  8.5468)
         else if g2 < 10.307 then
            prob := interpolate(0.90, 0.80, 8.547, 10.307) 
         else if g2 < 11.721 then
            prob := interpolate(0.80, 0.70, 10.307, 11.721) 
         else if g2 < 14.339 then
            prob := interpolate(0.70, 0.50, 11.721, 14.339) 
         else if g2 < 17.322 then
            prob := interpolate(0.50, 0.30, 14.339, 17.322) 
         else if g2 < 19.311 then
            prob := interpolate(0.30, 0.20 , 17.322, 19.311) 
         else if g2 < 22.3071 then
            prob := interpolate(0.20, 0.1, 19.311, 22.3071) 
         else if g2 <  24.9958 then
            prob := interpolate(0.1000,0.0500, 22.3071, 24.9958)
         else if g2 <  27.4884 then
            prob := interpolate(0.0500,0.0250, 24.9958, 27.4884)
         else if g2 <  30.5779 then
            prob := interpolate(0.0250,0.0100, 27.4884, 30.5779)
         else if g2 <  32.8013 then
            prob := interpolate(0.0100,0.0050, 30.5779, 32.8013)
         else if g2 <  37.6973 then
            prob := interpolate(0.0050,0.0010, 32.8013, 37.6973)
         else if g2 <  39.7188 then
            prob := interpolate(0.0010,0.0005, 37.6973, 39.7188)
         else if g2 <  44.2632 then
            prob := interpolate(0.0005,0.0001, 39.7188, 44.2632)
         else prob := 0.0;
      end
   else if df = 16 then
      begin
         if g2 <   2.7739 then prob := 0.9999
         else if g2 <   3.5358 then
            prob := interpolate(0.9999,0.9995,  2.7739,  3.5358)
         else if g2 <   3.9416 then
            prob := interpolate(0.9995,0.9990,  3.5358,  3.9416)
         else if g2 <   5.1422 then
            prob := interpolate(0.9990,0.9950,  3.9416,  5.1422)
         else if g2 <   5.8122 then
            prob := interpolate(0.9950,0.9900,  5.1422,  5.8122)
         else if g2 <   6.9077 then
            prob := interpolate(0.9900,0.9750,  5.8122,  6.9077)
         else if g2 <   7.9616 then
            prob := interpolate(0.9750,0.9500,  6.9077,  7.9616)
         else if g2 <   9.3122 then
            prob := interpolate(0.9500,0.9000,  7.9616,  9.3122)
         else if g2 < 11.152 then
            prob := interpolate(0.90, 0.80, 9.312, 11.152) 
         else if g2 < 12.624 then
            prob := interpolate(0.80, 0.70, 11.152, 12.624) 
         else if g2 < 15.338 then
            prob := interpolate(0.70, 0.50, 12.624, 15.338) 
         else if g2 < 18.418 then
            prob := interpolate(0.50, 0.30, 15.338, 18.418) 
         else if g2 < 20.465 then
            prob := interpolate(0.30, 0.20 , 18.418, 20.465) 
         else if g2 < 23.5418 then
            prob := interpolate(0.20, 0.1, 20.465, 23.5418) 
         else if g2 <  26.2962 then
            prob := interpolate(0.1000,0.0500, 23.5418, 26.2962)
         else if g2 <  28.8454 then
            prob := interpolate(0.0500,0.0250, 26.2962, 28.8454)
         else if g2 <  31.9999 then
            prob := interpolate(0.0250,0.0100, 28.8454, 31.9999)
         else if g2 <  34.2672 then
            prob := interpolate(0.0100,0.0050, 31.9999, 34.2672)
         else if g2 <  39.2524 then
            prob := interpolate(0.0050,0.0010, 34.2672, 39.2524)
         else if g2 <  41.3081 then
            prob := interpolate(0.0010,0.0005, 39.2524, 41.3081)
         else if g2 <  45.9249 then
            prob := interpolate(0.0005,0.0001, 41.3081, 45.9249)
         else prob := 0.0;
      end
   else if df = 17 then
      begin
         if g2 <   3.1567 then prob := 0.9999
         else if g2 <   3.9802 then
            prob := interpolate(0.9999,0.9995,  3.1567,  3.9802)
         else if g2 <   4.4161 then
            prob := interpolate(0.9995,0.9990,  3.9802,  4.4161)
         else if g2 <   5.6972 then
            prob := interpolate(0.9990,0.9950,  4.4161,  5.6972)
         else if g2 <   6.4078 then
            prob := interpolate(0.9950,0.9900,  5.6972,  6.4078)
         else if g2 <   7.5642 then
            prob := interpolate(0.9900,0.9750,  6.4078,  7.5642)
         else if g2 <   8.6718 then
            prob := interpolate(0.9750,0.9500,  7.5642,  8.6718)
         else if g2 <  10.0852 then
            prob := interpolate(0.9500,0.9000,  8.6718, 10.0852)
         else if g2 < 12.002 then
            prob := interpolate(0.90, 0.80, 10.085, 12.002) 
         else if g2 < 13.531 then
            prob := interpolate(0.80, 0.70, 12.002, 13.531) 
         else if g2 < 16.338 then
            prob := interpolate(0.70, 0.50, 13.531, 16.338) 
         else if g2 < 19.511 then
            prob := interpolate(0.50, 0.30, 16.338, 19.511) 
         else if g2 < 21.615 then
            prob := interpolate(0.30, 0.20 , 19.511, 21.615) 
         else if g2 < 24.769 then
            prob := interpolate(0.20, 0.1, 21.615, 24.769) 
         else if g2 <  27.5871 then
            prob := interpolate(0.1000,0.0500, 24.7690, 27.5871)
         else if g2 <  30.1910 then
            prob := interpolate(0.0500,0.0250, 27.5871, 30.1910)
         else if g2 <  33.4087 then
            prob := interpolate(0.0250,0.0100, 30.1910, 33.4087)
         else if g2 <  35.7185 then
            prob := interpolate(0.0100,0.0050, 33.4087, 35.7185)
         else if g2 <  40.7902 then
            prob := interpolate(0.0050,0.0010, 35.7185, 40.7902)
         else if g2 <  42.8792 then
            prob := interpolate(0.0010,0.0005, 40.7902, 42.8792)
         else if g2 <  47.5664 then
            prob := interpolate(0.0005,0.0001, 42.8792, 47.5664)
         else prob := 0.0;
      end
   else if df = 18 then
      begin
         if g2 <   3.5552 then prob := 0.9999
         else if g2 <   4.4394 then
            prob := interpolate(0.9999,0.9995,  3.5552,  4.4394)
         else if g2 <   4.9048 then
            prob := interpolate(0.9995,0.9990,  4.4394,  4.9048)
         else if g2 <   6.2648 then
            prob := interpolate(0.9990,0.9950,  4.9048,  6.2648)
         else if g2 <   7.0149 then
            prob := interpolate(0.9950,0.9900,  6.2648,  7.0149)
         else if g2 <   8.2307 then
            prob := interpolate(0.9900,0.9750,  7.0149,  8.2307)
         else if g2 <   9.3905 then
            prob := interpolate(0.9750,0.9500,  8.2307,  9.3905)
         else if g2 <  10.8649 then
            prob := interpolate(0.9500,0.9000,  9.3905, 10.8649)
         else if g2 < 12.857 then
            prob := interpolate(0.90, 0.80, 10.865, 12.857) 
         else if g2 < 14.440 then
            prob := interpolate(0.80, 0.70, 12.857, 14.440) 
         else if g2 < 17.338 then
            prob := interpolate(0.70, 0.50, 14.440, 17.338) 
         else if g2 < 20.601 then
            prob := interpolate(0.50, 0.30, 17.338, 20.601) 
         else if g2 < 22.760 then
            prob := interpolate(0.30, 0.20 , 20.601, 22.760) 
         else if g2 < 25.9894 then
            prob := interpolate(0.20, 0.1, 22.760, 25.9894) 
         else if g2 <  28.8693 then
            prob := interpolate(0.1000,0.0500, 25.9894, 28.8693)
         else if g2 <  31.5264 then
            prob := interpolate(0.0500,0.0250, 28.8693, 31.5264)
         else if g2 <  34.8053 then
            prob := interpolate(0.0250,0.0100, 31.5264, 34.8053)
         else if g2 <  37.1565 then
            prob := interpolate(0.0100,0.0050, 34.8053, 37.1565)
         else if g2 <  42.3124 then
            prob := interpolate(0.0050,0.0010, 37.1565, 42.3124)
         else if g2 <  44.4338 then
            prob := interpolate(0.0010,0.0005, 42.3124, 44.4338)
         else if g2 <  49.1894 then
            prob := interpolate(0.0005,0.0001, 44.4338, 49.1894)
         else prob := 0.0;
      end;
   chisquare := prob > signif;
  end;
end;


      
function getchisquare(var g2,prob: real; var varpair: partialpair; 
                      var conditions: partialedonarray;
                      var numzexp,numzpar: integer): boolean;
var df: real; i: integer;
begin
  df := (maxval[varpair[1]] - 1) * (maxval[varpair[2]] - 1);
  for i := 1 to conditions.length do
     df := df * maxval[conditions.arr[i]];
  df := df - numzexp + numzpar;
  getchisquare := chisquare(g2,df,signif,prob);
end;


procedure setupindices(varpair: partialpair; var conditions: partialedonarray);
var i: integer;
begin
  indices[1] := maxval[varpair[1]] * maxval[varpair[2]];
  for i := 2 to conditions.length+1 do indices[i] := 
     indices[i-1] * maxval[conditions.arr[i-1]];
end;


procedure initcells(varpair: partialpair; var conditions: partialedonarray);
var i: integer;
begin
  for i := 1 to indices[conditions.length+1] do cells^[i] := 0;
end;

procedure fillincells(varpair: partialpair; var conditions: partialedonarray);
var i,j,loc: integer;
begin
   for i := 1 to round(sampsize) do
     begin
	if (samparray[i]=train) or (samparray[i]=trainest) then
	begin
       loc := 1;
       for j := 1 to conditions.length do
          loc := loc + (getbigdata(i,conditions.arr[j]) - 1) * indices[j];
       loc := loc + maxval[varpair[1]] * (getbigdata(i,varpair[2]) - 1) + 
              (getbigdata(i,varpair[1]) - 1);
       cells^[loc] := cells^[loc] + 1;
	end;
     end;
end;

function calcg2(var varpair: partialpair; var conditions: partialedonarray;
                var numzexp,numzpar: integer):real;
var i,j,total,offset,inloop,loc: integer; g2,observed,expected: real;
    acells,bcells: array[0..numval] of longint; 
begin
  offset := 0;
  g2 := 0;  
  numzexp := 0;
  numzpar := 0;
  repeat
     total := 0;
     inloop := 0;
     for i := 0 to maxval[varpair[2]] - 1 do
       for j := 0 to maxval[varpair[1]] - 1 do
         begin
           inloop := inloop + 1;
           loc := inloop + offset;
           if j = 0 then acells[i] := 0;
           if i = 0 then bcells[j] := 0;
           acells[i] := acells[i] + cells^[loc];
           bcells[j] := bcells[j] + cells^[loc];
           total := total + cells^[loc];
         end;
     inloop := 0;
     for i := 0 to maxval[varpair[2]] - 1 do
       for j := 0 to maxval[varpair[1]] - 1 do
         begin
           inloop := inloop + 1;
           observed := cells^[inloop + offset];
           if total = 0 then expected := 0
           else expected := (acells[i] * bcells[j])/total;                 
	   if expected <0 then 
	   begin
	   write('got to:exp:',expected:5:3,'  obs:',observed:5:3,' acell:',acells[i]);
	   writeln(' bcells:', bcells[j] ,' total:' , total);
	   end;
           if expected = 0 then numzexp := numzexp + 1
           else if observed <> 0 then
              g2 := g2 + observed * ln(observed/expected);
         end;
     offset := offset + maxval[varpair[1]] * maxval[varpair[2]];
  until offset >= indices[conditions.length+1];
  calcg2 := 2 * g2;
end;

function calcindependence(*varpair: partialpair; var prob,g2: real;
                          var conditions: partialedonarray)
                          var numchecked: integer):  boolean; *);
var oldvertices: vertexset; i: vertextype; locscore1,locscore2: real;
begin
   oldvertices := graphvertices;
   graphvertices := [varpair[1],varpair[2]];
   causes[varpair[2]] := [];
   for i := 1 to conditions.length do 
       begin
         graphvertices := graphvertices + [conditions.arr[i]];
         adjacency^[conditions.arr[i],varpair[2]] := 0;
       end;
   adjacency^[varpair[1],varpair[2]] := notthere;
   getmodscore(lambda,prob,varpair[2]);
   adjacency^[varpair[1],varpair[2]] := 0;
   causes[varpair[2]] := causes[varpair[2]] + [varpair[1]];
   getmodscore(lambda,g2,varpair[2]);
   calcindependence := prob - g2 > 100 * signif;
   graphvertices := oldvertices;
   for i := 1 to conditions.length do 
         adjacency^[conditions.arr[i],varpair[2]] := notthere;
   adjacency^[varpair[1],varpair[2]] := notthere;
end;

function calcindep1(* varpair: partialpair; var prob,g2: real;
                          var conditions: partialedonarray): boolean;
                          var numchecked: integer*);
var numzexp,numzpar,i: integer; 
begin
   if ((numchecked mod 100000) = 0) then
      begin
          checktime;
          numchecked := 1;
      end
   else numchecked := numchecked + 1;
   prob := 0.0;
   g2 := 0.0;
   setupindices(varpair,conditions);
   if indices[conditions.length+1] > arraylength then calcindep1 := false
   else if ((trainhigh - trainlow) / indices[conditions.length+1]) < 5 then
      begin
        calcindep1 := false;
(*        for i := 1 to conditions.length do 
            write(ofilvar,vernames[conditions.arr[i]],' '); 
        writeln(ofilvar); *)
      end
   else
      begin
         initcells(varpair,conditions);
         fillincells(varpair,conditions);
         g2 := calcg2(varpair,conditions,numzexp,numzpar);
         calcindep1 :=  getchisquare(g2,prob,varpair,conditions,numzexp,numzpar);
      end;
end;

(*-----------#pc-version-----------------------------------------------------*)
(*end.*)
(*-----------#pc-version-----------------------------------------------------*)